<%@ Page Language="C#" %>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="filter">		
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />		
		<span><%= CommonLabels.Email %>:</span>
		<input id="email" class="ps-filter-textsearch textboxMiddle" type="text" />

		<span><%= CommonLabels.MaximumResults %></span>
		<select id="maxResults" class="styled smallwidth">
            <option value="0"></option>
            <option value="10" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "10") %>>10</option>
			<option value="50" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "50") %>>50</option>
			<option value="100" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "100") %>>100</option>
			<option value="200" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "200") %>>200</option>
			<option value="500" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "500") %>>500</option>
			<option value="1000" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "1000") %>>1000</option>
	    </select>
	
		<a class="ps-filter-showadvancedview" href="">
			<%= CommonLabels.AdvancedView %>
		</a>
		<div class="ps-filter-advancedview" style="display: none">
			<table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
				<colgroup>
					<col class="psColon1">
					<col>
					<col class="psColMid">
					<col class="psColon3">
					<col>
    			</colgroup>
				<tbody>
				<tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%= CommonLabels.AdvancedView %></span>
					</td>
				</tr>
				<tr>
					<td class="psFormCell"><%= CommonLabels.Member %></td>
					<td class="psFormCell">
						<div id="contactLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="contactLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show" ></button>
								    </td>
							    </tr>
						    </table>
						    <div  class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
                        </div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%= CommonLabels.Role %></span></td>
					<td class="psFormCell">
						<div id="roleLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="roleLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show" ></button>
								    </td>
							    </tr>
						    </table>

						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
				</tr>
				</tbody>
			</table>
		</div>
	</div>
    <div class="desktopTable">
        <div class="desktopTableActions">
			<%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>

    <polar:Footer runat="server" />
    <polar:Includes runat="server" />

	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function

		YAHOO.util.Event.onDOMReady( function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

	    POLAR.View.Page = function() {
			POLAR.View.setTitleAndResourceName(resource.LabelsCommon.AccountTemplates);
			autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
	    		id: 'contactLookup',
	    		url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
	    		urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
	    		linkID: "contactLink",
	    		propertyName: "Contact",
	    		resourceHolder: resource,
	    		autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
	    		lookupPanelData: {
	    			fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'UserName', 'FirstName', 'LastName', 'Email', 'URL'],
	    			columnDefinitions: [
											{ key: 'Add', formatter: 'customContact' },
											{ key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
											{ key: 'UserName', label: 'Username', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
											{ key: 'FirstName', label: 'UserFirstName', sortable: true, resizeable: true },
											{ key: 'LastName', label: 'UserLastName', sortable: true, resizeable: true },
											{ key: 'Email', label: 'Email', sortable: true, resizeable: true }
										]
	    		}
			});

			autoCompleteLookupRole = new POLAR.Widget.AutoCompleteLookup({
	    		id: 'roleLookup',
	    		url: '<%= UrlHelper.GetUrl("/api/roles") %>',
	    		urlItem: '<%= UrlHelper.GetUrl("/api/role/") %>',
	    		linkID: "roleLink",
	    		propertyName: "Role",
	    		resourceHolder: resource,
	    		autoCompleteData: { schema: ['Name', 'ID'], query: '?maxresults=60&textsearch={0}*' },
	    		lookupPanelData: {
	    			fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'URL'],
	    			columnDefinitions: [
									{ key: 'Add', formatter: 'customContact' },
									{ key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
									{ key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl }
								]
	    		}
			});

			POLAR.View.Page.initializeGrid();

            var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
                args: [
                    { id: 'maxResults', urlValueName: 'maxresults', type: 'select' },
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },
		            { id: 'email', urlValueName: 'email', type: 'textbox' },		            
                    { urlValueName: 'member' },
                    { urlValueName: 'role' }
                ],
                onGetArguments: function(args) {
					if (!YAHOO.lang.isUndefined(resource.Contact) && !YAHOO.lang.isNull(resource.Contact)) {
                		args['member'] = resource.Contact.ID;
					}
					if (!YAHOO.lang.isUndefined(resource.Role) && !YAHOO.lang.isNull(resource.Role)) {
                		args['role'] = resource.Role.ID;
					}
                },
                onSetArguments: function(args) {
					var contactID = args['member'];
					if (!YAHOO.lang.isUndefined(contactID) && !YAHOO.lang.isNull(contactID)) {
                		autoCompleteLookupContact._changeOnLinkedControl(contactID);
					}
					var roleID = args['role'];
					if (!YAHOO.lang.isUndefined(roleID) && !YAHOO.lang.isNull(roleID)) {
                		autoCompleteLookupRole._changeOnLinkedControl(roleID);
					}
                }
            });
        }

        POLAR.View.Page.initializeGrid = function() {
			var dataSource = POLAR.View.DataTable.createDataSource(resource);
        
            dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
            dataSource.responseSchema = {
                resultsList: 'Items',
                fields: [{ key: '<%= AccountTemplateResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber }, '<%= AccountTemplateResource.Meta.Name.Name %>', '<%= AccountTemplateResource.Meta.Division.Name %>', '<%= AccountTemplateResource.Meta.URL.Name %>']
            };

            dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: '<%= AccountTemplateResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: '<%= AccountTemplateResource.Meta.Name.Name %>', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				{ key: '<%= AccountTemplateResource.Meta.Division.Name %>', label: '<%= BusinessUnitLabels.Division %>', sortable: true, resizeable: true }
			], dataSource, {
				sortedBy: { key: '<%= AccountTemplateResource.Meta.Name.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
			    draggableColumns: true,
			    paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

			POLAR.View.DataTable.configDataTable(dataTable);

			POLAR.View.DataTable.configDeleteUndelete({
				dataTable: dataTable,
				dataTableItems: resource.Items,
				dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
				dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
			});

			////POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
		    //set with on first and second colon for beter visula efect
		    $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
		};
	</script>
	<script runat="server">
        string _jsonResRep;

	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>