<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>

<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div class="desktopTable">
        <div class="desktopTableActions">
			<%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>
    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep %>;
    </script>
    <polar:Includes runat="server" />
	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
		//YAHOO.util.Event.onDOMReady( function() {
	    $(document).ready(function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ActiveDirectoryImportSchemas);
		    var dataSource = POLAR.View.DataTable.createDataSource(resource);
			dataSource.responseSchema = {
			    resultsList: 'Items',
			    fields: [{ key: '<%= ActiveDirectoryImportSchemaResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber }, '<%= ActiveDirectoryImportSchemaResource.Meta.Name.Name %>', '<%= ActiveDirectoryImportSchemaResource.Meta.Enabled.Name %>', '<%= ActiveDirectoryImportSchemaResource.Meta.URL.Name %>', { key: '<%= ActiveDirectoryImportSchemaResource.Meta.ModifiedOn.Name %>', parser: POLAR.View.DateTime.stringToDate}]
			};

			dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: '<%= ActiveDirectoryImportSchemaResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: '<%= ActiveDirectoryImportSchemaResource.Meta.Name.Name %>', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				{ key: '<%= ActiveDirectoryImportSchemaResource.Meta.Enabled.Name %>', label: '<%= CommonLabels.Enabled %>', sortable: true, resizeable: true },
				{ key: '<%= ActiveDirectoryImportSchemaResource.Meta.ModifiedOn.Name %>', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			], dataSource, {
				sortedBy: { key: '<%= ActiveDirectoryImportSchemaResource.Meta.ModifiedOn.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
				draggableColumns: true,
				paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

			POLAR.View.DataTable.configDataTable(dataTable);
			POLAR.View.DataTable.configDeleteUndelete({
			    dataTable: dataTable,
			    dataTableItems: resource.Items,
			    dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
			    dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
			});
			////POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
			//set with on first and second colon for beter visula efect
			$("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
		};

	</script>

	<script runat="server">
        string _jsonResRep;
	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();
            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>