<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= ContactLabels.ContactsTitle %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="filter">
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />				
		<span><%= CommonLabels.MaximumResults %></span>
		<select id="maxResults" class="filterSelect styled middlewidth">
            <option value="0"></option>
            <option value="10" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "10") %>>10</option>
			<option value="50" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "50") %>>50</option>
			<option value="100" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "100") %>>100</option>
			<option value="200" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "200") %>>200</option>
			<option value="500" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "500") %>>500</option>
			<option value="1000" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "1000") %>>1000</option>
	    </select>	        
	   	    <a class="ps-filter-showadvancedview" href="">
			<%= CommonLabels.AdvancedView %>
		</a>
		<div class="ps-filter-advancedview" style="display: none">			
			<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
				<colgroup>
					<col class="psColon1">
					<col>
					<col class="psColMid">
					<col class="psColon3">
					<col>
    			</colgroup>
				<tbody>
				<tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%= CommonLabels.AdvancedView %></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell"><%= UserLabels.Email %></td>
					<td class="psFormCell">
						<input id="email" type="text" class="psTextbox"/>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%= CommonLabels.Account %></span></td>
					<td class="psFormCell">
					    <div id="accountLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="accountLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show"> </button>
								    </td>
							    </tr>
						    </table>

						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
				</tr>
				
				<tr>
					<td class="psFormCell"><%= CommonLabels.Category%></td>
					<td class="psFormCell">
					<select id="Category.ID" class="styled middlewidth">
							<option value=""></option>
							<%
                                foreach (Category item in _categoryRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>	   						
						 
					</td>										
					<td class="psFormMid"></td>
					<td class="psFormCell"></td>
					<td class="psFormCell"></td>
				</tr>			
				</tbody>
			</table>
		</div>
	</div>
    <div class="desktopTable">
        <div class="desktopTableActions">
            <%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
			<input id="buttonExport" type="button" value="<%= CommonLabels.Export %>" />
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>;
    </script>
     <polar:Includes runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function		
		YAHOO.util.Event.onDOMReady( function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Contacts);
		    autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
		        id: 'accountLookup',
		        url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
		        linkID: "accountLink",
		        propertyName: "Account",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['Name', 'City', 'PostalCode', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL'],
		            columnDefinitions: [
                                        { key: 'Add', formatter: 'customContact' },
	                                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                        { key: 'City', label: 'City', sortable: true, resizeable: true },
                                        { key: 'PostalCode', label: 'PostalCode', sortable: true, resizeable: true },
                                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                                    ]
		        }
		    });

            POLAR.View.Page.initializeGrid();

            var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
                args: [
                    { id: 'maxResults', urlValueName: 'maxresults', type: 'select' },
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },
                    { id: 'email', urlValueName: 'email', type: 'textbox' },
		            { urlValueName: 'category' },
                    { urlValueName: 'account' }
                ],
                onGetArguments: function(args) {
                    if (!YAHOO.lang.isUndefined(resource.Account) && !YAHOO.lang.isNull(resource.Account)) {
                        args['account'] = resource.Account.ID;
                    }
                    var valCategory = $(POLAR.Util.jqIdFormat("Category.ID")).selectedOptions();
                    if (valCategory[0].value != 0) {
                        args['category'] = valCategory[0].value;
                    }
                },
                onSetArguments: function(args) {
                    var accountID = args['account'];
                    if (!YAHOO.lang.isUndefined(accountID) && !YAHOO.lang.isNull(accountID)) {
                        autoCompleteLookupAccount._changeOnLinkedControl(accountID);
                    }
                    var categoryID = args['category'];
                    $(POLAR.Util.jqIdFormat("Category.ID")).selectOptions("" + categoryID);
                }
            });
        }
        
        POLAR.View.Page.initializeGrid = function() {
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
    		dataSource.responseSchema = {
    			resultsList: "Items",
    			fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber },
    			    'Name',
    			    'Email',
    			    'URL',
    			    { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate }
    			    ]
    		};

    		dataTable = new YAHOO.widget.DataTable("dataTableContainer", [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true },
	            { key: 'Name', label: '<%= CommonLabels.Username %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
	            { key: 'Email', label: '<%= UserLabels.Email %>', sortable: true, resizeable: true },
	            { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
	        ], dataSource, {
	            sortedBy: { key: 'ModifiedOn', dir: YAHOO.widget.DataTable.CLASS_DESC },
	        	draggableColumns: true,
	        	paginator: POLAR.View.DataTable.createDefaultPaginator()
	        });

    		POLAR.View.DataTable.configDataTable(dataTable);

    		POLAR.View.DataTable.configDeleteUndelete({
    			dataTable: dataTable,
    			dataTableItems: resource.Items,
    			dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
    			dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
    		});

    		//POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
    		//set with on first and second colon for beter visula efect
    		$("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');

		};
    </script>

    <script runat="server">
        string _jsonResRep;
        public readonly CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        protected void Page_Load(object sender, EventArgs e)
        {   
            PageHelper.RedirectToInstallationIfNoDatabaseFound();
            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>
