<%@ Import Namespace="Polar.ServiceDesk.HelpDesk.Documents"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>
<%@ Import namespace="Polar.ServiceDesk.Infrastructure.Net"%>
<%@ Control Language="C#" %>
<%@ Import Namespace="Polar.ServiceDesk.Infrastructure.Localization"%>
<div id="doc3" class="yui-t2">
    <div id="hd" class="psHeader">
        <span style="color:#d1d1d1; font-size:110%; font-weight:bold; position:absolute"> 
            <%
            if (TrialVersion)
            {
                %> &nbsp; Trial Version - 30 Day Free Trial<%
            }

            if (TrialVersionExpired)
            {   
                %> - <% =CommonValidationLabels.YourTrialVersionHasExpired.ToString()%><%
            }    
            %>
        </span>
        <div style="text-align:right" class="psProfile">
           <span id="myProfile"></span> | <a href="http://help.polarsoftware.com/phd/"><%= CommonLabels.Help %></a> | <span id="idLogout"></span>
        </div>                        
        <div id="topNavigation2" ></div>      
    </div>
    <div id="bd"><!-- body -->
        <div class="yui-b leftsidebar"> 
            <button id="menutoggle" type="button"><%= CommonLabels.CreateNew %></button>
            <br />
            <br />
            <span class="recentList" ><%= CommonLabels.Recent %>:</span>
            <div id="IdUserPreference"></div>
            <!-- Left Columns 	-->
            <div class="yui-b sidebarlefttop"> </div>          
	    </div>
        <div id="yui-main"><!-- main desktop content -->
            <div class="yui-b midletop"> </div>
            <div id='idmidle2' class="yui-b midle">
                <table border="0" cellpadding="0" cellspacing="0" width="100%" class="resourceHeader" >
                    <tbody>
                        <tr >                           
                            <td class="headermessage" >
                                <span id='idResourceName' class="resourceName"></span>
                            </td>                            
                            <td class="headermessage">
                                <span id="messagebox"></span>
                            </td>
                            <td class="headermessage">
                                <div id='messageBoxDialog' title=''></div>                                
                                <span id="openMessageDialog"></span>
                            </td>
                        </tr>
                </tbody>
                </table>    
    
<script runat="server">
	public bool TrialVersionExpired = false;
	public bool TrialVersion = false;
	
    protected void Page_Load(object sender, EventArgs e)
    {
		TrialVersionExpired = PageHelper.TrialPeriodExpired();

		foreach (License license in IoC.Container.Resolve<LicenseRepository>().GetAllOrDefault())
		{
			if (license.Data.TrialVersion)
			{
				TrialVersion = true;
			}
		}
    }
</script>
    