﻿<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.Infrastructure.ResourceHandlers"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
	<title><%= AdminEmailLabels.Title%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <%if (HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <%}%> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
	    <tr>
		        <td style="text-align:left">
                    <div id="controlsBar">
                        <%if (0 == resource.IncidentID.Value && !resource.Deleted.Value)
                        {
                            %><input id="buttonCreateIncident" type="button" value="<%=AdminEmailLabels.CreateIncident%>" />
                            <input id="buttonCreateIncidentAndOpen" type="button" value="<%=AdminEmailLabels.CreateIncidentAndOpen%>" /><%
                        }
                        if (resource.Deleted.Value)
                        {
                            %><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
                        }
                        else {
                            %><input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" /><%
                        }%>
                    </div>
                </td>
	        <td style="text-align:right" >
	            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= EmailResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
	        </td>
		<tr>
		<tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
			<tr <%if (0 != resource.IncidentID.Value) { %>style="display: none"<% } %>>
                <td class="psFormCell"><span><%= CommonLabels.IncidentTemplate %></span></td>
                <td class="psFormCell">
					<select id="IncidentTemplateID" class="styled"> 
						<option value="0"></option>
						<%
							foreach (IncidentTemplate item in PageHelper.GetIncidentTemplatesForLoggedInUser())
							{
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(item.ID == resource.IncidentTemplateID.Value) %>><%= item.Name%></option><%
							}
						%>
					</select>
                </td>
                <td class="psFormMid" />
                <td class="psFormCell"></span></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
        		    <span><%=CommonLabels.Incident %> </span>
		        </td>
                <td class="psFormCell">
		        	<a id="incidentLink" href=<%= (inc != null) ? inc.URL.Value : string.Empty %>><%= (inc != null) ? inc.Title.Value : string.Empty %></a>
		        </td>
		    </tr>
		    <tr>
		        <td class="psFormCell">
                    <span><%=CommonLabels.Contact %></span>
		        </td>
		        <td class="psFormCell">
		            <a id="contactLink" href=<%= (inc != null) ? inc.Contact.Value.URL.Value : string.Empty %> > <%= (inc != null) ? inc.Contact.Value.UserName.Value : string.Empty%></a>
		        </td>
		    </tr>
		    <tr>
                <td class="psFormCell psBar" colspan="5">
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><span><%=AdminEmailLabels.Subject %></span></td>
                <td class="psFormCell"><input class="psTextbox"  type="text" value="<%=resource.Subject%>" readonly="readonly" /></td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=AdminEmailLabels.FromName %></span></td>
                <td class="psFormCell"><input class="psTextbox"  type="text" value="<%=resource.FromName%>" readonly="readonly" /></td>
                <td class="psFormMid" />
                <td class="psFormCell"><span><%=AdminEmailLabels.ReceivedOn%></span></td>
                <td class="psFormCell"><input class="psTextbox"  type="text" value="<%=resource.ReceivedOn%>" readonly="readonly" /></td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=AdminEmailLabels.FromEmail %></span></td>
                <td class="psFormCell"><input class="psTextbox"  type="text" value="<%=resource.FromEmail%>" readonly="readonly" /></td>
                <td class="psFormMid" />
                <td class="psFormCell"><span><%=AdminEmailLabels.SentOn%></span></td>
                <td class="psFormCell"><input class="psTextbox"  type="text" value="<%=resource.SentOn%>" readonly="readonly" /></td>
            </tr>
            <!--<tr>
                <td class="psFormCell"><span><%=AdminEmailLabels.Spam %></span></td>
                <td class="psFormCell"><input id="<%=resource.Spam.Name %>" name="<%= resource.Spam.Name %>" type="checkbox" <%= resource.Spam.Value == 1 ? "checked" : string.Empty %> readonly="readonly" disabled="disabled"/> </td>
            </tr>-->
            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=AdminEmailLabels.RawEmail%></span></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell" colspan="5">
                    <textarea  class="psTextarea expand25-350 resizable" id="<%= resource.RawEmail.Name %>"><%= resource.RawEmail %></textarea>
                </td>
            </tr>
        </tbody>
    </table>

    </div>

    <polar:Footer runat="server" />
	<script type="text/javascript">
		var resource = <%= _jsonResRep %>
	</script>
	<polar:Includes runat="server" />

	<script type="text/javascript">
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		     POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Email);
		    if ($('#buttonCreateIncident').length) {
		        var oCreateButton = new YAHOO.widget.Button("buttonCreateIncident");
		        oCreateButton.on("click", POLAR.View.Page.CreateIncidentFromEmail);
		    }
		    if ($('#buttonCreateIncidentAndOpen').length) {
		        var oCreateButton = new YAHOO.widget.Button("buttonCreateIncidentAndOpen");
		        oCreateButton.on("click", POLAR.View.Page.CreateIncidentFromEmailAndRedirect);
		    }
		}

		POLAR.View.Page.CreateIncidentFromEmail = function() {
		    var url = '<%=UrlHelper.GetUrl("/api/incident/template/")%>' + $("#IncidentTemplateID").val() + '<%= "/email/" + resource.ID.Value %>';
		    POLAR.View.asyncPost(url, "");
		}

		POLAR.View.Page.CreateIncidentFromEmailAndRedirect = function() {
		    var url = '<%=UrlHelper.GetUrl("/api/incident/template/")%>' + $("#IncidentTemplateID").val() + '<%= "/email/" + resource.ID.Value %>';
		    POLAR.View.asyncPost(url, "", function (incident) {
				window.location = incident.URL;
		    });
		}

		POLAR.View.Page.asyncResponse = function(request) {
		    if (request.status == 201) {
		        $('#buttonCreateIncident').remove();
		        $('#buttonCreateIncidentAndOpen').remove();

		        var incident = YAHOO.lang.JSON.parse(request.responseText);
		        $("#controlsBar").append("<span><%=AdminEmailLabels.CreatedIncidentText%> </span>");
		        $("#controlsBar").append("<a id=\"incidentLink\" href=\"" + incident.URL + "\">" + incident.Title + "</a>");
		        $("#controlsBar").show("fast");
		    }
		    POLAR.View.setAsyncResponseMessage(request);
		}

		POLAR.View.Page.asyncResponseRedirect = function(request) {
		    if (request.status == 201) {
		        var incident = YAHOO.lang.JSON.parse(request.responseText);
		        window.location = incident.URL;
		    }
		    POLAR.View.setAsyncResponseMessage(request);
		}

		POLAR.View.Page.requestCallback = {
		    success: POLAR.View.Page.asyncResponse,
		    failure: POLAR.View.Page.asyncResponse,
		    argument: POLAR.View.args
		};

		POLAR.View.Page.requestCallbackAndRedirect = {
		    success: POLAR.View.Page.asyncResponseRedirect,
		    failure: POLAR.View.Page.asyncResponse,
		    argument: POLAR.View.args
		};
	</script>

    <script runat="server">
	    EmailResource resource;
        IdentityContext identityContext = IoC.Container.Resolve<IdentityContext>();
        string _jsonResRep;
        IncidentResourceFragment inc;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as EmailResource;
            inc = resource.IncidentID.Value == 0 ? null : new IncidentResourceFragment(new IncidentByIdResourceURI(resource.IncidentID.Value));
        }
    </script>
</body>
</html>
