<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Newtonsoft.Json.Converters"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.Infrastructure.ResourceHandlers"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
	<title><%= IncidentLabels.IncidentsTitle%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />

    Todo: MyIncidents or MyTeamsIncidents, MyUser, MyAccount
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div id="idUrlInfo"></div>
    <div class="desktopTable">
        <div class="desktopTableActions">
            <%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>;

    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
		YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            if (POLAR.View.HomePageIncidentsWidget() == false) {
                POLAR.View.HomePageIncidentContactsWidget();
            }
		    //POLAR.View.Page();
		});

		//----------------------------------------------------------------------------
		//permissionItem - je elemenata array UserResourcePermissions.UserDefineResorucePermissions
		//uriTemplate - template for which we try find mapping
		//return - je URL if we find some Uri for mapping
		var UriToUriTemplateMappingFinder = function(permissionItem, uriTemplate) {
		    /*var uriTemplateX = uriTemplate[0];
		    uriTemplate.push(permissionItem.URN);*/
		    if (permissionItem.GET == true) {
		        var flagMapping = POLAR.View.GetMappingResult(permissionItem.URN, uriTemplate);
		        if (flagMapping == true) {
		            return UserResourcePermissions.VirtualUrl + "/api/" + permissionItem.URN;
		        }
		    }
		    return 0;
		}
		//---------------------------------------------------------------------------------------------------------------------------
		//filtriramo sve one IDove od timova koji se mapiraju na posalti URI tempalte.
		//result - je array u koji slazemo konacni niz teamova
		//permissionItem - je elemenata iz liste UserResourcePermissions.UserDefineResorucePermissions
		function UriToUriTemplateMappingReducer(result, permissionItem, uriTemplate) {
		    if (permissionItem.GET == true) {
		        var flagMapping = POLAR.View.GetMappingResult(permissionItem.URN, uriTemplate);
		        if (flagMapping == true) {// /2 - /4 - /5;6 -> 2;4;5;6 String.lastIndexOf( )
		            var position = permissionItem.URN.lastIndexOf("/");
		            if (position != -1) {
		                if (result.length == 0) {
		                    result = result + permissionItem.URN.substring(position + 1);
		                }
		                else {
		                    result = result + ";" + permissionItem.URN.substring(position + 1);
		                }
		            }
		        }
		    }
		    return result;
		}
		//---------------------------------------------------------------------------------------------------------------------------
		POLAR.View.HomePageIncidentsWidget = function() {
		    //Chose on which URI current user have permission and therefor show on home desktop in widget
		    //var parameters = ["incidents"];
		    var url = "";
		    var flag = POLAR.Util.Find(POLAR.Util.GetPermissioneForUrnFinder, UserResourcePermissions.ResorucePermissions, "incidents");
		    if ( flag != true) {
		        //trebamo suziti listu na samo one koji se mapiraju na URI Template.
		        var result = POLAR.Util.ReduceExt(UriToUriTemplateMappingReducer, UserResourcePermissions.UserDefineResorucePermissions, "", "incidents/team/{TeamID}");
		        //treba vidjeti je li iz UserResourcePermissions.UserDefineResorucePermissions ima neki URI koji se machira na URI Template "incidents/team/{TeamID}"
		        //url = POLAR.Util.Find(UriToUriTemplateMappingFinder, UserResourcePermissions.UserDefineResorucePermissions, "incidents/team/{TeamID}");
		        if (result.length == 0) {
		            return false;
		        }
		        url = UserResourcePermissions.VirtualUrl + "/api/" + "incidents/team/" + result;
		        url = url + "?user=" + UserResourcePermissions.MyID + "&maxresults=100"; //show all incidents which assigned to current user (supporter)
		    }
		    else {
		        url = UserResourcePermissions.VirtualUrl + "/api/incidents" ;
		        url = url + "?user=" + UserResourcePermissions.MyID + "&maxresults=100"; //show all incidents which assigned to current user (supporter)
		    }

		    $("#idUrlInfo").append("My Incidents from all my Teams: " +  "<a href=" + url + ">" + url + "</a>"  );
		    var dataSource = new YAHOO.util.DataSource(url);

		    dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
		    dataSource.responseSchema = {
		        resultsList: 'Items',
		        fields: [
					    { key: '<%= IncidentResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber },
					    '<%= IncidentResource.Meta.Title.Name %>', '<%= IncidentResource.Meta.URL.Name %>', 'Contact.Name', 'Contact.URL', 'User.Name', 'User.URL', 'Status.Name', 'Priority.Name',
					    { key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', parser: POLAR.View.DateTime.stringToDate }
				    ]
		    };

		    var formatServiceUser = function(elCell, oRecord, oColumn, sData) {
		        if (sData == null) return;
		        elCell.innerHTML = '<a href=' + oRecord.getData('Contact.URL') + '>' + sData + '</a>';
		    };

		    var formatAssignee = function(elCell, oRecord, oColumn, sData) {
		        if (sData == null) return;
		        elCell.innerHTML = '<a href=' + oRecord.getData('User.URL') + '>' + sData + '</a>';
		    };

		    dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				    { label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				    { key: '<%= IncidentResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true },
				    { key: '<%= IncidentResource.Meta.Title.Name %>', label: '<%= CommonLabels.Title %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				    { key: 'Contact.Name', label: '<%= IncidentLabels.Contact %>', sortable: true, resizeable: true, formatter: formatServiceUser },
				    { key: 'User.Name', label: '<%= IncidentLabels.User %>', sortable: true, resizeable: true, formatter: formatAssignee },
				    { key: 'Status.Name', label: '<%= IncidentLabels.IncidentStatus %>', sortable: true, resizeable: true },
				    { key: 'Priority.Name', label: '<%= IncidentLabels.IncidentPriority %>', sortable: true, resizeable: true },
				    { key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			    ], dataSource, {
				    sortedBy: { key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
			        draggableColumns: true,
			        paginator: POLAR.View.DataTable.createDefaultPaginator()
			    });

		    POLAR.View.DataTable.configDataTable(dataTable);

		    POLAR.View.DataTable.configDeleteUndelete({
		        dataTable: dataTable,
		        dataTableItems: resource.Items,
		        dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
		        dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
		    });

		    //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
		    //set with on first and second colon for beter visula efect
		    $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
		    return true;
		};
		//---------------------------------------------------------------------------------------------------------------------------
		POLAR.View.HomePageIncidentContactsWidget = function() {

		    //check is current loged user have permisson for GET HTTP Method  //var uriList= ["incidents" , "incidents"];
		    //Chose on which URI current user have permission and therefor show on home desktop in widget
		    //var url = POLAR.Util.Find(POLAR.Util.GetPermissioneForUrnFinder, UserResourcePermissions.ResorucePermissions, "incidents");

		    var url = "";
		    var flag = POLAR.Util.Find(POLAR.Util.GetPermissioneForUrnFinder, UserResourcePermissions.ResorucePermissions, "incidentcontacts");
		    if (flag != true) {
		        flag = POLAR.Util.Find(POLAR.Util.GetPermissioneForUrnFinder, UserResourcePermissions.ResoruceTemplatePermissions, "incidentcontacts/contact/iperson/{MyID}");
		        if (flag != true) {
		            return false;
		        }
		        url = UserResourcePermissions.VirtualUrl + "/api/incidentcontacts/contact/iperson/" + UserResourcePermissions.MyID;
		        url = url + "?maxresults=100"; //show all incidents which created or reported by current contact user
		    }
		    else {
		        url = UserResourcePermissions.VirtualUrl + "/api/incidents";
		        url = url + "?contact=" + UserResourcePermissions.MyID;//show all incidents which created or reported by current contact user
		        //url = url + "?assignee=" + UserResourcePermissions.MyID;//show all incidents which assigned to current user (supporter)
		    }

		    //$("#idUrlInfo").append(url);
		    $("#idUrlInfo").append("<a href=" + url + ">" + url + "</a>");
		    var dataSource = new YAHOO.util.DataSource(url);

		    dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
		    dataSource.responseSchema = {
		        resultsList: 'Items',
		        fields: [
					{ key: '<%= IncidentResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber },
					'<%= IncidentResource.Meta.Title.Name %>', '<%= IncidentResource.Meta.URL.Name %>', 'Contact.Name', 'Contact.URL', 'User.Name', 'User.URL', 'Status.Name', 'Priority.Name',
					{ key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', parser: POLAR.View.DateTime.stringToDate }
				]
		    };

		    var formatServiceUser = function(elCell, oRecord, oColumn, sData) {
		        if (sData == null) return;
		        elCell.innerHTML = '<a href=' + oRecord.getData('Contact.URL') + '>' + sData + '</a>';
		    };

		    var formatAssignee = function(elCell, oRecord, oColumn, sData) {
		        if (sData == null) return;
		        elCell.innerHTML = '<a href=' + oRecord.getData('User.URL') + '>' + sData + '</a>';
		    };

		    dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: '<%= IncidentResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true },
				{ key: '<%= IncidentResource.Meta.Title.Name %>', label: '<%= CommonLabels.Title %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				{ key: 'Contact.Name', label: '<%= IncidentLabels.Contact%>', sortable: true, resizeable: true, formatter: formatServiceUser },
				{ key: 'User.Name', label: '<%= IncidentLabels.User %>', sortable: true, resizeable: true, formatter: formatAssignee },
				{ key: 'Status.Name', label: '<%= IncidentLabels.IncidentStatus %>', sortable: true, resizeable: true },
				{ key: 'Priority.Name', label: '<%= IncidentLabels.IncidentPriority %>', sortable: true, resizeable: true },
				{ key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			], dataSource, {
				sortedBy: { key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
			    draggableColumns: true,
			    paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

		    POLAR.View.DataTable.configDataTable(dataTable);

		    POLAR.View.DataTable.configDeleteUndelete({
		        dataTable: dataTable,
		        dataTableItems: resource.Items,
		        dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
		        dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
		    });

		    //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
		    //set with on first and second colon for beter visula efect
		    $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
		    return true;
		};

        //---------------------------------------------------------------------------------------------------------------------------
        POLAR.View.Page = function() {
            return;
        };
    </script>

	<script runat="server">
		HomeResource resource;
		string _jsonResRep;

		protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

			ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
			ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
			_jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
			resource = resourceHandlerResult.EntityResoruceRepresentation as HomeResource;
		}
	</script>

</body>
</html>
