<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" ><head>
    <title><%= IncidentHistoryLabels.IncidentHistoriesTitle %></title>
    <polar:CssIncludes runat="server"/>
</head>

<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="filter">
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />		
				
		<span><%= CommonLabels.MaximumResults %></span>
		<select id="maxResults" class="styled smallwidth">
            <option value="0"></option>
            <option value="10" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "10") %>>10</option>
			<option value="50" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "50") %>>50</option>
			<option value="100" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "100") %>>100</option>
			<option value="200" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "200") %>>200</option>
			<option value="500" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "500") %>>500</option>
			<option value="1000" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "1000") %>>1000</option>
	    </select>    
		<a class="ps-filter-showadvancedview" href="">
			<%= CommonLabels.AdvancedView %>
		</a>
		<div class="ps-filter-advancedview" style="display: none">
			<table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
                <colgroup>
                    <col class="psColon1" />
                    <col />
                    <col class="psColMid" />
                    <col class="psColon3" />
                    <col />
                </colgroup>
                <tbody>
    	        <tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%= CommonLabels.AdvancedView %></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell"><%= IncidentLabels.IncidentStatus %></td>
					<td class="psFormCell">
						<select id="Status.ID" class="styled middlewidth" >
							<option value=""></option>
							<%
                                foreach (Status item in Enum.GetValues(typeof(Status)))
        						{
									%><option value="<%=(long)item%>"><%=StatusLabels.GetLabel(item)%></option><%
        						}
							%>
						</select>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><%= CommonLabels.Category%></td>
					<td class="psFormCell">
						<select id="Category.ID" class="styled middlewidth" >
							<option value=""></option>
							<%
                                foreach (Category item in _incidentCategoryRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>
				</tr>
				<tr>
				<td class="psFormCell"><span><%=IncidentLabels.IncidentPriority%></span></td>
					<td class="psFormCell">
						<select id="Priority.ID" class="styled middlewidth" >
							<option value=""></option>
							<%
        						foreach (Priority item in Enum.GetValues((typeof (Priority))))
        						{
									%><option value="<%=(long)item%>"><%=PriorityLabels.GetLabel(item)%></option><%
        						}
							%>
						</select>
					</td>

					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=IncidentLabels.ClosureClassification%></span>
					</td> <td class="psFormCell">
						<select id="ClosureClassification.ID" class="styled middlewidth" >
							<option value=""></option>
							<%
                                foreach (ClosureClassification item in _incidentClosureClassificationRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>
				</tr>
				<tr>
				    <td class="psFormCell"><span><%=IncidentLabels.User%></span></td>
					<td class="psFormCell">
						 <div id="userLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="userLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show" ></button>
								    </td>
							    </tr>
						    </table>
						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"></span></td>
					<td class="psFormCell">
					</td>
			    </tr>
				<tr>
					<td class="psFormCell"><span><%=IncidentLabels.Contact%></span></td>
					<td class="psFormCell">
						<div id="contactLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="contactLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show" ></button>
								    </td>
							    </tr>
						    </table>
						    <div  class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
                        </div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=IncidentLabels.Origin%></span>
					</td> <td class="psFormCell">
						<select id="Origin.ID" class="styled middlewidth" >
							<option value=""></option>
							<%
                                foreach (Origin item in _incidentOriginRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>
				</tr>
				<tr>
					<td class="psFormCell"><span><%=CommonLabels.Team%></span></td>
					<td class="psFormCell">
                        <div id="teamLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="teamLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show" ></button>
								    </td>
							    </tr>
						    </table>

						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%= CommonLabels.Account%>:</span></td>
					<td class="psFormCell">
					    <div id="accountLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="accountLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show"> </button>
								    </td>
							    </tr>
						    </table>

						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
				</tr>
				<tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%=CommonLabels.SaveView%></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell psLabelRequire"><%= CommonLabels.NewViewName %></td>
					<td class="psFormCell">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td class="psFormCell">
									<input id="viewNameTextBox" type="text" class="ps-filter-filtername textboxMiddle" />
								</td>
								<td class="psFormCell">
									<input id="saveViewButton" class="ps-filter-savebutton" type="button" value="<%= CommonLabels.SaveButton %>" />
								</td>
							</tr>
						</table>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell">
						<span><%= CommonLabels.PublicView %></span>
					</td>
					<td class="psFormCell">
						<input id="publicViewCheckBox" class="ps-filter-publiccheckbox" type="checkbox" />
					</td>
				</tr>
				</tbody>
			</table>
		</div>
	</div>
    
    <div class="desktopTable">
        <div class="desktopTableActions"></div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>

    <polar:Footer runat="server" />
	<polar:Includes runat="server" />

	<script type="text/javascript">
		var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function

        YAHOO.util.Event.onDOMReady( function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.IncidentHistories);
		    autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
		        id: 'contactLookup',
		        url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
		        linkID: "contactLink",
		        propertyName: "Contact",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
		        }		        
		    });


		    autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
		        id: 'teamLookup',
		        url: '<%= UrlHelper.GetUrl("/api/teams") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
		        linkID: "teamLink",
		        propertyName: "Team",
		        resourceHolder: resource,		        
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&assignableteam=true&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
		        }
		    });


		    autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
		        id: 'userLookup',
		        url: '<%= UrlHelper.GetUrl("/api/users") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
		        linkID: "userLink",
		        propertyName: "User",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
		        }
		    });

		    autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
		        id: 'accountLookup',
		        url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
		        linkID: "accountLink",
		        propertyName: "Account",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
		            columnDefinitions: [
                                        { key: 'Add', formatter: 'customContact' },
	                                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                                    ]
		        }
		    });

			POLAR.View.Page.initializeGrid();

			var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
			    viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
			    args: [
                    { id: 'maxResults', urlValueName: 'maxresults', type: 'select' },
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },                    
                    { urlValueName: 'status' },
                    { urlValueName: 'priority' },
                    { urlValueName: 'category' },
                    { urlValueName: 'origin' },
                    { urlValueName: 'closureclassification' },
                    { urlValueName: 'contact' },
                    { urlValueName: 'user' },
                    { urlValueName: 'account' },
                    { urlValueName: 'team' }
                ],
			    onGetArguments: function(args) {
                    if (!YAHOO.lang.isUndefined(resource.Contact) && !YAHOO.lang.isNull(resource.Contact)) {
                        args['contact'] = resource.Contact.ID;
                    }
                    if (!YAHOO.lang.isUndefined(resource.User) && !YAHOO.lang.isNull(resource.User)) {
                        args['user'] = resource.User.ID;
                    }
                    if (!YAHOO.lang.isUndefined(resource.Account) && !YAHOO.lang.isNull(resource.Account)) {
                        args['account'] = resource.Account.ID;
                    }
                    if (!YAHOO.lang.isUndefined(resource.Team) && !YAHOO.lang.isNull(resource.Team)) {
                        args['team'] = resource.Team.ID;
                    }
                    var valStatus = $(POLAR.Util.jqIdFormat("Status.ID")).selectedOptions();
                    if (valStatus[0].value != 0) {
                        args['status'] = valStatus[0].value;
                    }

                    var valPriority = $(POLAR.Util.jqIdFormat("Priority.ID")).selectedOptions();
                    if (valPriority[0].value != 0) {
                        args['priority'] = valPriority[0].value;
                    }

                    var valOrigins = $(POLAR.Util.jqIdFormat("Origin.ID")).selectedOptions();
                    if (valOrigins[0].index != 0) {
                        args['origin'] = valOrigins[0].index;
                    }

                    var valCategory = $(POLAR.Util.jqIdFormat("Category.ID")).selectedOptions();
                    if (valCategory[0].index != 0) {
                        args['category'] = valCategory[0].index;
                    }

                    var valCC = $(POLAR.Util.jqIdFormat("ClosureClassification.ID")).selectedOptions();
                    if (valCC[0].index != 0) {
                        args['closureclassification'] = valCC[0].index;
                    }
                },
                onSetArguments: function(args) {
                    var contactID = args['contact'];
                    if (!YAHOO.lang.isUndefined(contactID) && !YAHOO.lang.isNull(contactID)) {
                        autoCompleteLookupContact._changeOnLinkedControl(contactID);
                    }
                    var userID = args['user'];
                    if (!YAHOO.lang.isUndefined(userID) && !YAHOO.lang.isNull(userID)) {
                        autoCompleteLookupUser._changeOnLinkedControl(userID);
                    }
                    var accountID = args['account'];
                    if (!YAHOO.lang.isUndefined(accountID) && !YAHOO.lang.isNull(accountID)) {
                        autoCompleteLookupAccount._changeOnLinkedControl(accountID);
                    }
                    var teamID = args['team'];
                    if (!YAHOO.lang.isUndefined(teamID) && !YAHOO.lang.isNull(teamID)) {
                        autoCompleteLookupTeam._changeOnLinkedControl(teamID);
                    }

                    var statusID = args['status'];
                    $(POLAR.Util.jqIdFormat("Status.ID")).selectOptions("" + statusID);

                    var priorityID = args['priority'];
                    $(POLAR.Util.jqIdFormat("Priority.ID")).selectOptions("" + priorityID);

                    var categoryID = args['category'];
                    $(POLAR.Util.jqIdFormat("Category.ID")).selectOptions("" + categoryID);

                    var closureclassificationID = args['closureclassification'];
                    $(POLAR.Util.jqIdFormat("ClosureClassification.ID")).selectOptions("" + closureclassificationID);

                    var originID = args['origin'];
                    $(POLAR.Util.jqIdFormat("Origin.ID")).selectOptions("" + originID);
                }
            });
        };
        
	    POLAR.View.Page.initializeGrid = function() {
			var dataSource = POLAR.View.DataTable.createDataSource(resource);
			
			dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
			dataSource.responseSchema = {
			    resultsList: 'Items',
			    fields: [
			        { key: 'ID', parser: YAHOO.util.DataSource.parseNumber },
			        { key: 'Incident.ID', parser: YAHOO.util.DataSource.parseNumber },
					'Title',
					'URL',
					'Contact.Name',
			        //'AccountFromTemplate.CountryRegion.Name',
					'Contact.URL',
					'User.Name',
					'User.URL',
					'Team.Name',
					'Team.URL',
					'Status.Name',
		            'Priority.Name',
					{ key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate }
			    ]
			};
			var formatServiceUser = function(elCell, oRecord, oColumn, sData) {
			    if (sData == null) return;
			    elCell.innerHTML = '<a href=' + oRecord.getData('Contact.URL') + '>' + sData + '</a>';
			};

			var formatAssignee = function(elCell, oRecord, oColumn, sData) {
			    if (sData == null) return;
			    elCell.innerHTML = '<a href=' + oRecord.getData('User.URL') + '>' + sData + '</a>';
			};

			var formatTeam = function(elCell, oRecord, oColumn, sData) {
			    if (sData == null) return;
			    elCell.innerHTML = '<a href=' + oRecord.getData('Team.URL') + '>' + sData + '</a>';
			};
			//TODO: resovle use case when incident was deleted and URI is /incident/delete/{ID} we have to look to persmission resoruce and format icnidetne link depend of that
			var formatIncidentID = function(elCell, oRecord, oColumn, sData) {
			    if (sData == null) return;
			    elCell.innerHTML = '<a href=' + UserResourcePermissions.VirtualUrl + '/incident/' + oRecord.getData('IncidentID') + '>' + sData + '</a>';
			};

			var dataTableContainerWidth = $("#dataTableContainer").width(); 
			dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
                { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true },
                { key: 'Incident.ID', label: '<%= CommonLabels.IncidentID %>', sortable: true, formatter: formatIncidentID, resizeable: true },
			    { key: 'Title', label: '<%= CommonLabels.Title %>', maxAutoWidth: dataTableContainerWidth / 3, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
 			    { key: 'Contact.Name', label: '<%= IncidentLabels.Contact %>', maxAutoWidth: dataTableContainerWidth / 10, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatServiceUser },
			    { key: 'User.Name', label: '<%= IncidentLabels.User %>', maxAutoWidth: dataTableContainerWidth / 10, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatAssignee },
			    { key: 'Team.Name', label: '<%= IncidentLabels.Team %>', maxAutoWidth: dataTableContainerWidth / 10, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatTeam },
			    { key: 'Status.Name', label: '<%= IncidentLabels.IncidentStatus %>', sortable: true, resizeable: true },
			    { key: 'Priority.Name', label: '<%= IncidentLabels.IncidentPriority %>', sortable: true, resizeable: true },
			    { key: 'ModifiedOn', label: '<%= CommonLabels.CreatedOn %>', maxAutoWidth: dataTableContainerWidth / 7, sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			], dataSource, {
			    sortedBy: { key: 'ModifiedOn', dir: YAHOO.widget.DataTable.CLASS_DESC },
        		draggableColumns: true,
        		paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

			POLAR.View.DataTable.configDataTable(dataTable);
			////POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
			//set with on first colon for beter visula efect
			$("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
		};
	</script>

	<script runat="server">
        string _jsonResRep;
        CategoryRepository _incidentCategoryRepository = IoC.Container.Resolve<CategoryRepository>();
        ClosureClassificationRepository _incidentClosureClassificationRepository = IoC.Container.Resolve<ClosureClassificationRepository>();
        OriginRepository _incidentOriginRepository = IoC.Container.Resolve<OriginRepository>();

	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

	        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>