<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />   	
	<div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="filter" class="filterdesk">
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />		
		<span class="selectFilter"><%= CommonLabels.View %>:</span>		
		<select id="filterSelect" class="ps-filter-views styled middlewidth" >
			<%
        		string relativeUrl = PageHelper.GetRelativeURL();
				if (resource != null && resource.Views.Value != null)
                {
				    foreach (FilterResourceFragment item in resource.Views.Value)
        		    {
					    %><option value="<%= HtmlTagConverter.HtmlEncode(item.Value.Value) %>"<%= HtmlHelper.OptionSelect(item.Value.Value == relativeUrl) %>><%= item.Name.Value %></option><%
        		    }
                }
			%>
		</select>		
		<span><%= CommonLabels.MaximumResults %>:</span>
		<select id="maxResults" class="styled smallwidth">
            <option value="0"></option>
            <option value="10" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "10") %>>10</option>
			<option value="50" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "50") %>>50</option>
			<option value="100" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "100") %>>100</option>
			<option value="200" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "200") %>>200</option>
			<option value="500" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "500") %>>500</option>
			<option value="1000" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "1000") %>>1000</option>
	    </select>
		
		<a class="ps-filter-showadvancedview" href="">
			<%= CommonLabels.AdvancedView %>
		</a>		
		
		<div class="ps-filter-advancedview psHidden">	
		<!-- template for autocomplete to clone from when creating new autocomplete components -->
            <div id="autocomplete-template" class="psHidden">
			    <table border="0" cellpadding="0" cellspacing="0" >
				    <tr>
					    <td class="acbox">
						    <div class="pl-autocomplete">						        
						        <input class="psTextbox pl-autocomplete-input psHidden" type="text" />
							    <div class="pl-autocomplete-container" ></div>
						    </div>
						    <a id="autocomplete-template-link" href=""></a>
			               </td>
					    <td class="">
						    <button class="lookup pl-lookup-panel-show" ></button>
						    <button class="lookupSetEmpty pl-lookup-panel-setEmpty psHidden" ></button>
					    </td>
				    </tr>
			    </table>

			    <div class="resizablepanel pl-lookup-panel">							    
				    <div class="bd">
					    <div class="yui-skin-sam pl-lookup-datatable"></div>
				    </div>
				    <div class="ft"></div>
			    </div>
		    </div>
					
			<table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
                <colgroup>
                    <col class="psColon1" />
                    <col />
                    <col class="psColMid" />
                    <col class="psColon3" />
                    <col />
                </colgroup>
                <tbody>
    	        <tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%= CommonLabels.AdvancedView %></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell"><%= IncidentLabels.IncidentStatus %></td>
					<td class="psFormCell">
				        <table id="filtersStatusTable" class="selectionArrayTable">
				            <tr>
		                    <%
				                int counter1 = 0;      
                                foreach (Status item in Enum.GetValues(typeof(Status)))
				                {
                                    if (counter1 % 3 == 0)
                                    {
                                        %></tr><tr><%
                                    }
                                    counter1++;
					                %><td><input id="statusId<%=(long)item%>" type="checkbox" /> <%=StatusLabels.GetLabel(item)%></td><%
				                }
			                %>
			                </tr>
				        </table>
					</td>
					<td class="psFormMid"></td>
					
					<td class="psFormCell"><%= CommonLabels.Category%></td>
					<td class="psFormCell">
						<select id="CategoryID" class="styled middlewidth">
							<option value=""></option>
							<%
                                foreach (Category item in _categoryRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>					
				</tr>
				<tr>
				<td class="psFormCell"><span><%=IncidentLabels.IncidentPriority%></span></td>
					<td class="psFormCell">
						<table id="filtersPriorityTable" class="selectionArrayTable">
				            <tr>
		                    <%
				                int counter2 = 0;      
                                foreach (Priority item in Enum.GetValues((typeof(Priority))))
				                {
                                    if (counter2 % 3 == 0)
                                    {
                                        %></tr><tr><%
                                    }
                                    counter2++;
					                %><td><input id="priorityId<%=(long)item%>" type="checkbox" /> <%=item.ToString()%></td><%
				                }
			                %>
			                </tr>
			            </table>
					</td>

					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=IncidentLabels.ClosureClassification%></span>
					</td> <td class="psFormCell">
						<select id="ClosureClassificationID" class="styled middlewidth">
							<option value=""></option>
							<%
                                foreach (ClosureClassification item in _incidentClosureClassificationRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>		
					</td>
				</tr>
				<tr>
				    <td class="psFormCell"><span><%=IncidentLabels.User%></span></td>
					<td class="psFormCell">
						<div id="userLookup0"></div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"></td>
					<td class="psFormCell">
					</td>
			    </tr>
				<tr>
					<td class="psFormCell"><span><%=IncidentLabels.Contact%></span></td>
					<td class="psFormCell">
						<div id="contactLookup0"></div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=IncidentLabels.Origin%></span>
					</td> <td class="psFormCell">
						<select id="OriginID" class="styled middlewidth">
							<option value=""></option>
							<%
                                foreach (Origin item in _incidentOriginRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>
				</tr>
				<tr>
					<td class="psFormCell"><span><%=CommonLabels.Team%></span></td>
					<td class="psFormCell">
                        <div id="teamLookup0"></div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%= CommonLabels.Account%>:</span></td>
					<td class="psFormCell">
					    <div id="accountLookup0"></div>
					</td>
				</tr>
				<tr>
					<td class="psFormCell"><span><%=CommonLabels.Created%></span></td>
					<td class="psFormCell">
						<div>							
							<%=CommonLabels.FromLowercase%> <input id="createdOnFrom" class="textboxMiddle" type="text"/>
							<%=CommonLabels.ToLowercase%> <input id="createdOnTo" class="textboxMiddle" type="text"/> 
							<a id="clearCreated" href=""><%= CommonLabels.Clear %></a>
						</div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"></td>
					<td class="psFormCell"></td>
				</tr>
				<tr>
					<td class="psFormCell"><span><%=CommonLabels.ModifiedOn%></span></td>
					<td class="psFormCell">
						<div>							
						    
							<%=CommonLabels.FromLowercase%> <input id="modifiedOnFrom" class="textboxMiddle"  type="text"/>
							<%=CommonLabels.ToLowercase%> <input id="modifiedOnTo" class="textboxMiddle" type="text" /> 
							<a id="clearModified" href=""><%= CommonLabels.Clear %></a>							
						</div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"></td>
					<td class="psFormCell"></td>
				</tr>
				<tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%=CommonLabels.SaveView%></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell psLabelRequire"><%= CommonLabels.NewViewName %></td>
					<td class="psFormCell">
						<table  border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td class="psFormCell">
									<input id="viewNameTextBox" type="text" class="ps-filter-filtername textboxMiddle" />
								</td>
								<td class="psFormCell">
									<input id="saveViewButton" class="ps-filter-savebutton" type="button" value="<%= CommonLabels.SaveButton %>" />
								</td>
							</tr>
						</table>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell">
						<span><%= CommonLabels.PublicView %></span>
					</td>
					<td class="psFormCell">
						<input id="publicViewCheckBox" class="ps-filter-publiccheckbox" type="checkbox" />
					</td>
				</tr>
				</tbody>
			</table>
		</div>
	</div>
	<div class="desktopTable">
        <div class="desktopTableActions">
			<%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
			<input id="buttonExport" type="button" value="<%= CommonLabels.Export %>" />
        </div>               
        
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>;
    </script>
    <polar:Includes runat="server" />
    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function       
        $(document).ready(function() {
            //$('.yui-t2').attr('id', 'doc4'); - resize on centar whole desktop
            /*$("#idmidle2").resize(function() {//for IE8 bug
                $(".leftsidebar").css({ 'height': $('#idmidle2').height()+15  });
            });
            */
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });
        
        // hold selected filters
        var selectedFilters = {};

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Incidents);
            
            // create calendar controls
			resultCallback = function(resultDates) {
				var startDateString = resultDates.startDate.toString("yyyy-MM-ddTHH:mm:ssZ");
				var endDateString = resultDates.endDate.toString("yyyy-MM-ddTHH:mm:ssZ");
				window.location = POLAR.View.getUrlWithoutArgs() + '?startDate='  +  startDateString + '&endDate=' + endDateString +  '&contactNumber=' + $('#contactNumber :selected').val();
			};
			
			$("#createdOnFrom").datepicker({ dateFormat: 'yy/mm/dd' });
			$("#createdOnTo").datepicker({ dateFormat: 'yy/mm/dd' });
			$("#modifiedOnFrom").datepicker({ dateFormat: 'yy/mm/dd' });
			$("#modifiedOnTo").datepicker({ dateFormat: 'yy/mm/dd' });
						
			$("#clearCreated").click(function(event) {
			    event.preventDefault();
			    $("#createdOnFrom").val("");
			    $("#createdOnTo").val("");
			    $('input[title!=""]').jqpHint();
			});                

			$("#clearModified").click(function(event) {
			    event.preventDefault();
			    $("#createdOnFrom").val("");
			    $("#createdOnTo").val("");
			    $('input[title!=""]').jqpHint();
			});
			
            var autoCompleteLookupContactControls = [];
            var autoCompleteContactConfig = {
                id: 'contactLookup',
                url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
                linkID: "contactLink",
                propertyName: "Contact",
                resourceHolder: selectedFilters,
                multipleControlsAllowed: true,
                allowUnassignedValue: false,
                listOfControlsToUpdate: autoCompleteLookupContactControls,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            };
            var aclControlContact = POLAR.Widget.appendNewLookupControl('contactLookup0', 'contactLink0', autoCompleteContactConfig, 'contactLookup0');
            autoCompleteLookupContactControls.push(aclControlContact);

            var autoCompleteLookupTeamControls = [];
            var autoCompleteTeamConfig = {
                id: 'teamLookup',
                url: '<%= UrlHelper.GetUrl("/api/teams") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
                linkID: "teamLink",
                propertyName: "Team",
                resourceHolder: selectedFilters,
                multipleControlsAllowed: true,
                allowUnassignedValue: false,
                listOfControlsToUpdate: autoCompleteLookupTeamControls,
                autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&assignableteam=true&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            };
            var aclControlTeam = POLAR.Widget.appendNewLookupControl('teamLookup0', 'teamLink0', autoCompleteTeamConfig, 'teamLookup0');
            autoCompleteLookupTeamControls.push(aclControlTeam);

            var autoCompleteLookupUserControls = [];
            var autoCompleteUserConfig = {
                id: 'userLookup0',
                url: '<%= UrlHelper.GetUrl("/api/users") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
                linkID: "userLink0",
                propertyName: "User",
                resourceHolder: selectedFilters,
                multipleControlsAllowed: true,
                allowUnassignedValue: true,
                listOfControlsToUpdate: autoCompleteLookupUserControls,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            };
            var aclControlUser = POLAR.Widget.appendNewLookupControl('userLookup0', 'userLink0', autoCompleteUserConfig, 'userLookup0');
            autoCompleteLookupUserControls.push(aclControlUser);

            var autoCompleteLookupAccountControls = [];
            var autoCompleteAccountConfig = {
                id: 'accountLookup',
                url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
                linkID: "accountLink",
                propertyName: "Account",
                resourceHolder: selectedFilters,
                multipleControlsAllowed: true,
                allowUnassignedValue: true,
                listOfControlsToUpdate: autoCompleteLookupAccountControls,
                autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                                    { key: 'Add', formatter: 'customContact' },
	                                { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                    { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                    { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                                ]
                }
            };
            var aclControlAccount = POLAR.Widget.appendNewLookupControl('accountLookup0', 'accountLink0', autoCompleteAccountConfig, 'accountLookup0');
            autoCompleteLookupAccountControls.push(aclControlAccount);

            POLAR.View.Page.initializeGrid();

					/*{ id: 'modifiedOnFrom', urlValueName: 'modifiedge', type: 'textbox' },
                    { id: 'modifiedOnTo', urlValueName: 'modifiedle', type: 'textbox' },
                    { id: 'createdOnFrom', urlValueName: 'createdge', type: 'textbox' },
                    { id: 'createdOnTo', urlValueName: 'createdle', type: 'textbox' }*/
                    
            var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter/iperson/") %>' + AuthenticatedPerson.ID,
                args: [
                    { id: 'maxResults', urlValueName: 'maxresults', type: 'select' },
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },
                    { urlValueName: 'status' },
                    { urlValueName: 'priority' },
                    { urlValueName: 'category' },
                    { urlValueName: 'origin' },
                    { urlValueName: 'closureclassification' },
                    { urlValueName: 'contact' },
                    { urlValueName: 'user' },
                    { urlValueName: 'account' },
                    { urlValueName: 'team' },
                    { urlValueName: 'modifiedge' },
                    { urlValueName: 'modifiedle' },
                    { urlValueName: 'createdge' },
                    { urlValueName: 'createdle' }
                ],

                // when getting values from controls that define filters so we can generate URL query from it
                onGetArguments: function(args) {
					stringToDateFrom = function(txt) {
						if("undefined" === txt || txt == "") {
							return "";
						}
						
						try
						{
						    var date = new Date.parse(txt);	
						    date.setHours(0);
						    date.setMinutes(0);
						    date.setSeconds(0);
						    date.add({ minutes: parseInt(TIME_ZONE_OFFSET_MINUTES) * -1 })
						    return date.toString("yyyy-MM-ddTHH:mm:ssZ");
						}
						catch (e) {
						    return "";			
						}
						
					};
					
					stringToDateTo = function(txt) {
						if("undefined" === txt || txt == "") {
							return "";
						}
						try {						
						    var date = new Date.parse(txt);							
						    date.setHours(23);
						    date.setMinutes(59);
						    date.setSeconds(59);
						    date.add({ minutes: parseInt(TIME_ZONE_OFFSET_MINUTES) * -1 })
						    return date.toString("yyyy-MM-ddTHH:mm:ssZ");
						}
						catch (e) {
						    return "";			
						}
						
					};
                
					args["modifiedge"] = stringToDateFrom($("#modifiedOnFrom").val());
					args["modifiedle"] = stringToDateTo($("#modifiedOnTo").val());
					args["createdge"] = stringToDateFrom($("#createdOnFrom").val());
					args["createdle"] = stringToDateTo($("#createdOnTo").val());
					
                    if (!YAHOO.lang.isUndefined(selectedFilters['Contact']) && !YAHOO.lang.isNull(selectedFilters['Contact'])) {
                        args['contact'] = selectedFilters['Contact'];
                    }

                    if (!YAHOO.lang.isUndefined(selectedFilters['User']) && !YAHOO.lang.isNull(selectedFilters['User'])) {
                        args['user'] = selectedFilters['User'];
                    }

                    if (!YAHOO.lang.isUndefined(selectedFilters['Account']) && !YAHOO.lang.isNull(selectedFilters['Account'])) {
                        args['account'] = selectedFilters['Account'];
                    }

                    if (!YAHOO.lang.isUndefined(selectedFilters['Team']) && !YAHOO.lang.isNull(selectedFilters['Team'])) {
                        args['team'] = selectedFilters['Team'];
                    }

                    args['status'] = [];
                    $('#filtersStatusTable input[type="checkbox"]:checked').each(function() {
                        // extract ID from element name, should be 'statusIdX' where X is ID
                        var statusId = this.id.substring(8);
                        args['status'].push(statusId);
                    });

                    args['priority'] = [];
                    $('#filtersPriorityTable input[type="checkbox"]:checked').each(function() {
                        // extract ID from element name, should be 'priorityIdX' where X is ID
                        var priorityId = this.id.substring(10);
                        args['priority'].push(priorityId);
                    });

                    args['origin'] = [];
                    var originVal = $('#OriginID').val();
                    if (originVal != undefined && originVal != null) {
                        args['origin'] = originVal;
                    }

                    args['category'] = [];
                    var valCategory = $('#CategoryID').val();
                    if (valCategory != undefined && valCategory != null) {
                        args['category'] = valCategory;
                    }

                    args['closureclassification'] = [];
                    var valCC = $('#ClosureClassificationID').val();
                    if (valCC != undefined && valCC != null) {
                        args['closureclassification'] = valCC;
                    }
                },

                // when setting query filter values to controls as page loads
                onSetArguments: function(args) {
					try {
						dateToString = function(txt) {
							if("undefined" === txt || txt == "") {
								return "";
							}
							
							var date = Date.parseExact(txt, "yyyy-MM-ddTHH:mm:ssZ");
							date.add({minutes: parseInt(TIME_ZONE_OFFSET_MINUTES)})
							
							return date.toString("yyyy/MM/dd");
						};
	                
						$("#modifiedOnFrom").val(dateToString(args["modifiedge"] + ""));
						$("#modifiedOnTo").val(dateToString(args["modifiedle"] + ""));
						$("#createdOnFrom").val(dateToString(args["createdge"] + ""));
						$("#createdOnTo").val(dateToString(args["createdle"] + ""));
					} 
					catch(e) {					
					}
					
                    var contactIDs = args['contact'];
                    if (!YAHOO.lang.isUndefined(contactIDs) && !YAHOO.lang.isNull(contactIDs) && $.isArray(contactIDs)) {
                        for (var i = 0; i < contactIDs.length; i++) {
                            autoCompleteLookupContactControls[autoCompleteLookupContactControls.length - 1]._changeOnLinkedControl(contactIDs[i]);
                        }
                    }

                    var userIDs = args['user'];
                    if (!YAHOO.lang.isUndefined(userIDs) && !YAHOO.lang.isNull(userIDs) && $.isArray(userIDs)) {
                        for (var i = 0; i < userIDs.length; i++) {
                            autoCompleteLookupUserControls[autoCompleteLookupUserControls.length - 1]._changeOnLinkedControl(userIDs[i]);
                        }
                    }

                    var accountIDs = args['account'];
                    if (!YAHOO.lang.isUndefined(accountIDs) && !YAHOO.lang.isNull(accountIDs) && $.isArray(accountIDs)) {
                        for (var i = 0; i < accountIDs.length; i++) {
                            autoCompleteLookupAccountControls[autoCompleteLookupAccountControls.length - 1]._changeOnLinkedControl(accountIDs[i]);
                        }
                    }

                    var teamIDs = args['team'];
                    if (!YAHOO.lang.isUndefined(teamIDs) && !YAHOO.lang.isNull(teamIDs) && $.isArray(teamIDs)) {
                        for (var i = 0; i < teamIDs.length; i++) {
                            autoCompleteLookupTeamControls[autoCompleteLookupTeamControls.length - 1]._changeOnLinkedControl(teamIDs[i]);
                        }
                    }

                    var statusIDs = args['status'];
                    if (!YAHOO.lang.isUndefined(statusIDs) && !YAHOO.lang.isNull(statusIDs)) {
                        for (var i = 0; i < statusIDs.length; i++) {
                            $('#statusId' + statusIDs[i]).attr('checked', true);
                        }
                    }

                    var priorityIDs = args['priority'];
                    if (!YAHOO.lang.isUndefined(priorityIDs) && !YAHOO.lang.isNull(priorityIDs)) {
                        for (var i = 0; i < priorityIDs.length; i++) {
                            $('#priorityId' + priorityIDs[i]).attr('checked', true);
                        }
                    }

                    var categoryID = args['category'];
                    if (categoryID != undefined && categoryID != null) {
                        $('#CategoryID').selectOptions('' + categoryID);
                    }

                    var closureclassificationID = args['closureclassification'];
                    if (closureclassificationID != undefined && closureclassificationID != null) {
                        $('#ClosureClassificationID').selectOptions('' + closureclassificationID);
                    }

                    var originID = args['origin'];
                    if (originID != undefined && originID != null) {
                        $('#OriginID').selectOptions('' + originID);
                    }
                }
            });
            POLAR.View.Page.processFilters();            
        }

        /**
        * Goes through all incident filters on the page and replaces templates with actual data.. e.g. incidents?user={myId} => incidents?user=2
        */
        POLAR.View.Page.processFilters = function() {
            var filters = $('#filter select.ps-filter-views option');

            // calculate values we will use
            var myId = '' + AuthenticatedPerson.ID;
            var myTeamIds = '';
            if ($.isArray(AuthenticatedPerson.Teams)) {
                for (var i = 0; i < AuthenticatedPerson.Teams.length; i++) {
                    myTeamIds += AuthenticatedPerson.Teams[i].ID + ';';
                }
                myTeamIds = myTeamIds.substring(0, myTeamIds.length - 1);
            }
            var todayStartTime = new Date();
            todayStartTime.setHours(0, 0, 0, 0);
            todayStartTime = todayStartTime.toISOString();
            var d = new Date();
            var lastWeekStartTime = Date.parse("1 week ago").add({ minutes: d.getTimezoneOffset() }).toString("yyyy-MM-ddTHH:mm:ssZ").replace(/\"/g, "");
            var lastMonthStartTime = Date.parse('-months').add({ minutes: d.getTimezoneOffset() }).toString("yyyy-MM-ddTHH:mm:ssZ").replace(/\"/g, "");

            // replace variable containers with values
            filters.each(function() {
                var optionUrl = $(this).val();
                optionUrl = optionUrl.replace('{myId}', myId);
                optionUrl = optionUrl.replace('{myTeamIds}', myTeamIds);
                optionUrl = optionUrl.replace('{todayStartTime}', todayStartTime);
                optionUrl = optionUrl.replace('{lastWeekStartTime}', lastWeekStartTime);
                optionUrl = optionUrl.replace('{lastMonthStartTime}', lastMonthStartTime);
                $(this).val(optionUrl);
            });

            // select currently used filter from select menu, this needs to be done after resolving variables in templates
            // if none is used then add custom selection
            var filterSelected = false;
            filters.each(function() {
                if (BASE_URL + $(this).val() == document.URL) {
                    $('#filter select.ps-filter-views').val($(this).val());
                    filterSelected = true;
                }
            });

            var uriDesktop = POLAR.View.getDektopURI() + "?maxresults=100";
            //alert(document.URL);
            //alert(uriDesktop);
            if (!filterSelected) {
                if (document.URL == BASE_URL + uriDesktop) {
                    $('#filter select.ps-filter-views').append("<option value=" + uriDesktop + " selected='selected'>(<%= CommonLabels.None%>)</option>");
                }
                else {
                    $('#filter select.ps-filter-views').append("<option value=" + uriDesktop + ">(<%= CommonLabels.None%>)</option>");
                    $('#filter select.ps-filter-views').append("<option value=" + uriDesktop + " selected='selected' ><%= CommonLabels.Custom %></option>");
                }       
            }
            else {
                $('#filter select.ps-filter-views').append("<option value=" + uriDesktop + ">(<%= CommonLabels.None%>)</option>");
            }
            $("select.styled").jqTransform();
        }

        POLAR.View.Page.initializeGrid = function() {
            //var dataSource = new YAHOO.util.DataSource(resource);
            //dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
            dataSource.responseSchema = {
                resultsList: 'Items',
                fields: [
					{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber },
					'Title',
					'URL',
					'Contact.Name',
					'Contact.URL',
					'User.Name',
					'User.URL',
					'Team.Name',
					'Team.URL',
					'Status.Name',
		            'Priority.Name',
					{ key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate }
				]
            };
            
            var dataTableContainerWidth = $("#dataTableContainer").width(); 
            dataTable = new YAHOO.widget.DataTable('dataTableContainer', [ 
					{label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
					{ key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true },
					{ key: 'Title', label: '<%= CommonLabels.Title %>', maxAutoWidth: dataTableContainerWidth / 3, resizeable: true, sortable: true, formatter: POLAR.View.DataTable.formatUrl },
 					{ key: 'Contact.Name', label: '<%= IncidentLabels.Contact %>', maxAutoWidth: dataTableContainerWidth / 10, sortable: true, formatter: POLAR.View.DataTable.formatServiceUser, resizeable: true },
					{ key: 'User.Name', label: '<%= IncidentLabels.User %>', maxAutoWidth: dataTableContainerWidth/10, sortable: true, formatter: POLAR.View.DataTable.formatAssignee, resizeable: true },
					{ key: 'Team.Name', label: '<%= IncidentLabels.Team %>', maxAutoWidth: dataTableContainerWidth/10, sortable: true, formatter: POLAR.View.DataTable.formatTeam, resizeable: true },
					{ key: 'Status.Name', label: '<%= IncidentLabels.IncidentStatus %>', sortable: true, resizeable: true },
					{ key: 'Priority.Name', label: '<%= IncidentLabels.IncidentPriority %>', sortable: true, resizeable: true },
					{ key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', maxAutoWidth: dataTableContainerWidth / 7 , sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate, resizeable: true }
			    ],
			    dataSource,
			    {
			        sortedBy: { key: 'ModifiedOn', dir: YAHOO.widget.DataTable.CLASS_DESC },
			        draggableColumns: true,
			        paginator: POLAR.View.DataTable.createDefaultPaginator()
			    }
			);

            
            POLAR.View.DataTable.configDataTable(dataTable);
            POLAR.View.DataTable.configDeleteUndelete({
                dataTable: dataTable,
                dataTableItems: resource.Items,
                dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
                dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
            });

            //TODO //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
            //set with on first and second colon for beter visula efect
            $("#dataTableContainer colgroup col:lt(2)").css('width', '10px');

            //attach filters on table            
            /*$("#dataTableContainer  th").slice(3,8).attr("filter-type", "ddl");            
            var options = {selectOptionLabel: resource.LabelsCommon.Select + "..."};
            $('#dataTableContainer').tableFilter(options);*/
        };
        //alert("sadgsdfg");
        //$(".yui-pg-rpp-options").addClass('styled');
        //$("select.styled").jqTransform();
        //$("#yui-pg0-0-first-span").css("color", "red");
        
    </script>

    <script runat="server">
        string _jsonResRep;
        IncidentsResource resource;
        public readonly CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        public readonly ClosureClassificationRepository _incidentClosureClassificationRepository = IoC.Container.Resolve<ClosureClassificationRepository>();
        public readonly OriginRepository _incidentOriginRepository = IoC.Container.Resolve<OriginRepository>();

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as IncidentsResource;
        }
    </script>
</body>
</html>