﻿<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>

<%@ Import Namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>
        <%= CommonLabels.LanguageEmbedded %></title>
    <polar:CssIncludes runat="server" />
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="text-align: left">
                    <div>
                    </div>
                </td>
            </tr>
       <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" style="background-color: white">
        <colgroup>
            <col class="psColon1">
            <col>
            <col class="psColMid">
            <col class="psColon3">
            <col>
        </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= LanguageLabels.Name %></span>
                    <span id="<%= resource.LanguageName.Name + "error" %>" />
                </td>
                <td class="psFormCell" colspan="1">
                    <input id="<%= resource.LanguageName.Name %>" class="psTextbox" type="text" value="<%= resource.LanguageName %>" />
                </td>
                <td class="psFormCell" colspan="3" />
            </tr>
            <tr>
                <td colspan="2">Export as: <a id="xmlFileLink" href="<%= resource.URL.Value %>?fileformat=XML">XML</a>, <a id="cvsFileLink" href="<%= resource.URL.Value %>?fileformat=CSV">CSV</a>, <a id="jsonFileLink" href="<%= resource.URL.Value %>?fileformat=JSON">JSON</a></td>
            </tr>
            <tr>
                <td>
                    <div id="myContainer" class=" yui-skin-sam"></div>
                </td>
            </tr>

        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
		var resource = <%= _jsonResRep %>
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.Page.formatText = function(elCell, oRecord, oColumn, sData) {
                var labelName = oRecord.getData("<%= LanguageLabelFragment.Meta.LabelName.Name %>");
                var labelValue = oRecord.getData("<%= LanguageLabelFragment.Meta.Text.Name %>");
                var inputId = currentContainer.ContainerName + "." + labelName;

                elCell.innerHTML = "<input id='" + inputId + "' value='" + labelValue + "' class='psTextbox' type='text' />";
            };

            if (resource.LanguageContainers == 'undefined') return;
            for (var i = 0; i < resource.LanguageContainers.length; ++i) {
                var currentContainer = resource.LanguageContainers[i];

                var currentContainerId = currentContainer.ContainerName;
                var currentContainerElement = "<div id='" + currentContainerId + "' class='yui-skin-sam'></div>"

                $("#myContainer").append(currentContainerElement);

                var myDataSource = new YAHOO.util.DataSource(currentContainer);
                myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

                myDataSource.responseSchema = {
                    resultsList: "<%= LanguageContainerFragment.Meta.Labels.Name %>",
                    fields: [
		                "<%= LanguageLabelFragment.Meta.LabelName.Name %>",
		                "<%= LanguageLabelFragment.Meta.Text.Name %>"
		            ]
                };

                var myColumnDefs = [
	                { key: "<%= LanguageLabelFragment.Meta.LabelName.Name %>", label: "<%= LanguageLabels.Name %>", sortable: true, resizeable: true },
	                { key: "<%= LanguageLabelFragment.Meta.Text.Name %>", label: "<%= LanguageLabels.Text %>", sortable: true, resizeable: true, width:500, formatter: POLAR.View.Page.formatText }
	            ];

	            var myDataTable = new YAHOO.widget.DataTable(currentContainerId, myColumnDefs, myDataSource, { caption: currentContainer.ContainerName });
            }
        }
    </script>
    <script runat="server">
        LanguageResource resource;
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as LanguageResource;
        }
        </script>
</body>
</html>
