<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= CommonLabels.Logs %></title>
    <polar:CssIncludes runat="server"/>
</head>

<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <br />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <br />
    <div class="desktopTable">
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
	<polar:Includes runat="server" />

	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function		
		YAHOO.util.Event.onDOMReady( function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Logs);
			POLAR.View.Page.initializeGrid();
        };

        POLAR.View.Page.initializeGrid = function() {
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
            dataSource.responseSchema = {
                resultsList: 'Items',
                fields: [{ key: '<%= FileResource.Meta.FileName.Name %>' }, '<%= FileResource.Meta.FileName.Name %>', '<%= FileResource.Meta.URL.Name %>', '<%= FileResource.Meta.FileSize.Name %>', '<%= FileResource.Meta.CreatedOn.Name %>', '<%= FileResource.Meta.ModifiedOn.Name %>']
            };

            dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: '<%= FileResource.Meta.FileName.Name %>', label: '<%= CommonLabels.FileName %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				{ key: '<%= FileResource.Meta.FileSize.Name %>', label: '<%= CommonLabels.FileSize %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: '<%= FileResource.Meta.CreatedOn.Name %>', label: '<%= CommonLabels.CreatedOn %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true, formatter: POLAR.View.DataTable.formatDate },
				{ key: '<%= FileResource.Meta.ModifiedOn.Name %>', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true, formatter: POLAR.View.DataTable.formatDate }
			], dataSource, {
			    sortedBy: { key: '<%= FileResource.Meta.FileName.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
			    draggableColumns: true,
			    paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

            POLAR.View.DataTable.configDataTable(dataTable);

            // set with on first and second colon for better visual effect
            $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
        };
	</script>

	<script runat="server">
        string _jsonResRep;

	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
	    }
    </script>
</body>
</html>