<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= ReportLabels.ReportEdit%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation ID="Navigation1" runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div id="toolbar"></div>
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
	<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Title %></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="Title" readonly="readonly" class="psTextbox" type="text" />
			    </td>
            </tr>
        </tbody>
    </table>

    <div id="tabs" style="display: none">
	    <ul>
		    <li><a href="#tabs-1" id="tab1"></a></li>
		    <li><a href="#tabs-2" id="tab2"></a></li>
		    <li><a href="#tabs-3" id="tab3"></a></li>
	    </ul>
	   <div id="tabs-1">
            <div class="codeEditor">
                <textarea id="ServerSideJavaScriptCode" rows="25" cols="20" style="width:100%"></textarea>
            </div>
	    </div>
	    <div id="tabs-2">
            <div class="codeEditor">
                <textarea id="ClientSideJavaScriptCode" rows="25" cols="20" style="width:100%"></textarea>
            </div>
	    </div>
	    <div id="tabs-3">
            <textarea id="JsonResult" readonly="readonly" rows="25" cols="25" style="width:100%; height:650px;"></textarea>
	    </div>
    </div>

    </div>
    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes ID="Includes1" runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
       	    POLAR.View.Initialization();
   	        POLAR.View.CheckForExtraInfo();
   	        POLAR.View.Page();
   	    });

   	    var codeEditor1 = 0;
   	    var codeEditor2 = 0;

   	    POLAR.View.Page = function() {
   	        POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ReportEditHistory);
   	        try {
   	            $("#toolbar").append("<input id='buttonRestore' type='button' />");
   	            $("#buttonRestore").val(resource.LabelsCommon.RestoreButton);
   	            var buttonRestore = new YAHOO.widget.Button("buttonRestore");
   	            var onButtonRestore = function() {

   	                //iz postopjecih podataka izbacimo ParentGuid i ubacimo ga kao glavi GUID i takav dokument spremimo sa PUT na GUID.. ako javi da nema takvog dokumenta onda idmeo sa POST
   	                var objJsonData = YAHOO.lang.JSON.parse(resource.Data);
   	                if (objJsonData.ParentGuid !== undefined) {
   	                    objJsonData.Guid = objJsonData.ParentGuid;
   	                    delete objJsonData.ParentGuid;
   	                    objJsonData.Deleted = false;
   	                    resource.Data = YAHOO.lang.JSON.stringify(objJsonData);
   	                    var apiURL = (UserResourcePermissions.VirtualUrl + "/api/" + "reportedit/" + objJsonData.Guid);
   	                    POLAR.View.requestCallbackAndRedirectExt.argument = { URL: UserResourcePermissions.VirtualUrl + "/reportedit/" + objJsonData.Guid };
   	                    var newResRepr = POLAR.View.clearExtraJSResRepForPUTandDELETE(resource);
   	                    var transaction = YAHOO.util.Connect.asyncRequest('PUT', apiURL, POLAR.View.requestCallbackAndRedirectExt, YAHOO.lang.JSON.stringify(newResRepr));
   	                }

   	                ///----------------------------
   	                /*var objData = {};
   	                objData.ServerSideJavaScriptCode = codeEditor1.mirror.getCode();
   	                objData.ClientSideJavaScriptCode = codeEditor2.mirror.getCode();
   	                objData.Title = $('#Title').val();

   	                objData.JsonResult = $('#JsonResult').val();
   	                resource.Data = YAHOO.lang.JSON.stringify(objData); //UserResourcePermissions.VirtualUrl : "http://localhost:5650/phd"
   	                var strAPIURI = resource.URI.replace(/reportedithistory/i, "reportedit");
   	                var strIDRegex = RegExp("/" + resource.ID.toString(), "i");
   	                strAPIURI = strAPIURI.replace(strIDRegex, "");
   	                var transaction = YAHOO.util.Connect.asyncRequest('PUT', strAPIURI, POLAR.View.requestCallback, YAHOO.lang.JSON.stringify(resource));
   	                //var transaction = YAHOO.util.Connect.asyncRequest('PUT', "http://localhost:5650/phd/api/reportedit/reportc1", POLAR.View.requestCallback, YAHOO.lang.JSON.stringify(resource));
   	                */
   	            }
   	            buttonRestore.on("click", onButtonRestore);

   	            if (resource.Data != null) {
   	                var objData = YAHOO.lang.JSON.parse(resource.Data);
   	                $('#ServerSideJavaScriptCode').text(objData.ServerSideJavaScriptCode);
   	                $('#ClientSideJavaScriptCode').text(objData.ClientSideJavaScriptCode);
   	                $('#JsonResult').text(objData.JsonResult);
   	                $('#Title').val(objData.Title);
   	            }

   	            $("#tab1").text(resource.Labels.SSJS);
   	            $("#tab2").text(resource.Labels.CSLS);
   	            $("#tab3").text(resource.Labels.JsonResult);
   	        }
   	        catch (exception) {
   	        }

   	        var textarea1 = document.getElementById('ServerSideJavaScriptCode');
   	        codeEditor1 = new MirrorFrame(CodeMirror.replace(textarea1), "textarea1", {
   	            height: "650px",
   	            width: "100%",
   	            tabMode: "spaces",
   	            content: textarea1.value,
   	            parserfile: ["tokenizejavascript.js", "parsejavascript.js"],
   	            stylesheet: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/css/jscolors.css",
   	            path: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/js/",
   	            readOnly: true,
   	            autoMatchParens: true
   	        });

   	        var textarea2 = document.getElementById('ClientSideJavaScriptCode');
   	        codeEditor2 = new MirrorFrame(CodeMirror.replace(textarea2), "textarea2", {
   	            height: "650px",
   	            width: "100%",
   	            content: textarea2.value,
   	            parserfile: ["tokenizejavascript.js", "parsejavascript.js"],
   	            stylesheet: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/css/jscolors.css",
   	            path: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/js/",
   	            readOnly: true,
   	            autoMatchParens: true
   	        });

   	        $("#tabs").tabs();
   	        $("#tabs").show("fast");
   	    }
	</script>
</body>
</html>

<script runat="server">
    ReportEditHistoryResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as ReportEditHistoryResource;
    }
</script>

