<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title><%= CommonLabels.Reports %></title>
    <polar:CssIncludes runat="server" />
</head>
<body class="yui-skin-sam">
    <polar:Navigation ID="Navigation1" runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >    
    <div class="desktopTable">
        <div class="desktopTableActions"></div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>
    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>;
    </script>
    <polar:Includes ID="Includes1" runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function

		//YAHOO.util.Event.onDOMReady(function() {
		YAHOO.util.Event.addListener(window, "load", function() {
		    POLAR.View.Initialization();
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Reports);
		    var evalResourceRep = POLAR.View.evalDataInResourceRepresentation(resource);
		    var dataSource = POLAR.View.DataTable.createDataSource(evalResourceRep);
		    //var dataSource = new YAHOO.util.DataSource(evalResourceRep);  //var dataSource = new YAHOO.util.DataSource(resource);
		    //dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

		    var item = evalResourceRep.Items[0];
		    POLAR.View.SetPropertyNameToObject(item);

		    dataSource.responseSchema = {
		        resultsList: 'Items',
		        fields: [
        		    { key: item.GetPropertyName("Data.Title"), parser: POLAR.View.titleParser },
        		    item.GetPropertyName("URL")
        		    ]
		    };

		    dataTable = new YAHOO.widget.DataTable(
        	    'dataTableContainer',
                [
				    { key: item.GetPropertyName("Data.Title"), label: resource.Labels.Title, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl }
			    ],
			    dataSource,
			    {
			        sortedBy: { key: item.GetPropertyName("Data.Title"), dir: YAHOO.widget.DataTable.CLASS_DESC },
			        draggableColumns: true,
			        paginator: POLAR.View.DataTable.createDefaultPaginator()
			    }
			);

		    POLAR.View.DataTable.configDataTable(dataTable);
		};
    </script>

    <script runat="server">
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>
