<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title><%= AdminRoleLabels.Title %></title>
    <polar:CssIncludes  runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation ID="Navigation1" runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
	    <tr>
	        <td style="text-align:left">
	            <div>
                    <% if(0 == resource.ID.Value) {
                    %>                    
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                    else if (resource.Deleted.Value)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                    <button id="copyFromButton" type="button"><%= IncidentLabels.CopyFromMenuButton %></button>
                </div>

	        </td>
	        <td style="text-align:right" >
	            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
	        </td>
		<tr>
		<tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1" />
	        <col />
	        <col class="psColMid" />
	        <col class="psColon3" />
	        <col />
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Description %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>"><%= resource.Description %></textarea>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= AdminRoleLabels.ResourcesDataTableCaption%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <div id="<%= resource.Resources.Name %>" class="yui-skin-sam"></div>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= AdminRoleLabels.UserDefinedResourcesDataTableCaption %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <span><%= AdminRoleLabels.AddUserDefinedResource %></span>
                    <input id="_userDefinedResourceName" type="text" />
                    <input id="addUserDefinedResource" type="button" value="<%= CommonLabels.CreateButton %>" />
                    <div id="<%= resource.UserDefinedResources.Name %>" class="yui-skin-sam"></div>
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Accounts%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><%= AdminRoleLabels.AddAccount %></td>
                <td class="psFormCell" colspan="4">
                    <div id="accountLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">						
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= RoleResource.Meta.Accounts.Name %>" class="yui-skin-sam"></div></td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Teams%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><%= AdminRoleLabels.AddTeam %></td>
                <td class="psFormCell" colspan="4">
                    <div id="teamLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= RoleResource.Meta.Teams.Name %>" class="yui-skin-sam"></div></td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
    <polar:Includes ID="Includes1" runat="server" />

	<script type="text/javascript">
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.CheckForExtraInfo();
	        POLAR.View.Page();
	    });   

	    POLAR.View.Page = function() {
			POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Role);
			POLAR.View.Page.copyFromMenu();
			
	        autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
	            id: 'accountLookup',
	            url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
	            urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
	            propertyName: "Account",
	            resourceHolder: resource,
	            autoCompleteData: { schema: ['Name', 'City', 'PostalCode', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
	            lookupPanelData: {
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL'],
	                columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
                        { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
	            },
	            dataTableData: {
	                resourceName: "Accounts",
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL', { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate}],
	                columnDefinitions: [
		                { key: '' },
		                { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                        { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
		            ]
	            }
	        });

	        autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
	            id: 'teamLookup',
	            url: '<%= UrlHelper.GetUrl("/api/teams") %>',
	            urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
	            propertyName: "Team",
	            resourceHolder: resource,
	            autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
	            lookupPanelData: {
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL', 'AssignableTeam'],
	                columnDefinitions: [
                                { key: 'Add', formatter: 'customContact' },
	                            { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                { key: 'AssignableTeam', label: 'AssignableTeam', sortable: true, resizeable: true }
                            ]
	            },
	            dataTableData: {
	                resourceName: "Teams",
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL', 'AssignableTeam', { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate}],
	                columnDefinitions: [
				                { key: '' },
				                { key: 'ID',  label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                { key: 'AssignableTeam', label: 'AssignableTeam', sortable: true, resizeable: true },
                                { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
				            ]
	            }
	        });

	        POLAR.View.Page.resourcesDataTable = POLAR.View.Page.loadResourcesDataTable();
	        POLAR.View.Page.userDefinedResourcesDataTable = POLAR.View.Page.loadUserDefinedResourcesDataTable();

	        YAHOO.util.Event.addListener(YAHOO.util.Dom.get('addUserDefinedResource'), 'click', POLAR.View.Page.addUserDefinedResource);
	    }
	    
	    POLAR.View.Page.loadResource = function(resourceToLoad) {
			resource.Resources = resourceToLoad.Resources;
			resource.UserDefinedResources = resourceToLoad.UserDefinedResources;
			//resource.Accounts = resourceToLoad.Accounts;
			//resource.Teams = resourceToLoad.Teams;

            POLAR.View.Page.resourcesDataTable = POLAR.View.Page.loadResourcesDataTable();
	        POLAR.View.Page.userDefinedResourcesDataTable = POLAR.View.Page.loadUserDefinedResourcesDataTable();
        }
	    
	    POLAR.View.Page.copyFromMenu = function() {
            var aItemData = [            
            <% 
				foreach(Role role in roleRepository.GetAll()) 
				{ 
					%>{ text: '<%= role.Name %>', value: '<%= role.ID %>' },<%
				}
			%>
			];

            var oMenu = new YAHOO.widget.Menu("basicmenu", { position: "dynamic" });                
            oMenu.addItems(aItemData);

            var oMenuToggleButton = new YAHOO.widget.Button("copyFromButton", { type: "menu", menu: oMenu.getItems() });
            oMenuToggleButton.getMenu().subscribe("click", function(p_sType, p_aArgs) {
                oMenuItem = p_aArgs[1];
                POLAR.View.SilenceAJAX('GET', BASE_URL + 'api/role/' + oMenuItem.value, null, function(dataResponse) {
					POLAR.View.Page.loadResource(dataResponse)
                });
            }); 
        }     

	    POLAR.View.Page.addUserDefinedResource = function() {
	        var element = YAHOO.util.Dom.get('_userDefinedResourceName');
	        // klijentska validacija ovdje, ne nuno ali neka stoji...
	        //if (element.value.indexOf('{') != -1)
	        //POLAR.View.addToMessageBox('User defined resource must not contain {');
	        //else
	        //POLAR.View.getContainedObject('<%= RoleResource.Meta.UserDefinedResources.Name %>').addRow({'<%= RoleResourcePermission.Meta.Name.Name %>': element.value});
	        POLAR.View.getContainedObject('<%= RoleResource.Meta.UserDefinedResources.Name %>').addRow({ '<%= RoleResourcePermission.Meta.Name.Name %>': element.value });
	        element.value = '';
	    }

	    POLAR.View.Page.loadResourcesDataTable = function() {
	        var dataSource = new YAHOO.util.DataSource(resource);
	        dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

	        dataSource.responseSchema = {
	            resultsList: '<%= RoleResource.Meta.Resources.Name %>',
	            fields: [
			        '<%= RoleResourcePermission.Meta.Name.Name %>',
				    '<%= RoleResourcePermission.Meta.Post.Name %>',
				    '<%= RoleResourcePermission.Meta.Get.Name %>',
				    '<%= RoleResourcePermission.Meta.Put.Name %>',
				    '<%= RoleResourcePermission.Meta.Delete.Name %>',
				    '<%= RoleResourcePermission.Meta.AllowPost.Name %>',
				    '<%= RoleResourcePermission.Meta.AllowGet.Name %>',
				    '<%= RoleResourcePermission.Meta.AllowPut.Name %>',
				    '<%= RoleResourcePermission.Meta.AllowDelete.Name %>']
	        };

	        var columnDefinitions = [
				{ key: '<%= RoleResourcePermission.Meta.Name.Name %>', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true },
				{ key: '<%= RoleResourcePermission.Meta.Post.Name %>', label: '<%= CommonLabels.Post %>', sortable: true, resizeable: true, formatter: POLAR.View.disableableCheckBoxFormatter },
				{ key: '<%= RoleResourcePermission.Meta.Get.Name %>', label: '<%= CommonLabels.Get %>', sortable: true, resizeable: true, formatter: POLAR.View.disableableCheckBoxFormatter },
				{ key: '<%= RoleResourcePermission.Meta.Put.Name %>', label: '<%= CommonLabels.Put %>', sortable: true, resizeable: true, formatter: POLAR.View.disableableCheckBoxFormatter },
				{ key: '<%= RoleResourcePermission.Meta.Delete.Name %>', label: '<%= CommonLabels.Delete %>', sortable: true, resizeable: true, formatter: POLAR.View.disableableCheckBoxFormatter}];

	        var element = YAHOO.util.Dom.get('<%= RoleResource.Meta.Resources.Name %>');
	        var dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource);
	        POLAR.View.setContainedObject(element, dataTable);

	        dataTable.subscribe('checkboxClickEvent', POLAR.View.disableableCheckBoxOnClick);

	        POLAR.View.setDataTableRowReader(element, function(recordData) {
	            var data = new Object();
	            data['<%= RoleResourcePermission.Meta.Name.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Name.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Post.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Post.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Get.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Get.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Put.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Put.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Delete.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Delete.Name %>'];
	            return data;
	        });

	        return dataTable;
	    }

	    POLAR.View.Page.loadUserDefinedResourcesDataTable = function() {
	        var dataSource = new YAHOO.util.DataSource(resource);
	        dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

	        dataSource.responseSchema = {
	            resultsList: '<%= RoleResource.Meta.UserDefinedResources.Name %>',
	            fields: [
			        '<%= RoleResourcePermission.Meta.Name.Name %>',
				    '<%= RoleResourcePermission.Meta.Post.Name %>',
				    '<%= RoleResourcePermission.Meta.Get.Name %>',
				    '<%= RoleResourcePermission.Meta.Put.Name %>',
				    '<%= RoleResourcePermission.Meta.Delete.Name %>']
	        };

	        var formatRemoveRow = function(elCell, oRecord, oColumn, oData) {
	            var link = document.createElement("div");
	            link.className = 'remove';
	            elCell.appendChild(link);

	            YAHOO.util.Event.addListener(link, 'click', function(e) {
	                dataTable.deleteRow(oRecord);
	            });
	        };

	        var columnDefinitions = [
				{ key: '', width: 20, formatter: formatRemoveRow },
				{ key: '<%= RoleResourcePermission.Meta.Name.Name %>', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true },
				{ key: '<%= RoleResourcePermission.Meta.Post.Name %>', label: '<%= CommonLabels.Post %>', sortable: true, resizeable: true, formatter: POLAR.View.checkBoxFormatter },
				{ key: '<%= RoleResourcePermission.Meta.Get.Name %>', label: '<%= CommonLabels.Get %>', sortable: true, resizeable: true, formatter: POLAR.View.checkBoxFormatter },
				{ key: '<%= RoleResourcePermission.Meta.Put.Name %>', label: '<%= CommonLabels.Put %>', sortable: true, resizeable: true, formatter: POLAR.View.checkBoxFormatter },
				{ key: '<%= RoleResourcePermission.Meta.Delete.Name %>', label: '<%= CommonLabels.Delete %>', sortable: true, resizeable: true, formatter: POLAR.View.checkBoxFormatter}];

	        var element = YAHOO.util.Dom.get('<%= RoleResource.Meta.UserDefinedResources.Name %>');
	        var dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource);
	        POLAR.View.setContainedObject(element, dataTable);

	        dataTable.subscribe("checkboxClickEvent", POLAR.View.disableableCheckBoxOnClick);

	        POLAR.View.setDataTableRowReader(element, function(recordData) {
	            var data = new Object();
	            data['<%= RoleResourcePermission.Meta.Name.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Name.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Post.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Post.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Get.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Get.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Put.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Put.Name %>'];
	            data['<%= RoleResourcePermission.Meta.Delete.Name %>'] = recordData['<%= RoleResourcePermission.Meta.Delete.Name %>'];
	            return data;
	        });

	        return dataTable;
	    }
	</script>

	<script runat="server">
	    RoleResource resource;
		RoleRepository roleRepository = IoC.Container.Resolve<RoleRepository>();
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as RoleResource;
        }
    </script>
</body>
</html>
