<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <% if(0 == resource.ID.Value) {
                    %>                    
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                    else if (resource.Deleted.Value)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                </div>

            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= ServiceLevelAgreementLabels.Service %></span>
			        <span id="<%= resource.Service.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <select id="Service.ID" class="styled">
			             <option value="0"></option>
		                <% foreach (Service item in _serviceRepository.GetAll()) { %>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.Service.Value ? item.ID == resource.Service.Value.ID.Value : false) %>><%= item.Name %></option>
		                <% } %>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell psLabelRequire">
                    <span><%= ServiceLevelAgreementLabels.ServiceLevel %></span>
                    <span id="<%= resource.Service.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <select id="ServiceLevel.ID" class="styled">
                         <option value="0"></option>
		                <% foreach (ServiceLevel item in _serviceLevelRepository.GetAll()) { %>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.ServiceLevel.Value ? item.ID == resource.ServiceLevel.Value.ID.Value : false) %>><%= item.Name %></option>
		                <% } %>
	                </select>
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= ServiceLevelAgreementLabels.Description %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>"><%= resource.Description %></textarea>
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Accounts%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><%= AdminRoleLabels.AddAccount %></td>
                <td class="psFormCell" colspan="4">
                    <div id="accountLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= ServiceLevelAgreementResource.Meta.Accounts.Name %>" class="yui-skin-sam"></div></td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>;
    </script>
    <polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.CheckForExtraInfo();
   	        POLAR.View.Page();
   	    });

   	    POLAR.View.Page = function() {
   	        POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ServiceLevelAgreement);
   	        autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
   	            id: 'accountLookup',
   	            url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
   	            urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
   	            propertyName: "Account",
   	            resourceHolder: resource,
   	            autoCompleteData: { schema: ['Name', 'City', 'PostalCode', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
   	            lookupPanelData: {
   	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL'],
   	                columnDefinitions: [
                                    { key: 'Add', formatter: 'customContact' },
	                                { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                    { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                    { key: 'Email', label: 'Email', sortable: true, resizeable: true }

                                ]
   	            },
   	            dataTableData: {
   	                resourceName: "Accounts",
   	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL', { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate}],
   	                columnDefinitions: [
				                    { key: '' },
				                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                    { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                    { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                    { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
				                ]
   	            }
   	        });
        };
	</script>
</body>
</html>

<script runat="server">
    ServiceRepository _serviceRepository = IoC.Container.Resolve<ServiceRepository>();
    ServiceLevelRepository _serviceLevelRepository = IoC.Container.Resolve<ServiceLevelRepository>();

    ServiceLevelAgreementResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as ServiceLevelAgreementResource;
    }
</script>

