<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server" />
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="text-align: left">
                    <div>
                        <% if (0 == resource.ID.Value)
                        { %>                            
                            <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                            <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                        <% }
                           else if (!_IsResourceDeleted())
                        { %>
                            <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                            <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                        <% }
                        else
                        { %>
                            <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                        <% } %>
                        <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                    </div>
                </td>
                <td style="text-align: right">
                    <span class="primaryValue">
                        <%= CommonLabels.ID%>:</span>
                    <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text"
                        value="<%= resource.ID %>" readonly="readonly" />
                </td>
            <tr>
        </tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
        <colgroup>
            <col class="psColon1">
            <col>
            <col class="psColMid">
            <col class="psColon3">
            <col>
        </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span>
                        <%= CommonLabels.Name %></span> <span id="<%= resource.Name.Name + "error" %>">
                        </span>
                </td>
                <td class="psFormCell" colspan="4">
                    <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
                </td>
            </tr>

            <tr>
                <td class="psFormCell">
                    <span><%= CommonLabels.Title %></span>
                </td>
                <td class="psFormCell" colspan="4">
                    <input id="<%= resource.Title.Name %>" class="psTextbox" type="text" value="<%= resource.Title %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= CommonLabels.User%></span>
                </td>
                <td class="psFormCell">
                    <div id="userLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="userLink" href="<%= null != resource.User.Value ? resource.User.Value.URL.Value : string.Empty %>">	<%= null != resource.User.Value ? resource.User.Value.Name.Value : string.Empty %></a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"></button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span>
                        <%= CommonLabels.Team %></span> <span id="<%= resource.Team.Name + "error" %>">
                    </span>
                </td>
                <td class="psFormCell">
					<div id="teamLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="teamLink" href="<%= null != resource.Team.Value ? resource.Team.Value.URL.Value : string.Empty %>"> <%= null != resource.Team.Value ? resource.Team.Value.Name.Value : string.Empty%>  </a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"></button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
              <td class="psFormCell">
                    <%= CommonLabels.Contact%>
                </td>
                <td class="psFormCell">
					<div id="contactLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="contactLink" href="<%= null != resource.Contact.Value ? resource.Contact.Value.URL.Value : string.Empty %>"> <%= null != resource.Contact.Value ? resource.Contact.Value.Name.Value : string.Empty %>  </a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"></button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span>
                        <%= CommonLabels.Account %></span> <span id="Span1">
                    </span>
                </td>
                <td class="psFormCell">
					<div id="accountLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="accountLink" href="<%= null != resource.Account.Value ? resource.Account.Value.URL.Value : string.Empty %>"> <%= null != resource.Account.Value ? resource.Account.Value.Name.Value : string.Empty%>  </a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"></button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span>
                        <%= CommonLabels.Status%></span> <span id="<%= resource.Status.Name + "error" %>">
                        </span>
                </td>
                <td class="psFormCell">
                    <select id="Status.ID" class="styled" >
                        <% foreach (WorkOrderStatus item in _workOrderStatusRepository.GetAll())
                           { %>
                        <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.Status.Value && item.ID == resource.Status.Value.ID.Value) %>>
                            <%= item.Name %></option>
                        <% } %>
                    </select>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span>
                        <%= CommonLabels.Priority %></span> <span id="<%= resource.Priority.Name + "error" %>">
                        </span>
                </td>
                <td class="psFormCell">
                    <select id="Priority.ID" class="styled" >
                        <% foreach (Priority item in Enum.GetValues((typeof(Priority))))
                           { %>
                        <option <%= HtmlHelper.OptionSelect((long)item == resource.Priority.Value.ID.Value) %>
                            value="<%= (long)item %>">
                            <%= PriorityLabels.GetLabel(item) %></option>
                        <% } %>
                    </select>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span>
                        <%= WorkOrderLabels.Deadline %></span> <span id="<%= resource.Deadline.Name + "error" %>">
                        </span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Deadline.Name %>" class="psTextbox" type="text" value="<%= resource.Deadline.Value %>" />
                </td>
            </tr>

            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span>
                        <%= CommonLabels.Attachments %>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <div id="attachmentStrip">
                    </div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span>
                        <%= CommonLabels.Description%>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>"><%= resource.Description.Value %></textarea>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Note %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr id="note">
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>"><%= resource.Note.Value%></textarea>
                </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
		var resource = <%= _jsonResRep %>
        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
        POLAR.View.setTitleAndResourceName(resource.LabelsCommon.WorkOrderTemplate);
            POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");
            POLAR.View.AttachmentStrip(resource.Attachments, '<%= CommonLabels.Upload %>', '<%= CommonLabels.Delete %>', YAHOO.util.Dom.get('attachmentStrip'), '<%= UrlHelper.GetUrl("/api/attachment") %>');

            autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
                id: 'contactLookup',
                url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
                linkID: "contactLink",
                propertyName: "Contact",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }                
            });

            autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
                id: 'accountLookup',
                url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
                linkID: "accountLink",
                propertyName: "Account",
                resourceHolder: resource,
                autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&assignableteam=true&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },                        
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            });

            autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
                id: 'userLookup',
                url: '<%= UrlHelper.GetUrl("/api/users") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
                linkID: "userLink",
                propertyName: "User",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            });

            autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
                id: 'teamLookup',
                url: '<%= UrlHelper.GetUrl("/api/teams") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
                linkID: "teamLink",
                propertyName: "Team",
                resourceHolder: resource,
                autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&assignableteam=true&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            });
        }
    </script>

    <script runat="server">
        WorkOrderStatusRepository _workOrderStatusRepository = IoC.Container.Resolve<WorkOrderStatusRepository>();
        WorkOrderTemplateResource resource;
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as WorkOrderTemplateResource;
        }

        private bool _IsResourceDeleted()
        {
            return resource.IsDeleted.Value;
        }

        private string _HideIfResourceIsDeleted()
        {
            if (_IsResourceDeleted())
            {
                return @"style=""display:none;""";
            }
            else return "";
        }
    </script>

</body>
</html>
