<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
	    <tr>
	        <td style="text-align:left">
                <div>
                    <% if(0 == resource.ID.Value) {
                    %>
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                       else if (_businessUnitTemplateRepository.GetByID((long)resource.ID.Value).Deleted)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                    <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                </div>
	        </td>
	        <td style="text-align:right" >
	            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= AccountTemplateResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
	        </td>
		<tr>
		<tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
               <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
			    <td colspan="3">
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.AccountName%></span>
			        <span id="<%= resource.BusinessUnitName.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.BusinessUnitName.Name %>" class="psTextbox" type="text" value="<%= resource.BusinessUnitName %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.Email %></span>
                    <span id="<%= resource.Email.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Email.Name %>" class="psTextbox" type="text" value="<%= resource.Email %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.Language %></span>
                    <span id="<%= resource.Language.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <select id="Language.ID" class="styled">
                        <option value=""></option>
		                <% foreach (Language item in _languageRepository.GetAllLanguages()) {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Language.Value && item.ID == resource.Language.Value.ID.Value) %>><%= item.Name %></option>
		                <% } %>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%= BusinessUnitLabels.WebSiteUrl %></span>
			        <span id="<%= resource.WebSiteUrl.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.WebSiteUrl.Name %>" class="psTextbox" type="text" value="<%= resource.WebSiteUrl %>" />
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.AddressAndTelephones %></td>
            </tr>            
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.Street %></span>
			        <span id="<%= resource.Street.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Street.Name %>" class="psTextbox" type="text" value="<%= resource.Street %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.MainPhone %></span>
                    <span id="<%= resource.MainPhone.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.MainPhone.Name %>" class="psTextbox" type="text" value="<%= resource.MainPhone %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= BusinessUnitLabels.City %></span>
                    <span id="<%= resource.City.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.City.Name %>" class="psTextbox" type="text" value="<%= resource.City %>" />
                </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.OtherPhone %></span>
			        <span id="<%= resource.OtherPhone.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.OtherPhone.Name %>" class="psTextbox" type="text" value="<%= resource.OtherPhone %>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.StateProvince %></span>
			        <span id="<%= resource.StateProvince.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.StateProvince.Name %>" class="psTextbox" type="text" value="<%= resource.StateProvince %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.Fax %></span>
                    <span id="<%= resource.Fax.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Fax.Name %>" class="psTextbox" type="text" value="<%= resource.Fax %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= BusinessUnitLabels.PostalCode %></span>
                    <span id="<%= resource.PostalCode.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.PostalCode.Name %>" class="psTextbox" type="text" value="<%= resource.PostalCode %>" />
                </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= CommonLabels.CountryRegion %></span>
			        <span id="<%= resource.CountryRegion.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <select id="CountryRegion.ID" class="styled">
	                    <option value=""></option>
		                <% foreach (CountryRegion item in _countryRegionRepository.GetAll()) { %>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CountryRegion.Value && item.ID == resource.CountryRegion.Value.ID.Value) %>><%= item.Name %></option>
		                <% } %>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.Note %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>"><%= resource.Note%></textarea>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.AccountMembers %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell"><span><%= BusinessUnitLabels.AddMember %></span></td>
                <td class="psFormCell">
                   <div id="contactLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">						
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id=<%= AccountResource.Meta.Members.Name %> class="yui-skin-sam"></div></td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Roles %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell"><span><%= BusinessUnitLabels.AddRole%></span></td>
                <td class="psFormCell">
                   <div id="roleLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= AccountResource.Meta.Roles.Name %>" class="yui-skin-sam"></div></td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>;

        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
    <polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
			//POLAR.View.Page.membersDataTable = POLAR.View.Page.loadMembersDataTable();
			//POLAR.View.Page.rolesDataTable = POLAR.View.Page.loadRolesDataTable();
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.AccountTemplate);
		    POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");

		    autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
		        id: 'contactLookup',
		        url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
		        propertyName: "Contacts",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: '<%= CommonLabels.Name%>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: '<%= UserLabels.Email%>', sortable: true, resizeable: true }
                    ]
		        },
		        dataTableData: {
		            resourceName: "Members",
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'URL', 'Email'],
		            columnDefinitions: [
				        { key: '' },
				        { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				        { key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
				        { key: 'Email', label: '<%= UserLabels.Email%>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl }
				    ]
		        }
		    });
		    
			autoCompleteLookupRole = new POLAR.Widget.AutoCompleteLookup({
				id: 'roleLookup',
			    url: '<%= UrlHelper.GetUrl("/api/roles") %>',
			    urlItem: '<%= UrlHelper.GetUrl("/api/role/") %>',
			    propertyName: "Roles",
			    resourceHolder: resource,
			    autoCompleteData: { schema: ['Name', 'ID'], query: '?maxresults=60&textsearch={0}*' },
			    lookupPanelData: {
			        fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'URL'],
			        columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: '<%= AdminRoleLabels.RoleName%>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl }

                    ]
			    },
			    dataTableData: {
			        resourceName: "Roles",
			        fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, '<%= RoleResource.Meta.Name.Name %>', '<%= RoleResource.Meta.URL.Name %>'],
			        columnDefinitions: [
				        { key: '' },
				        { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				        { key: '<%= RoleResource.Meta.Name.Name %>', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl }
				    ]
			    }
			});
		}
	</script>

	<script runat="server">
        CountryRegionRepository _countryRegionRepository = IoC.Container.Resolve<CountryRegionRepository>();
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();
        BusinessUnitRepository _businessUnitRepository = IoC.Container.Resolve<BusinessUnitRepository>();
        BusinessUnitTemplateRepository _businessUnitTemplateRepository = IoC.Container.Resolve<BusinessUnitTemplateRepository>();
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();

		AccountTemplateResource resource;
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as AccountTemplateResource;
        }
    </script>
</body>
</html>