<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <% if(0 == resource.ID.Value) { %>
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <% } else { %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <input id="importUsers" type="button" value="<%= CommonLabels.Import %>" />
                    <% } %>
                </div>

            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID %>:</span> <input id="ID" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    </tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="Name" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= CommonLabels.Path %></span>
			    </td>
			    <td class="psFormCell">
					<input id="Path" class="psTextbox" type="text" value="<%= resource.Path %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= CommonLabels.Username %></span>
                </td>
                <td class="psFormCell">
                    <input id="Username" class="psTextbox" type="text" value="<%= resource.Username %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= CommonLabels.Filter %></span>
			    </td>
			    <td class="psFormCell">
					<input id="Filter" class="psTextbox" type="text" value="<%= resource.Filter %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= CommonLabels.Password%></span>
                </td>
                <td class="psFormCell">
                    <input id="Password" class="psTextbox" type="password" value="<%= resource.Password %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= CommonLabels.ContactTemplate%></span>
			    </td>
			    <td class="psFormCell">
					<select id="ContactTemplate.ID" class="styled">
						<option value="0"></option>
		                <%
		                	foreach (ContactTemplate template in contactTemplateRepository.GetAllNotDeletedTemplates())
							{
								%><option value="<%= template.ID %>" <%= template.ID == resource.ContactTemplate.Value.ID.Value ? "selected=\"selected\"" : string.Empty %>><%= template.Name %></option><%
							}
                    	%>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= CommonLabels.Enabled %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Enabled.Name %>" name="<%= resource.Enabled.Name %>" type="checkbox" <%= resource.Enabled.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= CommonLabels.UserTemplate%></span>
			    </td>
			    <td class="psFormCell">
					<select id="UserTemplate.ID" class="styled">
						<option value="0"></option>
		                <%
							foreach (UserTemplate template in userTemplateRepository.GetAllNotDeletedTemplates())
							{
								%><option value="<%= template.ID %>" <%= template.ID == resource.UserTemplate.Value.ID.Value ? "selected=\"selected\"" : string.Empty %>><%= template.Name %></option><%
							}
                    	%>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= CommonLabels.Translation %></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell" colspan="5">
					<div id="translationTable">
						<table border="0" cellpadding="0" cellspacing="0">
							<tbody class="ps-translationtable-rows">
								<tr>
									<td>Help Desk</td>
									<td>Active Directory</td>
									<td>Domain Name</td>
								</tr>
								<tr class="ps-translationtable-row" style="visibility: hidden">
									<td><input class="ps-translationtable-helpdeskfield" readonly type="text" value="" /></td>
									<td><input class="ps-translationtable-activedirectoryfield psTextbox" type="text" value="" /></td>
									<td class="ps-translationtable-methods" style="visibility: hidden;">
										<input class="ps-translationtable-domainname psTextbox" type="text" value="" />
										<!--<input class="ps-translationtable-automaticdomainnamedetection" type="checkbox" /> Use automatic domain name detection-->
									</td>
								</tr>
							</tbody>
						</table>
						Translation table instructs the ActiveDirectory import on how to convert ActiveDirectory fields into HelpDesk fields. Grayed text boxes are the HelpDesk fields while the white text boxes are ActiveDirectory fields. ActiveDirectory fields correspond to ActiveDirectory User object properties you wish to read.
						<br />
						<br />
						UserName HelpDesk field is specific in that it can be made to correspond exactly to the ActiveDirectory username. What this means is that UserName can be imported as regular username ("myUserName") or as full ActiveDirectory username ("DOMAIN\myUserName"). Full ActiveDirectory username is required if you wish to use automatic ActiveDirectory login for your users.
						<input id="Translation" class="ps-translationtable-translation psTextbox" type="hidden" value="<%= resource.Translation %>" />
					</div>
			    </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.addListener(window, 'load', function() {
   	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ActiveDirectoryImportSchema);
			var translationTable = new POLAR.View.TranslationTable(YAHOO.util.Dom.get('translationTable'), [
				{ to: 'UserName', method: resource.Domain },
				{ to: 'Email' },
				{ to: 'FirstName' },
				{ to: 'LastName' },
				{ to: 'Title' },
				{ to: 'Office' },
				{ to: 'Description' },
				{ to: 'WebPage' },
				{ to: 'Street' },
				{ to: 'City' },
				{ to: 'StateProvince' },
				{ to: 'PoBox' },
				{ to: 'ZipPostalCode' },
				{ to: 'TelephoneNumber' },
				{ to: 'TelephoneHome' },
				{ to: 'TelephonePage' },
				{ to: 'TelephoneMobile' },
				{ to: 'TelephoneFax' },
				{ to: 'Notes' }
			]);

            var oCreateButton = new YAHOO.widget.Button("importUsers");
		    $("#importUsers").click(function() {
                POLAR.View.TopWorkingStart();
			    var url = '<%= UrlHelper.GetUrl("/api/activedirectoryimportschema/") %>' + resource.ID;
                var transaction = YAHOO.util.Connect.asyncRequest('POST', url, POLAR.View.requestCallback);
		    });
			
			$("#UserTemplate\\.ID").change(function() {
				if($("#UserTemplate\\.ID").val() != "0") {
					$("#ContactTemplate\\.ID").val(0);
				}
			});
			
			$("#ContactTemplate\\.ID").change(function() {
				if($("#ContactTemplate\\.ID").val() != "0") {
					$("#UserTemplate\\.ID").val(0);
				}
			});
		};
	</script>

	<script runat="server">
		ActiveDirectoryImportSchemaResource resource;
		ContactTemplateRepository contactTemplateRepository = IoC.Container.Resolve<ContactTemplateRepository>();
		UserTemplateRepository userTemplateRepository = IoC.Container.Resolve<UserTemplateRepository>();
        string _jsonResRep;

		protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as ActiveDirectoryImportSchemaResource;
		}
	</script>
</body>
</html>