<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <polar:CssIncludes runat="server" />
</head>
<body class="yui-skin-sam">
    <polar:Navigation ID="Navigation1" runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
        <div class="desktopTable">
            <div class="desktopTableActions">
                <div id="toolbar"></div>
            </div>
            <div id="dataTableContainer" class="yui-skin-sam"></div>
        </div>
    </div>
    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>;
    </script>
    <polar:Includes ID="Includes1" runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
        //YAHOO.util.Event.onDOMReady(function() {
        YAHOO.util.Event.addListener(window, "load", function() {
            POLAR.View.Initialization();
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Bookmarks);
            var evalResourceRep = POLAR.View.evalDataInResourceRepresentation(resource);
            var dataSource = new YAHOO.util.DataSource(evalResourceRep);  //var dataSource = new YAHOO.util.DataSource(resource);
            dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

            if (evalResourceRep.Items.length == 0) {
                $('#messagebox').empty();
                $('#messagebox').append("No deleted reports");
                $('#messagebox').show("fast");
                return;
            }
            else {
                var index = resource.URL.lastIndexOf("deleted", (resource.URL.length - "deleted".length))// do not do if links URI is /reportedit/{ReportName}/deleted or New report
                if (index == -1) {
                    //$("#toolbar").append("<input id='deleteButton' type='button' value='<%= CommonLabels.DeleteButton %>' />");
                    $("#toolbar").append("<input id='deleteButton' type='button'/>");
                    $("#deleteButton").val(resource.LabelsCommon.DeleteButton + "NOT WORKING JEY");
                }
                else {
                    //$("#toolbar").append("<input id='undeleteButton' type='button' value='<%= CommonLabels.UndeleteButton %>' />");
                    $("#toolbar").append("<input id='undeleteButton' type='button'/>");
                    $("#undeleteButton").val(resource.LabelsCommon.UndeleteButton);
                }
            }
            var item = evalResourceRep.Items[0]; //take first report form list for item.GetPropertyName("Data.Title")
            POLAR.View.SetPropertyNameToObject(item);

            dataSource.responseSchema = {
                resultsList: 'Items',
                fields: [
                    { key: item.GetPropertyName("ID"), parser: YAHOO.util.DataSource.parseNumber },
                    { key: item.GetPropertyName("Data.Title"), parser: POLAR.View.titleParser },
        		    item.GetPropertyName("URL"),
        		    { key: item.GetPropertyName("CreatedOn"), parser: POLAR.View.DateTime.stringToDate }
        		    ]
            };

            var formatNamespace = function(elCell, oRecord, oColumn, sData) {
                elCell.innerHTML = '<a href=' + oRecord.getData('NamespaceURL') + '>' + sData + '</a>';
            };

            dataTable = new YAHOO.widget.DataTable(
                'dataTableContainer',
                [
				    { label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				    { key: item.GetPropertyName("ID"), label: resource.LabelsCommon.ID, sortable: true, resizeable: true },
				    { key: 'Data.Title', label: resource.Labels.Title, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				    { key: item.GetPropertyName("CreatedOn"), label: resource.LabelsCommon.Created, sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			    ],
			    dataSource,
			    {
			        sortedBy: { key: item.GetPropertyName("CreatedOn"), dir: YAHOO.widget.DataTable.CLASS_DESC },
			        draggableColumns: true,
			        paginator: POLAR.View.DataTable.createDefaultPaginator()
			    }
	        );

            POLAR.View.DataTable.configDataTable(dataTable);

            POLAR.View.DataTable.configDeleteUndelete({
                dataTable: dataTable,
                dataTableItems: resource.Items,
                dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
                dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
            });

            ////POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
            //set with on first and second colon for beter visula efect
            $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');

        };
    </script>

    <script runat="server">
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>
