<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
		    <tr>
		        <td style="text-align:left">
		            <div>
		                <%
                            if (0 == resource.ID.Value)
                            {
                                %>
									<input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
									<input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                                <%
                            }
                            else
                            {
								if ((_dataRepository.GetByID(typeof(ContactUser), (long)resource.ID.Value) as ContactUser).Deleted)
								{
									%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
								}
								else
								{
									%>
										<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
										<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
									<%
								}
                            }
                        %>
                        <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                    </div>

		        </td>
		        <td style="text-align:right">
		            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
		        </td>
			</tr>
		</tbody>
    </table>
    </div>
	<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire"><span><%=ContactLabels.ContactName%></span></span></td><td class="psFormCell"><input id="<%=resource.UserName.Name%>" class="psTextbox"  type="text" value="<%=resource.UserName%>" /></td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=ContactLabels.Email%></td>	<td class="psFormCell"></span>  <input id="<%=resource.Email.Name%>" class="psTextbox"  type="text" value="<%=resource.Email%>" /></td>
            </tr>

            <tr>
                <td class="psFormCell">   <span><%=ContactLabels.ContactFirstName%></span> <span id="<%=resource.FirstName.Name + "error"%>"></span> </td>    <td class="psFormCell"><input id="<%=resource.FirstName.Name%>" size="50" class="psTextbox"  type="text" value="<%=resource.FirstName%>" /> </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=ContactLabels.WebPage%> </td>   <td class="psFormCell"></span>  <input id="<%=resource.WebPage.Name%>" class="psTextbox"  type="text" value="<%=resource.WebPage%>" /> </td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=ContactLabels.ContactLastName%></span> <span id="<%=resource.LastName.Name + "error"%>"></span> </td>    <td class="psFormCell"><input id="<%=resource.LastName.Name%>" class="psTextbox"  type="text" value="<%=resource.LastName%>" /> </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=ContactLabels.Title%></span> </td>	 <td class="psFormCell"><input id="<%=resource.Title.Name%>" class="psTextbox"  type="text" value="<%=resource.Title%>" /></td>			    
            </tr>

			<tr>
                <td class="psFormCell psLabelRequire"><span><%=UserLabels.Password%></span> </td> <td class="psFormCell"><input id="<%=resource.Password.Name%>" class="psTextbox"  type="text" value="<%=resource.Password%>" /> </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			    </td>
			    <td class="psFormCell">
				</td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="2"><%=ContactLabels.Telephones%></td>
				<td class="psFormMid"></td>
			    <td class="psFormCell psBar" colSpan="2"><%=ContactLabels.Address%></td>
            </tr>                
            <tr class="psAfterBar" ><td></td></tr>                
            <tr>
                <td class="psFormCell"><span><%=ContactLabels.TelephoneNumber%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneNumber.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneNumber%>" />   </td>
				<td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=ContactLabels.Street%></td>   <td class="psFormCell"></span>  <input id="<%=resource.Street.Name%>" class="psTextbox"  type="text" value="<%=resource.Street%>" /></td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=ContactLabels.TelephoneHome%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneHome.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneHome  %>" />     </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=ContactLabels.City%></td><td class="psFormCell"></span>  <input id="<%=resource.City.Name%>" class="psTextbox"  type="text" value="<%=resource.City%>" />                         </td>
            <tr>
            </tr>
                <td class="psFormCell"><span><%=ContactLabels.TelephoneMobile%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneMobile.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneMobile%>" />   </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=ContactLabels.StateProvince%></td><td class="psFormCell"></span>  <input id="<%=resource.StateProvince.Name%>" class="psTextbox"  type="text" value="<%=resource.StateProvince  %>" />     </td>
            <tr>
            </tr>
                <td class="psFormCell"><span><%=ContactLabels.TelephonePage%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephonePage.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephonePage  %>" />     </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=ContactLabels.ZipPostalCode%></td><td class="psFormCell"></span>  <input id="<%=resource.ZipPostalCode.Name%>" class="psTextbox"  type="text" value="<%=resource.ZipPostalCode  %>" />     </td>
            <tr>

            <tr>
			    <td class="psFormCell"><span><%=ContactLabels.TelephoneFax%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneFax.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneFax   %>" />      </td>
				<td class="psFormMid"></td>
			    <td class="psFormCell"><span><%= CommonLabels.CountryRegion%></span></td>
			    <td class="psFormCell">
			        <select id="CountryRegion.ID" class="styled">
		                <option value=""></option>
		                <% foreach (CountryRegion item in _countryRegionRepository.GetAll())
                     {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CountryRegion.Value && item.ID == resource.CountryRegion.Value.ID.Value) %>><%= item.Name%></option>
		                <% } %>
	                </select>
			    </td>
            </tr>            
            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=CommonLabels.Account%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="Accounts" class="yui-skin-sam"></div></td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=ContactLabels.PrimaryAccount%></span></td>
                <td class="psFormCell">
					<select id="PrimaryAccountID" class="styled">
		                <option value="0"></option>
		                <% 
		                	foreach (var item in resource.Accounts.Value)
							{
								%><option value="<%= item.ID.Value %>" <%= HtmlHelper.OptionSelect(item.ID.Value == resource.PrimaryAccountID.Value) %>><%= item.Name.Value %></option><% 
							} 
                    	%>
	                </select>
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell">					
				</td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.Token %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><span><%= UserLabels.UserAPIToken %></span></td>
                <td class="psFormCell" colspan="4">
					<input id="Token" type="text" class="psTextbox"  value="<%= resource.Token %>" />
					<input id="generatetoken" type="button" value="<%= UserLabels.GenerateNewToken %>" />
					<input id="removetoken" type="button" value="<%= UserLabels.RemoveToken %>" />
				</td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.ProfileStatus%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><span><%= UserLabels.ReceiveEmails%></span></td>
                <td class="psFormCell"><input id="<%=resource.ReceiveEmails.Name %>" name="<%= resource.ReceiveEmails.Name %>" type="checkbox" <%= resource.ReceiveEmails.Value ? "checked" : string.Empty %> /> </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
			    <td class="psFormCell"><span><%= UserLabels.Language%></span></td>
			    <td class="psFormCell">
			        <select id="Language.ID" class="styled">
		                <option value="" ></option>
		                <% foreach (Language item in _languageRepository.GetAllLanguages())
						{%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Language.Value && item.ID == resource.Language.Value.ID.Value) %>><%= item.Name%></option>
		                <% } %>
	                </select>
			    </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=ContactLabels.Description%></span></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>            
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><textarea class="psTextarea expand25-350 resizable" id="<%=resource.Description.Name%>" ><%=resource.Description%></textarea></td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5">
					<span><%= ContactLabels.IncidentsContact %></span>
				</td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
			    <td id="IncidentsContact" class="psFormCell" colspan="4">					
				</td>
            </tr>
       </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%> ;
        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Contact);
		    POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");
            POLAR.View.Page.accountsDataTable = POLAR.View.Page.loadAccountsDataTable();
		    var button = new YAHOO.widget.Button("generatetoken");
            button.on("click", function() {
                $("#Token").attr("value", POLAR.View.Page.createUUID());
            });

            var button = new YAHOO.widget.Button("removetoken");
            button.on("click", function() {
				$("#Token").attr("value", '');
            });

            var url = UserResourcePermissions.VirtualUrl + '/incidents?contact=' + resource.ID;
            $("#IncidentsContact").append("<a href=" + url + ">" + url + "</a>");
            
            
		};

		POLAR.View.Page.createUUID = function() {
			// http://www.ietf.org/rfc/rfc4122.txt
			var s = [];
			var hexDigits = "0123456789ABCDEF";
			for (var i = 0; i < 32; i++) {
				s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
			}
			s[12] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
			s[16] = hexDigits.substr((s[16] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01

			var uuid = s.join("");
			return uuid;
		}

		POLAR.View.Page.addAccount = function(id) {
	        var url = '<%= UrlHelper.GetUrl("/api/account/") %>' + id;
		    POLAR.View.asyncGet(url, function(account) {
		    POLAR.View.Page.accountsDataTable.addRow({ '<%= AccountResource.Meta.ID.Name %>': account['<%= AccountResource.Meta.ID.Name %>'], '<%= AccountResource.Meta.Name.Name %>': account['<%= AccountResource.Meta.Name.Name %>'], '<%= AccountResource.Meta.Division.Name %>': account['<%= AccountResource.Meta.Division.Name %>'], '<%= AccountResource.Meta.URL.Name %>': account['<%= AccountResource.Meta.URL.Name %>'] });
		    });
	    };

	    var dataTable;  //MUST be outside of function for proper working of select all javascipt code -> onclick = "POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)"
		POLAR.View.Page.loadAccountsDataTable = function() {
			var dataSource = new YAHOO.util.DataSource(resource);
			dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

			dataSource.responseSchema =
			{
			    resultsList: '<%= resource.Accounts.Name%>',
			    fields:
			    [
				    { key: '<%= AccountResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber },
				    '<%= AccountResource.Meta.Name.Name %>',
				    '<%= AccountResource.Meta.URL.Name %>'
			    ]
            };

			var columnDefinitions =
			[
				{ key: '<%= AccountResource.Meta.ID.Name %>', sortable: true, className: "colwidth2", label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				{ key: '<%= AccountResource.Meta.Name.Name %>', sortable: true, className: "colwidth2", label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl }
			];

            var configs = {
    		      draggableColumns:true
        	};

        	var element = YAHOO.util.Dom.get('<%= resource.Accounts.Name%>');
			dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource, configs );
			POLAR.View.setContainedObject(element, dataTable);

			POLAR.View.setDataTableRowReader(element, function(recordData){
			    var data = new Object();
			    data['<%= AccountResource.Meta.ID.Name %>'] = recordData['<%= AccountResource.Meta.ID.Name %>'];
			    return data;
			});

			$("#Accounts table colgroup col:lt(1)").css('width', '10px');
			return dataTable;
		};

        YAHOO.util.Event.addListener(window, 'load', showTables);
        function showTables() {
            if (resource.IncidentsItems != null) {
                var dataSource = new YAHOO.util.DataSource(resource.IncidentsItems);
                showTable1(dataSource, '_dataTableContainer1');
            }
            if (resource.AssignedIncidentsItems != null) {
                var dataSource = new YAHOO.util.DataSource(resource.AssignedIncidentsItems);
                showTable1(dataSource, '_dataTableContainer2');
            }
        }

        function showTable1(dataSource, dataTableContainer) {
		    dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

            var myFormatDate = function(elCell, oRecord, oColumn, oDate) {
	            elCell.innerHTML = 1 + oDate.getMonth() + "/" + oDate.getDate()  + "/" + oDate.getFullYear() + " " + oDate.getHours() + ":" + oDate.getMinutes();
	        };

		    this.formatUrlUser = function(elCell, oRecord, oColumn, sData) {
			    elCell.innerHTML = '<a href=' + oRecord.getData('Contact.URL') + '>' + sData + '</a>';
		    };

		    dataSource.responseSchema = {
		        fields: [
			        {key:'<%= IncidentResource.Meta.ID.Name %>', parser:YAHOO.util.DataSource.parseNumber},
			        '<%= IncidentResource.Meta.Title.Name %>',
			        '<%= IncidentResource.Meta.URL.Name %>',
			        'Contact.UserName','Contact', 'Contact.URL', 'User.UserName', 'Status.Name', 'Priority.Name',
			        { key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', parser: YAHOO.util.DataSource.parseDate}]
			    };
            var configs = {
            sortedBy: { key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
		        draggableColumns:true
        	};
		    var columnDefinitions = [
			    {key:'<%= IncidentResource.Meta.ID.Name %>', width:20, label:'<%= CommonLabels.ID %>', sortable:true, formatter:'number', sortOptions:{defaultOrder:'desc'}, resizeable:true},
			    {key: '<%= IncidentResource.Meta.Title.Name %>', label: '<%= CommonLabels.Title %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
 			    {key:'Contact.UserName', label:'<%= IncidentLabels.Contact %>', sortable:true, resizeable:true, formatter:this.formatUrlUser},
		        {key:'User.UserName', label:'<%= IncidentLabels.User %>', sortable:true, resizeable:true},
		        {key:'Status.Name', label:'<%= IncidentLabels.IncidentStatus %>', sortable:true, resizeable:true},
		        {key:'Priority.Name', label:'<%= IncidentLabels.IncidentPriority %>', sortable:true, resizeable:true},
		        {key: '<%= IncidentResource.Meta.ModifiedOn.Name %>', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: myFormatDate}];

		   dataTable = new YAHOO.widget.DataTable(dataTableContainer, columnDefinitions, dataSource, configs);
	    }
    </script>

    <script runat="server">
        CountryRegionRepository _countryRegionRepository = IoC.Container.Resolve<CountryRegionRepository>();
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();
		IDataRepository _dataRepository = IoC.Container.Resolve<IDataRepository>();
        ContactResource resource;
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();
            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as ContactResource;
        }
    </script>

</body>
</html>
