<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= DocumentLabels.DocumentHistory %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    </div>
    <!--<table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
	        <tr>
	            <td style="text-align:left">
	                <div>
	                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.RestoreButton %>" />
                    </div>
	            </td>
	            <td style="text-align:right" >
	                <span class="primaryValue"><%= CommonLabels.ID%>:</span>
	                <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
	            </td>
		    </tr>
		</tbody>
    </table>-->
	<b><%= resource.Title %></b><br />
    <%
        foreach (var item in resource.Attachments.Value)
        {
            %><a href="<%= item.URI %>"><%= item.Name %></a>, <%
        }
    %>    
	<p><%= resource.Body %></p>
    </div>
    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.addListener(window, 'load', function() {
   	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.DocumentHistory);

		}
	</script>
</body>
</html>

<script runat="server">
    DocumentHistoryResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as DocumentHistoryResource;
    }
</script>