<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= EmailNotificationLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <% if(0 == resource.ID.Value) {
                    %>                    
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                    else if (resource.Deleted.Value)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                </div>
            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			    </td>
			    <td class="psFormCell" colspan="7">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="8"><span><%= EmailNotificationLabels.Notifications %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell" rowspan="3">
                    <span><%= EmailNotificationLabels.AutomationSettings%></span>
                </td>
				<td class="psFormCell"></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.Contact %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.CurrentUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.AssignedBusinessUnitMembers %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.OldUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.OldAssignedBusinessUnitMembers %></span></td>
				<td class="psFormCell" rowspan="2">
				</td>
			</tr>
            	    
		    <tr>
				<td class="psFormCell"><span><%= EmailNotificationLabels.IncidentCreatedFromEmail%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CreatedFromEmail.Name + "." + NotificationRecipientsCreatedFromEmailResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CreatedFromEmail.Name + "." + NotificationRecipientsCreatedFromEmailResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.CreatedFromEmail.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CreatedFromEmail.Name + "." + NotificationRecipientsCreatedFromEmailResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CreatedFromEmail.Name + "." + NotificationRecipientsCreatedFromEmailResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.CreatedFromEmail.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CreatedFromEmail.Name + "." + NotificationRecipientsCreatedFromEmailResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CreatedFromEmail.Name + "." + NotificationRecipientsCreatedFromEmailResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.CreatedFromEmail.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
		    </tr>
		    
		     <tr>
				<td class="psFormCell"><span><%= EmailNotificationLabels.IncidentUpdatedFromEmail%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.UpdatedFromEmail.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.UpdatedFromEmail.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.UpdatedFromEmail.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.OldAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.OldAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.UpdatedFromEmail.Value.OldAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.OldTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.UpdatedFromEmail.Name + "." + NotificationRecipientsUpdatedFromEmailResource.Meta.OldTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.UpdatedFromEmail.Value.OldTeamMembers.Value ? "checked" : string.Empty %> /></td>
		    </tr>
		    
		    <tr>
			    <td class="psFormCell psBar" colspan="8"></td>
            </tr>

            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell" rowspan="2">
                    <span><%= EmailNotificationLabels.NotificationsSentBasedOnIncidentEvents %></span>
                </td>
				<td class="psFormCell"></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.Contact %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.CurrentUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.AssignedBusinessUnitMembers %></span></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
				<td class="psFormCell" rowspan="2">
					<select id="IncidentCreatedEmailTemplate.ID" class="styled">
						<%
							foreach (EmailTemplate item in emailTemplateRepository.GetAll())
							{
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.IncidentCreatedEmailTemplate.Value && item.ID == resource.IncidentCreatedEmailTemplate.Value.ID.Value) %>><%= item.Name%></option><%
							}
						%>
					</select>
				</td>
			</tr>
            
            <tr>
				<td class="psFormCell"><span><%= EmailNotificationLabels.IncidentCreated %></span></td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentCreatedServiceUser.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentCreatedServiceUser.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentCreatedServiceUser.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentCreatedCurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentCreatedCurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentCreatedCurrentAssignee.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentCreatedAssignedBusinessUnitMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentCreatedAssignedBusinessUnitMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentCreatedAssignedBusinessUnitMembers.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
		    </tr>

		    <tr>
			    <td class="psFormCell psBar" colspan="8"></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
		    <tr>
				<td class="psFormCell" rowspan="4">
					<span><%= EmailNotificationLabels.NotificationsSentWhenIncidentPropertiesAreChanged%></span>
				</td>
				<td class="psFormCell"></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.Contact %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.CurrentUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.AssignedBusinessUnitMembers %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.OldUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.OldAssignedBusinessUnitMembers %></span></td>
				<td class="psFormCell" rowspan="4">
					<select id="IncidentUpdatedEmailTemplate.ID" class="styled">
						<%
							foreach (EmailTemplate item in emailTemplateRepository.GetAll())
							{
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.IncidentUpdatedEmailTemplate.Value && item.ID == resource.IncidentUpdatedEmailTemplate.Value.ID.Value) %>><%= item.Name%></option><%
							}
						%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= EmailNotificationLabels.IncidentUserChanged%></span></td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedServiceUser.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedServiceUser.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentAssigneeChangedServiceUser.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedCurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedCurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentAssigneeChangedCurrentAssignee.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedAssignedBusinessUnitMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedAssignedBusinessUnitMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentAssigneeChangedAssignedBusinessUnitMembers.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedOldAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentAssigneeChangedOldAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentAssigneeChangedOldAssignee.Value ? "checked" : string.Empty %> />
				</td>	
				<td></td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= EmailNotificationLabels.IncidentBusinessUnitChanged%></span></td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedServiceUser.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedServiceUser.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentBusinessUnitChangedServiceUser.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedCurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedCurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentBusinessUnitChangedCurrentAssignee.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedAssignedBusinessUnitMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedAssignedBusinessUnitMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentBusinessUnitChangedAssignedBusinessUnitMembers.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedOldAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedOldAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentBusinessUnitChangedOldAssignee.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedOldAssignedBusinessUnitMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentBusinessUnitChangedOldAssignedBusinessUnitMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentBusinessUnitChangedOldAssignedBusinessUnitMembers.Value ? "checked" : string.Empty %> />
				</td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= EmailNotificationLabels.IncidentUpdated%></span></td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentUpdatedServiceUser.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentUpdatedServiceUser.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentUpdatedServiceUser.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentUpdatedCurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentUpdatedCurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentUpdatedCurrentAssignee.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
					<input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentUpdatedAssignedBusinessUnitMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentUpdatedAssignedBusinessUnitMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentUpdatedAssignedBusinessUnitMembers.Value ? "checked" : string.Empty %> />
				</td>
				<td class="psFormCell">
				</td>
				<td></td>
			</tr>
			<tr>
			    <td class="psFormCell psBar" colspan="7"></td>
			    <td></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
			<tr>
				<td class="psFormCell" rowspan="7"><span><%= EmailNotificationLabels.IncidentStatusChangedTo%></span></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.Contact %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.CurrentUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.AssignedBusinessUnitMembers %></span></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span id="labelNew"></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserNew.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserNew.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusServiceUserNew.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeNew.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeNew.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusCurrentAssigneeNew.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersNew.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersNew.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusAssignedBusinessUnitMembersNew.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span id="labelInProgress"></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserInProgress.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserInProgress.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusServiceUserInProgress.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeInProgress.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeInProgress.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusCurrentAssigneeInProgress.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersInProgress.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersInProgress.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusAssignedBusinessUnitMembersInProgress.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span id="labelWaiting"></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserWaiting.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserWaiting.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusServiceUserWaiting.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeWaiting.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeWaiting.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusCurrentAssigneeWaiting.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersWaiting.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersWaiting.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusAssignedBusinessUnitMembersWaiting.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span id="labelResolved"</span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserCompleted.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserCompleted.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusServiceUserCompleted.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeResolved.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeResolved.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusCurrentAssigneeResolved.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersResolved.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersResolved.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusAssignedBusinessUnitMembersResolved.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span id="labelCompleted"</span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserResolved.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserResolved.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusServiceUserResolved.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeCompleted.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeCompleted.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusCurrentAssigneeCompleted.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersCompleted.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersCompleted.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusAssignedBusinessUnitMembersCompleted.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span id="labelClosed"</span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserClosed.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusServiceUserClosed.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusServiceUserClosed.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeClosed.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusCurrentAssigneeClosed.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusCurrentAssigneeClosed.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersClosed.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.IncidentStatusAssignedBusinessUnitMembersClosed.Name %> %>" type="checkbox" <%= resource.Notifications.Value.IncidentStatusAssignedBusinessUnitMembersClosed.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
			    <td class="psFormCell psBar" colspan="7"></td>
			    <td></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
				<td class="psFormCell" rowspan="7"><span><%= EmailNotificationLabels.NotificationsSentForPriorityEscalations %></span></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.Contact %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.CurrentUser %></span></td>
				<td class="psFormCell"><span><%= EmailNotificationLabels.AssignedBusinessUnitMembers %></span></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
				<td class="psFormCell"><span><%= ServiceLevelLabels.PlanningPriority %></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.PlanningPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.PlanningPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.PlanningPriorityEscalation.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.PlanningPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.PlanningPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.PlanningPriorityEscalation.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.PlanningPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.PlanningPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.PlanningPriorityEscalation.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= ServiceLevelLabels.LowPriority%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.LowPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.LowPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.LowPriorityEscalation.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.LowPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.LowPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.LowPriorityEscalation.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.LowPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.LowPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.LowPriorityEscalation.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= ServiceLevelLabels.MediumPriority%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.MediumPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.MediumPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.MediumPriorityEscalation.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.MediumPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.MediumPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.MediumPriorityEscalation.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.MediumPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.MediumPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.MediumPriorityEscalation.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= ServiceLevelLabels.HighPriority%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.HighPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.HighPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.HighPriorityEscalation.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.HighPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.HighPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.HighPriorityEscalation.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.HighPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.HighPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.HighPriorityEscalation.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= ServiceLevelLabels.CriticalPriority%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CriticalPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CriticalPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.CriticalPriorityEscalation.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CriticalPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CriticalPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.CriticalPriorityEscalation.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CriticalPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.CriticalPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.CriticalPriorityEscalation.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<tr>
				<td class="psFormCell"><span><%= ServiceLevelLabels.BrokenSLAPriority%></span></td>
				<td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.BrokenSLAPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.BrokenSLAPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.Contact.Name %> %>" type="checkbox" <%= resource.Notifications.Value.BrokenSLAPriorityEscalation.Value.Contact.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.BrokenSLAPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.BrokenSLAPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentAssignee.Name %> %>" type="checkbox" <%= resource.Notifications.Value.BrokenSLAPriorityEscalation.Value.CurrentAssignee.Value ? "checked" : string.Empty %> /></td>
                <td class="psFormCell"><input id="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.BrokenSLAPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %>" name="<%= EmailNotificationResource.Meta.Notifications.Name + "." + NotificationRecipientsResource.Meta.BrokenSLAPriorityEscalation.Name + "." + NotificationRecipientsPriorityEscalationResource.Meta.CurrentTeamMembers.Name %> %>" type="checkbox" <%= resource.Notifications.Value.BrokenSLAPriorityEscalation.Value.CurrentTeamMembers.Value ? "checked" : string.Empty %> /></td>
				<td class="psFormCell"></td>
				<td class="psFormCell"></td>
			</tr>
			<!--
			<tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Teams%></td>
            </tr>
            <tr>
                <td class="psFormCell"><%= AdminRoleLabels.AddTeam %></td>
                <td class="psFormCell" colspan="4">
                    <div id="teamLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td >
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td>
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">
							<div class="hd"><%= CommonLabels.Teams%></div>
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= RoleResource.Meta.Teams.Name %>" class="yui-skin-sam"></div></td>
            </tr>-->
        </tbody>
    </table>

    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

    <script type="text/javascript">
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.EmailNotification);
            $("#labelNew").text("<%= StatusLabels.New %>");
            $("#labelInProgress").text("<%= StatusLabels.InProgress %>");
            $("#labelWaiting").text("<%= StatusLabels.Waiting %>");
            $("#labelResolved").text("<%= StatusLabels.Resolved %>");
            $("#labelCompleted").text("<%= StatusLabels.Completed %>");
            $("#labelClosed").text("<%= StatusLabels.Closed %>");

            /*autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
	            id: 'teamLookup',
	            url: '<%= UrlHelper.GetUrl("/api/teams") %>',
	            urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
	            propertyName: "Team",
	            resourceHolder: resource,
	            autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
	            lookupPanelData: {
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL', 'AssignableTeam'],
	                columnDefinitions: [
                                { key: 'Add', formatter: 'customContact' },
	                            { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                { key: 'AssignableTeam', label: 'AssignableTeam', sortable: true, resizeable: true }
                            ]
	            },
	            dataTableData: {
	                resourceName: "Teams",
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL', 'AssignableTeam', { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate}],
	                columnDefinitions: [
				                { key: '' },
				                { key: 'ID',  label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                { key: 'AssignableTeam', label: 'AssignableTeam', sortable: true, resizeable: true },
                                { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
				            ]
	            }
	        });*/
        }

	</script>
</body>
</html>

<script runat="server">
    EmailNotificationResource resource;
    string _jsonResRep;

	EmailTemplateRepository emailTemplateRepository = IoC.Container.Resolve<EmailTemplateRepository>();

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as EmailNotificationResource;
    }
</script>