<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.Infrastructure.ResourceHandlers"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
	    <tr>
	        <td style="text-align:left">
	            <div>
					<%
                        if (0 == resource.ID.Value)
                        {
                            %>
                            <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                            <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" /><%
                        }
                        else
                        {
							if (_incidentRepository.GetByID((long)resource.ID.Value).Deleted)
							{
								%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
							}
							else
							{
								%>
									<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
									<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
								<%
							}
                        }
                    %>
                </div>

	        </td>
	        <td style="text-align:right" >
	            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
	        </td>
		<tr>
		<tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= CommonLabels.Title %></span>
                    <span id="<%= resource.Title.Name + "error" %>"></span>
                </td>
                <td class="psFormCell" colspan="4">
                    <input id="<%= resource.Title.Name %>" class="psTextbox" type="text" value="<%= resource.Title %>" />
                </td>
            </tr>

            <tr>
                <td class="psFormCell">
                    <span><%= IncidentLabels.IncidentStatus %></span>
                    <span id="Span2"></span>
                </td>
                <td class="psFormCell">
                    <%
                        foreach (Status item in Enum.GetValues(typeof(Status)))
                        {
                            if((long)item == resource.Status.Value.ID.Value)
                            {
                                %><input class="psTextbox" type="text" value="<%= StatusLabels.GetLabel(item) %>" readonly="readonly" /><%
                                break;
                            }
                        }
                    %>
                </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
                <% if(showContact) { %>
					<span><%= IncidentLabels.Contact %></span>
				<% } %>
                </td>
                <td class="psFormCell">
                <% if(showContact) { %>
				<input class="psTextbox" type="text" value="<%= resource.Contact == null ? "" : resource.Contact.Value.Name.Value %>" readonly="readonly" />
				<% } %>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= CommonLabels.Attachments %></span>
                    <span id="<%= resource.Attachments.Name + "error" %>"></span>
                </td>
                <td class="psFormCell" colspan="4">
                    <div id="attachmentStrip"></div>
                    <span id="uploadFailed"  style="visibility: hidden"><%= CommonLabels.UploadFailedMessage%></span>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBarNoBorder" colspan="5"><span><%= IncidentLabels.IncidentDescription %></td>
            </tr>            
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>"><%= resource.Description %></textarea>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBarNoBorder" colspan="5">
                    <span><%= CommonLabels.ConversationHistory %></span>
                </td>
            </tr>
            <tr>
            <td class="psFormCell" colspan="5">
                <div id="conversation">
					<div class="ps-conversation-rows">
						<div class="ps-conversation-template" style="visibility: hidden;">
						    <div class="conversation-head">
						    <!-- <%= CommonLabels.PostedBy %> --> <a class="ps-conversation-postedby-urn"><span class="ps-conversation-postedby-name"></span></a>
									 - ( <span class="ps-conversation-postedon convpostedon"></span> )
						    </div>
						    <div class="con-gr1" ></div>					   
						    
							<table class="conversation-body" style="width: 100%;" cellpadding="0" cellspacing="0">
								<!-- <tr class="">
									<td class="contd"><%= CommonLabels.PostedBy %> <a class="ps-conversation-postedby-urn"><span class="ps-conversation-postedby-name"></span></a></td>
									<td class="contd convpostedon"><span class="ps-conversation-postedon"></span></td>
								</tr> --> 
								<tr>
									<td colspan="2" class="ps-conversation-attachments-container">
									    <div class="con-sub"><span class="con-subhead"><%= CommonLabels.Attachments %>:</span></div>
										<span class="ps-conversation-attachments"></span>											
									</td>
								</tr>
								<tr>
									<td colspan="2" class="ps-conversation-description-container">
										<div class="con-sub"><span class="con-subhead"><%= CommonLabels.Description %> </span></div>
										<span class="ps-conversation-description"></span>											
									</td>
								</tr>
								<tr>
									<td colspan="2" class="ps-conversation-resolution-container">
									    <div class="con-sub"><span class="con-subhead"><%= CommonLabels.Resolution %></span></div>
										<span class="ps-conversation-resolution"></span>											
									</td>
								</tr>
							</table>
							<!-- <div class="convfooter"></div> --> 
						</div>
					</div>
				</div>
            </td>
        </tr>

        </tbody>
    </table>

	<table cellpadding="0" cellspacing="0">

    </table>
    </div>

    <polar:Footer runat="server" />
	<script type="text/javascript">
		var resource = <%= _jsonResRep %>
	</script>
	<polar:Includes runat="server" />

	<script type="text/javascript">
		var incidentConversation;
		
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Incident);
	        POLAR.View.AttachmentStrip(resource.Attachments, '<%= CommonLabels.Upload %>', '<%= CommonLabels.Delete %>', YAHOO.util.Dom.get('attachmentStrip'), '<%= UrlHelper.GetUrl("/api/attachment") %>');
	        //incidentConversation = new POLAR.View.Conversation(YAHOO.util.Dom.get('<%= IncidentContactResource.Meta.Conversation.Name %>'), resource.Conversation);
	        incidentConversation = new POLAR.View.Conversation(YAHOO.util.Dom.get('conversation'), resource.Conversation);

	        POLAR.View.Events.addOnResourceSavedEvent(POLAR.View.Page.onOperationSuccessful);
		}

		POLAR.View.Page.onOperationSuccessful = function () {
			var descriptionElement = YAHOO.util.Dom.get('<%= IncidentContactResource.Meta.Description.Name %>');
			incidentConversation.addRow({
        			Description: resource.Description.replace(/</g, '&lt;'),
        			Resolution: '',
        			Attachments: resource.Attachments,
        			PostedOn: new Date(),
        			PostedBy: AuthenticatedPerson
        		}, true);
        		
		    descriptionElement.value = '';
		}
	</script>

    <script runat="server">
	    IncidentContactResource resource;
        string _jsonResRep;
        readonly IncidentRepository _incidentRepository = IoC.Container.Resolve<IncidentRepository>();
		bool showContact = false;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();
            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as IncidentContactResource;

			IdentityContext ic = IoC.Container.Resolve<IdentityContext>();
			foreach (BusinessUnit bu in ic.AuthenticatedUser.Data.BusinessUnits)
			{
				if (bu.BusinessUnitType == BusinessUnitType.Account)
				{
					if (AuthorisationHelper.GetAuthorizationOnUri("incidentcontacts/account/" + bu.ID))
					{
						showContact = true;
						break;
					}
				}
			}
        }
    </script>
</body>
</html>
