<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.Infrastructure.ResourceHandlers"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title><%= IncidentHistoryLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
			<td style="text-align: left">
				<%= CommonLabels.Incident %>: <a id="incident" href=''></a>, <a id="incidentHistories" href=''><%= CommonLabels.IncidentHistory %></a>
			</td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
        <colgroup>
	        <col class="psColon1" />
	        <col />
	        <col class="psColMid" />
	        <col class="psColon3" />
	        <col />
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell">
                    <span><%= CommonLabels.Title%></span>
                </td>
                <td class="psFormCell" >
                    <input id="Title" name="Title" class="psTextbox" type="text" value="<%= resource.Title %>" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= IncidentLabels.Service %></span>
                </td>
                <td class="psFormCell">
                    <a href="<%= resource.Service.Value.URL%>"><%= resource.Service.Value.Name%></a>
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <%= IncidentLabels.Contact %>
                </td>
                <td class="psFormCell">
					<a href="<%= resource.Contact.Value.URL%>"><%= resource.Contact.Value.Name %></a>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= IncidentLabels.Account%></span>
                </td>
                <td class="psFormCell">
                    <a href="<%= resource.Account.Value.URL%>"><%= resource.Account.Value.Name%></a>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                </td>
                <td class="psFormCell">
			    </td>
            </tr>
            
            <tr>
				<td class="psFormCell">
                    <span><%= IncidentLabels.User%></span>
                </td>
                <td class="psFormCell">
                    <a href="<%= resource.User.Value.URL%>"><%= resource.User.Value.Name%></a>
                </td>
                <td class="psFormMid">
                </td>
				<td class="psFormCell">
                    <span><%= IncidentLabels.Origin%></span>
                </td>
                <td class="psFormCell">
                    <a href="<%= resource.Origin.Value.URL%>"><%= resource.Origin.Value.Name%></a>
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= IncidentLabels.Team%></span>
                </td>
                <td class="psFormCell">
					<a href="<%= resource.Team.Value.URL%>"><%= resource.Team.Value.Name%></a>
                </td>
                <td class="psFormMid">
                </td>
               <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= IncidentLabels.IncidentStatus %></span>
                </td>
                <td class="psFormCell">
                    <%= resource.Status.Value.Name%>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span><%= IncidentLabels.ClosureClassification%></span>
                </td>
                <td class="psFormCell">
                    <a href="<%= resource.ClosureClassification.Value.URL%>"><%= resource.ClosureClassification.Value.Name%></a>
                </td>
            </tr>
            <tr>
				<td class="psFormCell">
                    <span><%= IncidentLabels.IncidentPriority%></span>
                </td>
                <td class="psFormCell">
                    <%= resource.Priority.Value.Name%>
                </td>
                </td>
                <td class="psFormMid">
                </td>
                 <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            
            <tr>
			    <td class="psFormCell psBar" colspan="5"></td>
            </tr>
            
            <tr>
                <td class="psFormCell">
			        <span><%= IncidentHistoryLabels.CreatedOn %></span>
			    </td>
			    <td class="psFormCell">
			        <span id='createdOn'></span>
			    </td>
	            <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= IncidentHistoryLabels.CreatedBy %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.CreatedBy.Name %>" class="psTextbox" type="text" value="<%= resource.CreatedBy.Value.Name.Value %>" readonly="readonly" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= IncidentHistoryLabels.EndedOn %></span>
			    </td>
			    <td class="psFormCell">
			        <span id="endedOn"></span>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			         <span><%= IncidentHistoryLabels.Deleted %></span>
                </td>
                <td class="psFormCell">
                     <% if(resource.Deleted.Value) {%> <%= IncidentHistoryLabels.True %> <%} else {%> <%= IncidentHistoryLabels.False %> <%} %>
			    </td>
			</tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Attachments %></td>
            </tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <%
                        foreach (var item in resource.Attachments.Value)
     	                {
     	                    %><a href="<%= item.URI %>"><%= item.Name %></a>, <%
     	                }
                    %>                    
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Description %></td>
            </tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable"  id="<%= resource.Description.Name %>" readonly="readonly"><%= resource.Description %></textarea>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Resolution %></td>
            </tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Resolution.Name %>" readonly="readonly"><%= resource.Resolution %></textarea>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Note %>:</td>
            </tr>
            <tr id="note">
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>" readonly="readonly"><%= resource.Note.Value%></textarea>
                </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
	<script type="text/javascript">
		var resource = <%= _jsonResRep %>
	</script>
    <polar:Includes runat="server" />

	<script type="text/javascript">
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.CheckForExtraInfo();
	        POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.IncidentHistory);
		    $("#incident").attr("href", resource.Incident.URL);
		    $("#incident").text(resource.Incident.Title);
		    $("#incidentHistories").attr("href", UserResourcePermissions.VirtualUrl + '/incidenthistories?incident.id=' + resource.Incident.ID);
		    $("#createdOn").text(POLAR.View.DateTime.dateToString(POLAR.View.DateTime.stringToDate(resource.ModifiedOn)));
		    if (POLAR.View.DateTime.stringToDate(resource.EndedOn).getFullYear() > 2060) {
		        $("#endedOn").text('<%= IncidentHistoryLabels.Pending %>');
		    }
		    else {
		        $("#endedOn").text(POLAR.View.DateTime.dateToString(POLAR.View.DateTime.stringToDate(resource.EndedOn)));
		    }
		}
    </script>

    <script runat="server">
	    IncidentHistoryResource resource;
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as IncidentHistoryResource;
        }
    </script>
</body>
</html>
