<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
	<title><%= IncidentTemplateLabels.IncidentEditTitle%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="text-align: left">
                    <div>
                        <%
                            if (0 == resource.ID.Value)
                            {
								%>
								<input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
								<input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" /><%
							}
                            else
                            {
                                if (_incidentTemplateRepository.GetByID((long)resource.ID.Value).Deleted)
                                {
									%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
                                }
                                else
                                {
									%>
										<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
										<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
									<%
								}
                            }
                        %>
                        <button id="assigneToMe" type="button"><%= IncidentLabels.AssigneIncidentToMe %></button>
                        <button id="idMoreAction" type="button"><%= IncidentLabels.MoreActionsMenuButton%></button>
                        <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                    </div>
                </td>
                <td style="text-align: right">
                    <span class="primaryValue"><%= CommonLabels.ID %>:</span>
                    <input id="<%= IncidentTemplateResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
                </td>
            </tr>
        </tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
        <colgroup>
            <col class="psColon1" />
            <col />
            <col class="psColMid" />
            <col class="psColon3" />
            <col />
        </colgroup>
        <tbody>
            <tr>
				<td class="psFormCell"><span><%=IncidentTemplateLabels.Name%></span></td>
				<td class="psFormCell" colspan="4"><input id="<%= IncidentTemplateResource.Meta.Name.Name %>" class="psTextbox" type="text" value="<%=resource.Name%>"/></td>
			</tr>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= CommonLabels.Title%></span>
                </td>
                <td class="psFormCell" colspan="4">
                    <input id="<%= IncidentTemplateResource.Meta.Title.Name %>" name="<%= IncidentTemplateResource.Meta.Title.Name %>" class="psTextbox" type="text" value="<%= resource.Title %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <%= IncidentLabels.Contact %>
                </td>
                <td class="psFormCell">
					<div id="contactLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="contactLink" href="<%= null != resource.Contact.Value ? resource.Contact.Value.URL.Value : string.Empty %>"> <%= null != resource.Contact.Value ? resource.Contact.Value.Name.Value : string.Empty %>  </a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell psLabelRequire">
                    <span>
                        <%= IncidentLabels.Service%></span>
                </td>
                <td class="psFormCell">
                    <select id="Service.ID" class="styled" class="styled">
                          <option value="0"></option>
                        <%
                            foreach (Service item in _incidentServiceRepository.GetAll())
                            {
                        %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Service.Value && item.ID == resource.Service.Value.ID.Value) %>>
                            <%= item.Name%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
            <tr>
				<td class="psFormCell">
					<span><%= IncidentLabels.Account%></span>
				</td>
                <td class="psFormCell">
					<div id="accountLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="accountLink" href="<%= null != resource.Account.Value ? resource.Account.Value.URL.Value : string.Empty %>"> <%= null != resource.Account.Value ? resource.Account.Value.Name.Value : string.Empty%>  </a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
                    <td class="psFormCell">
                    <span><%= IncidentLabels.ServiceLevel%></span>
                </td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
            <td class="psFormCell">
                    <span><%= IncidentLabels.User%></span>
                </td>
                <td class="psFormCell">
                    <div id="userLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="userLink" href="<%= null != resource.User.Value ? resource.User.Value.URL.Value : string.Empty %>">	<%= null != resource.User.Value ? resource.User.Value.Name.Value : string.Empty %></a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show" ></button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span>
                        <%= IncidentLabels.ServiceLevelAgreement%>
                    </span>
                </td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span>
                        <%= IncidentLabels.Team%></span>
                </td>
                <td class="psFormCell">
					<div id="teamLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="teamLink" href="<%= null != resource.Team.Value ? resource.Team.Value.URL.Value : string.Empty %>"> <%= null != resource.Team.Value ? resource.Team.Value.Name.Value : string.Empty%>  </a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span><%= IncidentLabels.Origin%></span>
                </td>
                <td class="psFormCell">
                    <select id="Origin.ID" class="styled">
                        <option value="0"></option>
                        <%
                            foreach (Origin item in _originRepository.GetAll())
                            {
                        %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.Origin.Value && item.ID == resource.Origin.Value.ID.Value) %>>
                            <%= item.Name%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= IncidentLabels.IncidentStatus %></span>
                </td>
                <td class="psFormCell">
                    <select id="Status.ID" class="styled">
                        <%
                            foreach (Status item in Enum.GetValues(typeof(Status)))
                            {
								%><option value="<%=(long)item%>" <%= HtmlHelper.OptionSelect(null !=  resource.Status.Value && (long)item == resource.Status.Value.ID.Value) %>><%= StatusLabels.GetLabel(item)%></option><%
                            }
                        %>
                    </select>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            <tr>
            <td class="psFormCell psLabelRequire">
                    <span>
                        <%= IncidentLabels.IncidentPriority%></span>
                </td>
                <td class="psFormCell">
                    <select id="Priority.ID" class="styled">
                        <%
                            foreach (Priority item in Enum.GetValues((typeof(Priority))))
                            {
                        %><option <%= HtmlHelper.OptionSelect((long)item == resource.Priority.Value.ID.Value) %>
                            value="<%= (long)item %>">
                            <%= PriorityLabels.GetLabel(item)%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span>
                        <%= IncidentLabels.ClosureClassification%></span>
                </td>
                <td class="psFormCell">
                    <select id="ClosureClassification.ID" class="styled">
                        <option value="0"></option>
                        <%
                            foreach (ClosureClassification item in _closureClassificationRepository.GetAll())
                            {
                        %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.ClosureClassification.Value && item.ID == resource.ClosureClassification.Value.ID.Value) %>>
                            <%= item.Name%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
            <tr class="userAssignee">
                <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>

                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span><%= CommonLabels.Attachments%></span>
                </td>
                <td class="psFormCell">
                    <div id="attachmentStrip">
                    </div>
                    <span id="uploadFailed"  style="visibility: hidden"><%= CommonLabels.UploadFailedMessage%></span>
                </td>
            </tr>
            <tr class="noteControl" style="display:none">
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Note %></span> <a href="" id="noteShowHide"><%= CommonLabels.Hide %></a></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr class="noteControl" style="display:none">
                <td id="noteTextArea" class="psFormCell" colspan="5">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>"><%= resource.Note.Value%></textarea>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= IncidentLabels.IncidentDescription%></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell" colspan="5">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>"><%= resource.Description %></textarea>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= IncidentLabels.IncidentResolution%></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell" colspan="5">
                    <textarea  class="psTextarea expand25-350 resizable" id="<%= resource.Resolution.Name %>"><%= resource.Resolution %></textarea>
                </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
	<script type="text/javascript">
		var resource = <%= _jsonResRep %>
        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
				%>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});<%
            }
        %>
	</script>
   <polar:Includes runat="server" />

	<script type="text/javascript">
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.CheckForExtraInfo();
	        POLAR.View.Page();
		});

		var incidentConversation;

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.IncidentTemplate);
		    POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");
		    if ($('#assigneToMe').length) {
		        var oAssigneToMe = new YAHOO.widget.Button("assigneToMe");
		        oAssigneToMe.on("click", function() {
		            autoCompleteLookupUser._changeOnLinkedControl(AuthenticatedPerson.ID);
		            $("#Resolution").focus();
		            $("#Resolution").height("200px");
		        }
                );
		    }

		    $(".noteControl").show();

		    $('#noteShowHide').click(function(event) {
		        event.preventDefault();
		        event.stopPropagation();
		        if ($("#noteTextArea").is(':visible')) {
		            $("#noteShowHide").text(" <%= CommonLabels.Show%>");
		            $('#noteTextArea').hide();
		        }
		        else {
		            $("#noteShowHide").text(" <%= CommonLabels.Hide%>");
		            $('#noteTextArea').show();
		        }
		    });

		    $("#assigneIncidentToMe").click(function(event) {
		        event.preventDefault();
		        autoCompleteLookupUser._changeOnLinkedControl(AuthenticatedPerson.ID);
		        $("#Resolution").focus();
		        $("#Resolution").height("200px");
		    });

		    MoreActionMenu = function() {
		        //Show Work Orders if hiden and if exist any work order included in this incident
		        var moreActions = new Array();
		        moreActions[0] = '<%= CommonLabels.AddNote%>';
		        var aItemData = [
                        { text: moreActions[0] }
                    ];

		        var oMenu = new YAHOO.widget.Menu("basicmenu", { position: "dynamic" });
		        oMenu.addItems(aItemData);

		        // Define a handler for the "click" event
		        function onClick(p_sType, p_aArgs) {
		            oMenuItem = p_aArgs[1]; // YAHOO.widget.MenuItem instance
		            if (oMenuItem.index == 0) {
		                $(".noteControl").show();
		                $("#Note").focus();
		                $("#Note").height("200px");
		            }
		        }
		        var oMenuToggleButton = new YAHOO.widget.Button("idMoreAction", { type: "menu", menu: oMenu.getItems() });
		        oMenuToggleButton.getMenu().subscribe("click", onClick); // Subscribe to the "click" event
		    }
		    MoreActionMenu();
		    /*YAHOO.util.Event.addListener(YAHOO.util.Dom.get('Account.ID'), 'change', POLAR.View.Page.changeAccount);
		    YAHOO.util.Event.addListener(YAHOO.util.Dom.get('Service.ID'), 'change', POLAR.View.Page.changeService);
		    POLAR.View.Events.addOnResourceSavedEvent(POLAR.View.Page.onOperationSuccessful);
		    incidentConversation = new POLAR.View.Conversation(YAHOO.util.Dom.get('conversation'), resource.Conversation);
		    */

		    POLAR.View.AttachmentStrip(resource.Attachments, '<%= CommonLabels.Upload %>', '<%= CommonLabels.Delete %>', YAHOO.util.Dom.get('attachmentStrip'), '<%= UrlHelper.GetUrl("/api/attachment") %>');
		    autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
		        id: 'contactLookup',
		        url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
		        linkID: "contactLink",
		        propertyName: "Contact",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
		        }		        
		    });

		    autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
		        id: 'accountLookup',
		        url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
		        linkID: "accountLink",
		        propertyName: "Account",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
		            columnDefinitions: [
                                    { key: 'Add', formatter: 'customContact' },
	                                { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                    { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                    { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                                ]
		        }
		    });

		    autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
		        id: 'teamLookup',
		        url: '<%= UrlHelper.GetUrl("/api/teams") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
		        linkID: "teamLink",
		        propertyName: "Team",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&assignableteam=true&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
		        }
		    });

		    autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
		        id: 'userLookup',
		        url: '<%= UrlHelper.GetUrl("/api/users") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
		        linkID: "userLink",
		        propertyName: "User",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
		        }
		    });
		}
    </script>

	<script runat="server">
        IncidentTemplateResource resource;
        string _jsonResRep;

		IncidentTemplateRepository _incidentTemplateRepository = IoC.Container.Resolve<IncidentTemplateRepository>();
		ClosureClassificationRepository _closureClassificationRepository = IoC.Container.Resolve<ClosureClassificationRepository>();
		OriginRepository _originRepository = IoC.Container.Resolve<OriginRepository>();
		ServiceRepository _incidentServiceRepository = IoC.Container.Resolve<ServiceRepository>();
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as IncidentTemplateResource;
        }
	</script>
</body>
</html>
