<%@ Page Language="C#" AutoEventWireup="True" EnableViewState="True" %>
<%@ Import Namespace="System.Security.Principal"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
	<title>Installation</title> 
	<polar:CssIncludes ID="CssIncludes1" runat="server"/>
</head>
<body class="yui-skin-sam">
    <div id="doc3" class="yui-t2">
    <div id="hd" class="psHeader">  
      <span style="color:#d1d1d1; font-size:150%; font-weight:bold; position:absolute">             
            Polar Help Desk - Install            
        </span>  
        <div style="text-align:right" class="psProfile">
           <span id="myProfile"></span> <a href="http://help.polarsoftware.com/phd/">Help</a> <span id="idLogout"></span>
        </div>                        
        <div id="topNavigation2" ></div>      
    </div>
    <div id="bd"><!-- body -->
        <div class="yui-b leftsidebar"> 
            <!-- Left Columns 	-->
            <div class="yui-b sidebarlefttop"> </div>          
	    </div>
        <div id="yui-main"><!-- main desktop content -->
            <div class="yui-b midletop"> </div>
            <div id='idmidle2' class="yui-b midle">
                <table border="0" cellpadding="0" cellspacing="0" width="100%" class="resourceHeader" >
                    <tbody>
                        <tr >                           
                            <td class="headermessage" >
                                <span id='idResourceName' class="resourceName"></span>
                            </td>                            
                            <td class="headermessage">
                                <span id="messagebox"></span>
                            </td>
                            <td class="headermessage">
                                <div id='messageBoxDialog' title=''></div>                                
                                <span id="openMessageDialog"></span>
                            </td>
                        </tr>
                </tbody>
                </table>    
  
    
    <form id="form1" runat="server">
		<p />
        <table cellpadding="2" cellspacing="0" border="0">
            <tr>
                <td>
                   <asp:Label ID="_sqlServersLabel" Text="Select SQL server" Visible="false" runat="server"></asp:Label>
                </td>
                <td>
                   <asp:DropDownList ID="_sqlServersDropDownList" OnSelectedIndexChanged="OnSqlServerChanged" Visible="false" runat="server"></asp:DropDownList>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <asp:Label ID="_createDatabaseLabel" runat="server"></asp:Label>
                    <br />
                    Database Name: <asp:TextBox ID="_databaseTextBox" runat="server"></asp:TextBox>
                    <asp:Button ID="_installButton" OnClick="OnInstall" runat="server" />
                </td>
            </tr>
            <tr id="_upgradeDatabaseSection" Visible="false" runat="server">
                <td colspan="2">
                    <br />
                    <asp:Label ID="_upgradeDatabaseLabel" runat="server"></asp:Label>
                    <br />
                    Database List: <asp:DropDownList ID="_databaseDropDownList" runat="server"></asp:DropDownList>
                    <asp:Button ID="_upgradeButton" OnClick="OnUpgrade" runat="server" />
                </td>
            </tr>
            <tr>
                <td colspan="2">
					<br />
                    Below you can optionally enter the URL you wish this installation of Help Desk to be accessible from. Help Desk will not be accessible from URL's other than this. You can add more URL's in Administration/Settings. Note that Help Desk will always be accessible from http://localhost.
                    <br />
                    Instance URL: <asp:TextBox ID="_instanceurlTextBox" runat="server" style="width: 400px"></asp:TextBox>
                     <br />
                    Response.Write(System.Security.Principal.WindowsIdentity.GetCurrent().Name);:
                    <% // Retrieve the Windows account token for the current user.
                        Response.Write(UseProperties()); %>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <asp:Label ID="_errorMessageLabel" style="color: Red;" runat="server"></asp:Label>
                </td>
            </tr>
        </table>
        <p />
        <table cellpadding="2" cellspacing="0" border="0">
            <tr>
                <td colspan="2">
                   <asp:Label ID="_helpLabel" runat="server"></asp:Label>
                </td>
            </tr>
        </table>
    </form>

 </div> <!--  End of - <div id="yui-main"> -->
       <div class="yui-b midleBottom"> </div>
       </div><!--  End of - <div class="yui-b midle"> - main desktop content -->
    </div>   <!--  End of body  - <div id="bd"> -->
    <div id="ft" class="footer" >    
      Need Help? See <a href="http://help.polarsoftware.com/phd">Help Section </a>or contact us at <a href="mailto:support@polarsoftware.com">support@polarsoftware.com</a><br />        
    </div>
    <div class="footer2" >                
        <a href="http://www.polarsoftware.com">Help Desk Software</a> by Polar <br />
    </div>
</div> <!-- End of - <div id="doc3" class="yui-t2">e do -->
    <script runat="server">
        HelpDeskInstanceManager _helpDeskInstanceManager = IoC.Container.Resolve<HelpDeskInstanceManager>();

        protected void Page_Load(object sender, EventArgs e)
        {
			if (!Request.IsLocal)
			{
				Response.Clear();
				Response.StatusCode = (int)HttpStatusCode.Forbidden;
			    const string unableToCreateDatabase = "Database can only be created from local computer! Please connect to the server and try again from there.";
                Response.Write("<p align=center style='font-size: 150%;'>" + unableToCreateDatabase + "</p>");
				Response.End();
			}

            _helpLabel.Text = "If you wish to upgrade Polar HelpDesk 4 database, you will need to use a special upgrade application. This upgrade application can be found in the installation folder, setup directory.";
            _createDatabaseLabel.Text = "If you wish to create a new database, enter the database name in the textbox and click Create Database.";
            _upgradeDatabaseLabel.Text = "To upgrade an existing database, select the database you wish to upgrade from the list and click Upgrade Database.";
            _upgradeButton.Text = "Upgrade Database";
            _installButton.Text = "Create Database";
            _errorMessageLabel.Text = string.Empty;
			
			bool redirect = true;

			if (!IsPostBack)
			{
                //first time load page 
				string url = Request.Url.AbsoluteUri;
				int index = url.IndexOf("?");
				if (-1 != index)
				{
					url = url.Remove(index, url.Length - index);
				}

				_instanceurlTextBox.Text = url.Replace("/install", "");

				string[] servers = _helpDeskInstanceManager.EnumerateDatabaseServers();

				foreach (string server in servers)
				{
					_sqlServersDropDownList.Items.Add(new ListItem(server, server));
				}

				if (1 < _sqlServersDropDownList.Items.Count)
				{
					_sqlServersLabel.Visible = true;
					_sqlServersDropDownList.Visible = true;
				}

				_databaseTextBox.Text = Request.QueryString["database"];

                if (!string.IsNullOrEmpty(Request.QueryString["redirect"]))
                {
                    redirect = true;
                }

			    PopulateDatabaseList();
			}

			if (!_sqlServersDropDownList.Visible && (!_upgradeDatabaseSection.Visible && !string.IsNullOrEmpty(_databaseTextBox.Text)) && redirect)
            {
				InstallHelpdesk(redirect);
            }
		}

        protected void OnSqlServerChanged(object sender, EventArgs args)
        {
            PopulateDatabaseList();
        }

        protected void OnInstall(object sender, EventArgs args)
        {
            InstallHelpdesk(false);
        }

        protected void OnUpgrade(object sender, EventArgs args)
        {
            if (-1 == _databaseDropDownList.SelectedIndex)
			{
				_errorMessageLabel.Text = "Error: No database was specified.";
				return;
			}

            string url = _helpDeskInstanceManager.UpgradeDatabase(string.Empty, _databaseDropDownList.SelectedValue, _sqlServersDropDownList.SelectedValue, string.Empty, string.Empty);
            Response.Redirect(url);
        }

		private void InstallHelpdesk(bool redirect)
        {
            if (string.IsNullOrEmpty(_databaseTextBox.Text))
			{
				_errorMessageLabel.Text = "Error: No database name was specified.";
				return;
			}

            string url;
            // delete cached files
		    CreateInstanceResponse response;
            try
            {
			    response = _helpDeskInstanceManager.CreateInstance(string.Empty, _databaseTextBox.Text, _sqlServersDropDownList.SelectedValue, string.Empty, string.Empty, _instanceurlTextBox.Text.Trim(), out url);
            }
            catch (Exception e)
            {
                _errorMessageLabel.Text = _errorMessageLabel.Text + "Error: Can not create instance of Polar Help Desk" + " - " + e.ToString();
                return;
            }
            
            if(CreateInstanceResponse.AlreadyExists == response)
			{
				_errorMessageLabel.Text = "Error: Database already exists.";

				if (redirect && url != null)
				{
					Response.Redirect(url);
				}
				
				return;
			}

            Response.Redirect(url);
        }

        private void PopulateDatabaseList()
        {
            foreach (string database in _helpDeskInstanceManager.EnumerateUpgradeableDatabases(_sqlServersDropDownList.SelectedValue))
            {
                _databaseDropDownList.Items.Add(new ListItem(database, database));
            }

            if (0 < _databaseDropDownList.Items.Count)
            {
                _upgradeDatabaseSection.Visible = true;
            }
        }

        // Access the properties of a WindowsIdentity object.
        static string UseProperties(/*IntPtr logonToken*/)
        {

            IntPtr logonToken = WindowsIdentity.GetCurrent().Token;
            
            WindowsIdentity windowsIdentity = new WindowsIdentity(logonToken);
            string propertyDescription = "The Windows identity named ";

            // Retrieve the Windows logon name from the Windows identity object.
            propertyDescription += windowsIdentity.Name;

            // Verify that the user account is not considered to be an Anonymous
            // account by the system.
            if (!windowsIdentity.IsAnonymous)
            {
                propertyDescription += " is not an Anonymous account";
            }

            // Verify that the user account has been authenticated by Windows.
            if (windowsIdentity.IsAuthenticated)
            {
                propertyDescription += ", is authenticated";
            }

            // Verify that the user account is considered to be a System account
            // by the system.
            if (windowsIdentity.IsSystem)
            {
                propertyDescription += ", is a System account";
            }

            // Verify that the user account is considered to be a Guest account
            // by the system.
            if (windowsIdentity.IsGuest)
            {
                propertyDescription += ", is a Guest account";
            }

            // Retrieve the authentication type for the 
            String authenticationType = windowsIdentity.AuthenticationType;

            // Append the authenication type to the output message.
            if (authenticationType != null)
            {
                propertyDescription += (" and uses " + authenticationType);
                propertyDescription += (" authentication type.");
            }
            return propertyDescription;
            
            /*Console.WriteLine(propertyDescription);

            // Display the SID for the owner.
            Console.Write("The SID for the owner is : ");
            SecurityIdentifier si = windowsIdentity.Owner;
            Console.WriteLine(si.ToString());
            // Display the SIDs for the groups the current user belongs to.
            Console.WriteLine("Display the SIDs for the groups the current user belongs to.");
            IdentityReferenceCollection irc = windowsIdentity.Groups;
            foreach (IdentityReference ir in irc)
                Console.WriteLine(ir.Value);
            TokenImpersonationLevel token = windowsIdentity.ImpersonationLevel;
            Console.WriteLine("The impersonation level for the current user is : " + token.ToString());
             * */
        }

	</script>
</body>
</html>
