﻿<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import Namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title><%= LanguageLabels.Language %></title>
    <polar:CssIncludes runat="server" />
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="text-align: left">                    
                        <%
                            if (0 == resource.ID.Value)
                            { %>                                
                                <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                                <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
								<%
							}
                            else
                            {
                                Language lang = _languageRepository.GetByID((long)resource.ID.Value);
                                if (lang != null && lang.Deleted)
                                {
									%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
                                }
                                else
                                {
									%>
										<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
										<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
									<%
								}
                            }
                        %>                    
                </td>                
            </tr>
       <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
        <colgroup>
            <col class="psColon1">
            <col>
            <col class="psColMid">
            <col class="psColon3">
            <col>
        </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= LanguageLabels.Name %></span>
                    <span id="<%= resource.LanguageName.Name + "error" %>" />
                </td>
                <td class="psFormCell" colspan="4">
                    <input id="<%= resource.LanguageName.Name %>" class="psTextbox" type="text" value="<%= resource.LanguageName %>" />
                </td>
                
            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5"><%= LanguageLabels.ImportFromFile %></td>							    
            </tr>                
            <tr class="psAfterBar" ><td></td></tr>                
            <tr>
                <td class="psFormCell" colspan="5">                    
                    <form id="importForm" action="action" enctype="multipart/form-data" method="post">
                        <input id="buttonImport" type="button" value="<%= LanguageLabels.ImportFromFile %>" />
                        <input id="fileImport" name="languageImportFile" type="file" />
                    </form> 
                </td>

            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5">Export to file</td>							    
            </tr>                
            <tr class="psAfterBar" ><td></td></tr>                
            
            <tr>
                <td class="psFormCell">
                    <span>Export as</span>                    
                </td>
                
                <td class="psFormCell" colspan="4">                    
                    <% if (0 != resource.ID.Value)
                       {%>
                       <a id="xmlFileLink" href="<%= resource.URL.Value %>?fileformat=XML">XML</a>, <a id="cvsFileLink" href="<%= resource.URL.Value %>?fileformat=CSV">CSV</a>, <a id="jsonFileLink" href="<%= resource.URL.Value %>?fileformat=JSON">JSON</a>
                    <% } %>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5">Labels</td>							    
            </tr>                
            <tr class="psAfterBar" ><td></td></tr>                
            <tr>
                <td>
                    <div id="myContainer" class=" yui-skin-sam"></div>
                </td>
            </tr>

        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
		var resource = <%= _jsonResRep %>
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Language);
            if (resource.ID != 0) {
                $('#LanguageName').attr('disabled', 'disabled');
            }

            // update json data
            POLAR.View.Page.updateJson = function(containerName, labelName, labelText) {
                for (var i = 0; i < resource.LanguageContainers.length; ++i) {
                    var container = resource.LanguageContainers[i];

                    if (container.ContainerName == containerName) {
                        for (var j = 0; j < container.Labels.length; ++j) {
                            var label = container.Labels[j];

                            if (label.LabelName == labelName) {
                                label.Text = labelText;
                            }
                        }
                    }
                }
            }

            // gets data written in table and change json to match
            /*POLAR.View.Page.updateJsonFromTable = function(containerName, labelName) {
                var inputValue = YAHOO.util.Dom.get(containerName + "." + labelName).value;
                POLAR.View.Page.updateJson(containerName, labelName, inputValue);
            };*/

            // updates text in table label
            POLAR.View.Page.updateTableLabel = function(containerName, labelName, labelText) {
                $(POLAR.Util.jqIdFormat(containerName + "." + labelName)).val(labelText);
            };

            // called when we get response after uploading file with post on /languageconverted, it reads json response and updates table and json data
            // as it really isnt ajax request but an iframe form post, we cant read response.status and anything usefull except response data we've put status in json
            POLAR.View.Page.uploadResponse = function(response) {
                // manually read status and add to build proper response object we usually handle
                var jsonResRep = POLAR.View.convertAsyncResponseToObject(response);
                response.status = jsonResRep.ResponseStatus;
                response.statusText = "Manually simulated response, only response status is valid.";
                //POLAR.View.setAsyncResponseMessage(response);

                if (resource.id == 0) {
                    $('#LanguageName').val(jsonResRep.LanguageName);
                }
                for (container in jsonResRep.LanguageContainers) {
                    for (label in jsonResRep.LanguageContainers[container].Labels) {
                        POLAR.View.Page.updateJson(
                            jsonResRep.LanguageContainers[container].ContainerName,
                            jsonResRep.LanguageContainers[container].Labels[label].LabelName,
                            jsonResRep.LanguageContainers[container].Labels[label].Text);
                        POLAR.View.Page.updateTableLabel(
                            jsonResRep.LanguageContainers[container].ContainerName,
                            jsonResRep.LanguageContainers[container].Labels[label].LabelName,
                            jsonResRep.LanguageContainers[container].Labels[label].Text);
                    }
                }
            }

            // bind import button to get json from file data using /languageconverter resource
            $("#buttonImport").click(function() {
                var filename = $("#fileImport").val();
                var extension = filename.substr(filename.lastIndexOf('.') + 1).toUpperCase();
                if (extension == "XML" || extension == "CSV" || extension == "JSON") {
                    var URI = BASE_URL + 'api/languageconverter';
                    POLAR.View.asyncUpload('importForm', URI + '?fileformat=' + extension, POLAR.View.Page.uploadResponse);
                }
                else {
                    POLAR.View.addToMessageBox("Invalid file: \"" + filename + "\". Select XML or CSV or JSON file");
                }
            });

            /*POLAR.View.Page.formatText = function(elCell, oRecord, oColumn, sData) {
                var labelName = oRecord.getData("<%= LanguageLabelFragment.Meta.LabelName.Name %>");
                var labelValue = oRecord.getData("<%= LanguageLabelFragment.Meta.Text.Name %>");
                var inputId = currentContainer.ContainerName + "." + labelName;

                elCell.innerHTML = "<input id='" + inputId + "' value=\"" + labelValue + "\" class='psTextbox' type='text' onblur='POLAR.View.Page.updateJsonFromTable(\"" + currentContainer.ContainerName + "\", \"" + labelName + "\")' />";
            };*/

            if (resource.LanguageContainers == 'undefined') return;
            
            function alphabetical(a, b) {
				 var A = a.ContainerName.toLowerCase();
				 var B = b.ContainerName.toLowerCase();
				 if (A < B){
					return -1;
				 }else if (A > B){
				   return  1;
				 }else{
				   return 0;
				 }
			};
			            
            var table = $("<table>");
            $.each(resource.LanguageContainers.sort(alphabetical), function(containerKey, container) {                
                var tr = $("<tr>").appendTo(table);
                
                $("<td>")
					.attr({colspan: 2})
					.css({
						padding: "2px",
						"font-weight": "bold",
						"font-size": "larger"
					})
					.text(container.ContainerName)
					.appendTo(tr);
					
				$.each(container.Labels, function(labelKey, label) {
					tr = $("<tr>").appendTo(table);		

					$("<td>")
						.text(label.LabelName)
						.css({
							padding: "2px"
						})
						.appendTo(tr);						
										
					$("<td>")
						.append($("<input>")
							.attr({
								type: "text",
								id: container.ContainerName + "." + label.LabelName
							})
							.css({
								width: "500px",
								border: "1px solid silver"
							})
							.val(label.Text)
							.data("label", label)
							.keydown(function() {
								$(this).data("label").Text = $(this).val();
							})
						)
						.appendTo(tr);
				});
                
                /*var currentContainer = resource.LanguageContainers[i];

                var currentContainerId = currentContainer.ContainerName;
                var currentContainerElement = "<div id='" + currentContainerId + "' class='yui-skin-sam'></div>"

                $("#myContainer").append(currentContainerElement);

                var myDataSource = new YAHOO.util.DataSource(currentContainer);
                myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

                myDataSource.responseSchema = {
                    resultsList: "<%= LanguageContainerFragment.Meta.Labels.Name %>",
                    fields: [
		                "<%= LanguageLabelFragment.Meta.LabelName.Name %>",
		                "<%= LanguageLabelFragment.Meta.Text.Name %>"
		            ]
                };

                var myColumnDefs = [
	                { key: "<%= LanguageLabelFragment.Meta.LabelName.Name %>", label: "<%= LanguageLabels.Name %>", sortable: true, resizeable: true },
	                { key: "<%= LanguageLabelFragment.Meta.Text.Name %>", label: "<%= LanguageLabels.Text %>", sortable: true, resizeable: true, width: 400, formatter: POLAR.View.Page.formatText }
	            ];

                var myDataTable = new YAHOO.widget.DataTable(currentContainerId, myColumnDefs, myDataSource, { caption: currentContainer.ContainerName });*/
            });
            
            table.appendTo("#myContainer");
        }
    </script>
    <script runat="server">
        LanguageResource resource;
        string _jsonResRep;
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as LanguageResource;
        }
        </script>
</body>
</html>
