    <%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title><%= LanguageLabels.Languages %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="filter">
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />				
    </div>
    <div class="desktopTable">
        <div class="desktopTableActions">
			<%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <script type="text/javascript">
        var resource = <%=_jsonResRep %>
    </script>

    <polar:Footer runat="server" />
    <polar:Includes runat="server" />

	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of select all javascipt code -> onclick = "POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)"		
		YAHOO.util.Event.onDOMReady( function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Languages);
			POLAR.View.Page.initializeGrid();

			var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
                args: [
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },
                ],
                onGetArguments: function(args) {
                },
                onSetArguments: function(args) {
                }
            });
        };

        POLAR.View.Page.initializeGrid = function() {
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
		    dataSource.responseSchema = {
		        resultsList: "Items",
		        fields: [{ key: "<%= LanguageResource.Meta.ID.Name %>", parser: YAHOO.util.DataSource.parseNumber }, "<%= LanguageResource.Meta.LanguageName.Name %>", "<%= LanguageResource.Meta.URL.Name %>", "<%= LanguageResource.Meta.Default.Name %>"]
		    };

		    POLAR.View.Page.formatExportUrl = function(elCell, oRecord, oColumn, sData) {
		        elCell.innerHTML = 'Export as: <a href="' + oRecord.getData('URL') + '?fileformat=XML">XML</a>, <a href="' + oRecord.getData('URL') + '?fileformat=CSV">CSV</a>, <a href="' + oRecord.getData('URL') + '?fileformat=JSON">JSON</a> ';
		    };

		    dataTable = new YAHOO.widget.DataTable("dataTableContainer", [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
	            { key: "<%= LanguageResource.Meta.ID.Name %>", label: "<%= CommonLabels.ID %>", sortable: true, formatter: "number", sortOptions: { defaultOrder: "desc" }, resizeable: true },
	            { key: "<%= LanguageResource.Meta.LanguageName.Name %>", label: "<%= LanguageLabels.Name %>", sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
	            { key: "<%= LanguageResource.Meta.Default.Name %>", label: "<%= LanguageLabels.Default %>", sortable: true, resizeable: true },
	            { key: "<%= LanguageResource.Meta.URL.Name %>", label: "<%= LanguageLabels.Export %>", resizeable: true, formatter: POLAR.View.Page.formatExportUrl }
	        ], dataSource, {
	            sortedBy: { key: '<%= LanguageResource.Meta.LanguageName.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
	            draggableColumns: true,
	            paginator: POLAR.View.DataTable.createDefaultPaginator()
	        });

		    POLAR.View.DataTable.configDataTable(dataTable);

		    POLAR.View.DataTable.configDeleteUndelete({
		        dataTable: dataTable,
		        dataTableItems: resource.Items,
		        dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
		        dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
		    });

		    //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
		    //set with on first and second colon for beter visula efect
		    $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
		};
    </script>

    <script runat="server">
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>

</body>
</html>