<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>    
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                </div>
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
			<tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= LicenseLabels.LicenseKeys %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
					<span><%= LicenseLabels.AddLicenseKey%></span>
                    <input id="licenceKey" type="text" />
                    <input id="addLicenceKey" type="button" value="<%= CommonLabels.Add %>" />
                    <div id="<%= resource.LicenseKeys.Name %>" class="yui-skin-sam"></div>
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
					<span><%= LicenseLabels.NamedLicenses %></span></td>
					<td class="psFormCell"><input id="<%= LicenseResource.Meta.NamedLicences.Name %>" class="psTextbox" readonly type="text" value="<%= resource.NamedLicences %>"/>
				</td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= LicenseLabels.NamedUsers %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell"><span><%= LicenseLabels.AddNamedUsers %></span></td>
                <td class="psFormCell" colspan="4">
					<div id="userLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
             <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= LicenseResource.Meta.NamedUsers.Name %>" class="yui-skin-sam"></div></td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>

   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.License);
		    autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
		        id: 'userLookup',
		        url: '<%= UrlHelper.GetUrl("/api/users") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
		        propertyName: "User",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: '<%= CommonLabels.Name%>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: '<%= UserLabels.Email%>', sortable: true, resizeable: true }
                    ]
		        },
		        dataTableData: {
		            resourceName: "NamedUsers",
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'URL', 'Email'],
		            columnDefinitions: [
                        { key: '' },
				        { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				        { key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
				        { key: 'Email', label: '<%= UserLabels.Email%>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl }
				    ]
		        }
		    });

		    POLAR.View.Page.loadLicenceKeyDataTable();
		    YAHOO.util.Event.addListener(YAHOO.util.Dom.get('addLicenceKey'), 'click', POLAR.View.Page.addLicenceKey);
		}

		POLAR.View.Page.addLicenceKey = function() {
			var element = YAHOO.util.Dom.get('licenceKey');
			if(element.value.length > 10) {
				POLAR.View.getContainedObject('LicenseKeys').addRow({ 'Key': element.value, 'Name': 'New Key' });
				element.value = '';
			}
		}

		POLAR.View.Page.loadLicenceKeyDataTable = function() {
			var dataSource = new YAHOO.util.DataSource(resource);
			dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

			dataSource.responseSchema = {
				resultsList: 'LicenseKeys',
				fields: ['ID', 'Name', 'Key']
			};

			var formatRemoveRow = function(elCell, oRecord, oColumn, oData) {
				var link = document.createElement("div");
				link.className = 'remove';
				elCell.appendChild(link);

				YAHOO.util.Event.addListener(link, 'click', function(e) {
					dataTable.deleteRow(oRecord);
				});
			};

			var columnDefinitions = [
				{ key: '', width: 20, formatter: formatRemoveRow },
				{ key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true }
			];

			var element = YAHOO.util.Dom.get('LicenseKeys');
			var dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource);
			POLAR.View.setContainedObject(element, dataTable);

			dataTable.subscribe("checkboxClickEvent", POLAR.View.disableableCheckBoxOnClick);

			POLAR.View.setDataTableRowReader(element, function(recordData) {
				var data = new Object();
				data['ID'] = recordData['ID'];
				data['Name'] = recordData['Name'];
				data['Key'] = recordData['Key'];
				return data;
			});

			return dataTable;
		}
	</script>
</body>
</html>

<script runat="server">
    LicenseResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as LicenseResource;
    }
</script>

