    <%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html class="login" xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title><%= LoginLabels.Title %></title>
	<polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam login">
<div id="mainlogin">
    <div id="messagebox"></div>
    <div id="login-top"></div>
    <div id="login-body">
        <div id="panelLogin">
            <div id="branding"><%= optionsService.HelpDeskTitle %></div>
            <div id="loginForm">
	            <div >
		            <label><%= CommonLabels.Username %></label>
		            <!-- <input id="_username" type="text" class="psTextbox psLoginText" value="<%= Context.User.Identity.Name %>" /> -->
		            <input id="_username" type="text" class="psTextbox psLoginText" />
	            </div>
	            <div>
		            <label><%= CommonLabels.Password%></label>
		            <input id="_password" type="password"  class="psTextbox psLoginText" />
	            </div>
	            <div>
	                <input id="loginbutton" type="button" value="<%= CommonLabels.LogIn %>" />
	            </div>
	            
	            <div>
					<%
						if (!PerformAutomaticLoginIfRequested())
						{
							%><label style="color: red;"><%= AuthenticationLabels.InvalidUsernameOrPassword.ToString() %></label><%
						}
					%>
	            </div>

	            <div>
					<%
						if (AuthorisationHelper.GetPostAndGetAuthorizationOnUri("registercontact/" + optionsService.RegisterContactTemplate))
						{
							%><a href="<%= UrlHelper.GetUrl("registercontact/") + optionsService.RegisterContactTemplate %>"><%= LoginLabels.registerNewContact%></a>, <%
						}
	              	%>
	                <a href="#" id="forgetPassword"><%= LoginLabels.IForgottenPassword%></a>
	            </div>
	        </div>

	        <div id="passwordReminder" style="display:none">
	            <div>
	                <p><%= LoginLabels.ForgottenPasswordText %></p>
		            <label><%= CommonLabels.Email %></label>
		            <input id="emailTextBox" type="text" class="psTextbox psLoginText" />
		        </div>
		        <div>
		            <input id="sendEmailButton" type="button" value="<%= CommonLabels.SendEmail %>" />
		            <span><a href="#" id="cancelForgetPassword" >cancel</a></span>
		        </div>
	        </div>

	        <div>
                <label><%= optionsService.WelcomeMessage %></label>
            </div>
        </div>
    </div>
    <div id="login-bottom"></div>
</div>
    <div id="ft" class="footer" >
        Need Help? See <a href="http://help.polarsoftware.com/phd/">Help Section</a> or contact us at <a href="mailto:support@polarsoftware.com">support@polarsoftware.com</a><br />
    </div>
    <div class="footer2" >
        Polar Help Desk Version: <span id="helpdeskVersion"></span>, Database Version: <span id="databaseVersion"></span><br />
        <a href="http://www.polarsoftware.com">Help Desk Software</a> by Polar <br />        
    </div>

    <script type="text/javascript">
        var resource = { "Errors": [], "Messages": [<% if (authenticationResult != AuthenticationResult.SuccessfullyAuthenticated ) {%> "<%= AuthenticationLabels.GetLabel(authenticationResult).ToString()%>" <% } %>] }
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        $(document).ready(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();

            $("#forgetPassword").click(function() {
                $("#messagebox").hide("fast");
                $("#loginForm").toggle();
                $("#passwordReminder").toggle();
            });

            $("#cancelForgetPassword").click(function() {
                $("#messagebox").hide("fast");
                $("#passwordReminder").toggle();
                $("#loginForm").toggle();
            });

            var loginFunction = function(e) {
                var code = (e.keyCode ? e.keyCode : e.which);
                if (code == 13) {
                    e.data.action();
                }
            }
            
            if(!navigator.cookieEnabled)
            {
				$("#messagebox").html("Cookies are not allowed to be saved by your browser. Please enable cookies in your browser settings before attempting to log in.<br><br>"
					+ "To do this in Internet Explorer, you must go to Tools/Internet Options and on Privacy tab move the slider until it changes to Accept All Cookies. For the changes to be applied, you must restart your browser by closing all instances of Internet Explorer.");
				$("#messagebox").show();
            }

            $('#_password').bind('keypress', { action: POLAR.View.Page.logIn }, loginFunction);
            $('#_username').bind('keypress', { action: POLAR.View.Page.logIn }, loginFunction);
            $('#emailTextBox').bind('keypress', { action: POLAR.View.Page.sendEmail }, loginFunction);
        });

        /*YAHOO.util.Event.addListener(window, 'load', function() {
        POLAR.View.CheckForExtraInfo();
        POLAR.View.Page();
        });*/

        POLAR.View.Page = function() {

            var oLoginButton = new YAHOO.widget.Button("loginbutton");
            oLoginButton.on("click", POLAR.View.Page.logIn);
            var oSendEmailButton = new YAHOO.widget.Button("sendEmailButton");
            oSendEmailButton.on("click", POLAR.View.Page.sendEmail);
            //YAHOO.util.Event.addListener(YAHOO.util.Dom.get('loginbutton'), 'click', POLAR.View.Page.logIn);
            //YAHOO.util.Event.addListener(YAHOO.util.Dom.get('sendEmailButton'), 'click', POLAR.View.Page.sendEmail);

            /*var api1 = $("#mainlogin").expose({ api: true, lazy: true, color: '#AAAAAA', opacity: '0.8' });
            $(function() {
            // expose the form when it's clicked
            $("#mainlogin").click(function() {
            api1.load();
            });
            });*/
        }

        POLAR.View.Page.logIn = function() {
            var _usernameElement = YAHOO.util.Dom.get('_username');
            var _passwordElement = YAHOO.util.Dom.get('_password');
            var url = '<%= UrlHelper.GetUrl("/api/login") %>';

            var data = {
                "<%= LoginResource.Meta.Username.Name %>": _usernameElement.value,
                "<%= LoginResource.Meta.Password.Name %>": _passwordElement.value
            }

            POLAR.View.asyncPost(url, data, function(logIn) {
                /*window.location = '<%= UrlHelper.GetUrl("/home/iperson/") %>' + logIn.AuthenticatedUserID;*/
                window.location = logIn.StartingURL;
            });
        }

        POLAR.View.Page.sendEmail = function() {

            // Show the Panel
            //YAHOO.WorkingBox.wait.show();
            POLAR.View.TopWorkingStart();

            var _emailElement = YAHOO.util.Dom.get('emailTextBox');
            var url = '<%= UrlHelper.GetUrl("/api/forgottenpassword") %>';

            var data = {
                "<%= ForgottenPasswordResource.Meta.Email.Name %>": _emailElement.value
            }

            POLAR.View.asyncPost(url, data, function(forgottenPassword) {
                // Hide the Panel
                //YAHOO.WorkingBox.wait.hide();
                POLAR.View.TopWorkingEnd();
                $("#messagebox").empty();
                $("#messagebox").append('<%= LoginLabels.NewPasswordSent %>');
                $("#messagebox").show();
            });
        }
    </script>

    <script runat="server">
        OptionsService optionsService = IoC.Container.Resolve<OptionsService>();
        AuthenticationResult authenticationResult = AuthenticationResult.SuccessfullyAuthenticated;

        protected void Page_Load(object sender, EventArgs e)
        {
            ActionLogHelper.TrackRequest();
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            LogoutIfRequested();
        }

        private void LogoutIfRequested()
        {
            if (null != Request.QueryString["logout"])
                AuthenticationHelper.Logout();
        }

        private bool PerformAutomaticLoginIfRequested()
        {
            string username = Request.QueryString["username"];
            string password = Request.QueryString["password"];

            if (!string.IsNullOrEmpty(username))
            {
                AuthenticationHelper.Logout();
                authenticationResult = AuthenticationHelper.Authenticate(username, password, false);

				if (AuthenticationResult.SuccessfullyAuthenticated == authenticationResult)
				{
                    // redirect to URI we can access
					IdentityContext identityContext = IoC.Container.Resolve<IdentityContext>();
					if (identityContext.AuthenticatedUser.IsUserInAccount() == true)
					{
						GetAccountIncidentPermision();
					}
					else if (identityContext.AuthenticatedUser.IsUserInTeam() == true)
					{
                        GetTeamIncidentPermision();
					}
				}
				else
				{
					return false;
				}
            }

			return true;
        }

        private void GetTeamIncidentPermision()
        {
            AuthorizationService authorizationService = IoC.Container.Resolve<AuthorizationService>();
            Permission permission;
            if (authorizationService.CurrentPermissions.TryGetValue("/incidents", out permission) == true)
            {
                //Ako korisnik ima pravo na cijeli URI Tempalte onda neam smisla izlistavati sve URI toga oblika jer ocito ima pravo na temeljni URI , znaci taj URI TEmpalte Menu Item brisemo iz menija
                if (permission.Get == true)
                {
                    Response.Redirect(UrlHelper.GetUrl("/incidents?maxresults=100"));
                    return;
                }
            }

            IdentityContext identityContext = IoC.Container.Resolve<IdentityContext>();
            foreach (BusinessUnit team in identityContext.AuthenticatedUser.Data.BusinessUnits)
            {
                if (team.BusinessUnitType == BusinessUnitType.Team)
                {
                    string uriTmp = "/incidents/team/" + team.ID;
                    // uri must be in format "/incidents/team/{TeamID}/deleted"
                    if (authorizationService.CurrentPermissions.TryGetValue(uriTmp, out permission) == true)
                    {
                        if (permission.Get == true)
                        {
                            Response.Redirect(UrlHelper.GetUrl(uriTmp + "?maxresults=100"));
                        }
                    }
                    if (authorizationService.CurrentPermissions.TryGetValue("/incidents/team/{teamid}", out permission) == true)
                    {
                        if (permission.Get == true)
                        {
                            Response.Redirect(UrlHelper.GetUrl(uriTmp + "?maxresults=100"));
                        }
                    }
                }
            }
        }

        private void GetAccountIncidentPermision()
        {
            AuthorizationService authorizationService = IoC.Container.Resolve<AuthorizationService>();
            Permission permission;
            if (authorizationService.CurrentPermissions.TryGetValue("/incidentcontacts", out permission) == true)
            {
                //Ako korisnik ima pravo na cijeli URI Tempalte onda neam smisla izlistavati sve URI toga oblika jer ocito ima pravo na temeljni URI , znaci taj URI TEmpalte Menu Item brisemo iz menija
                if (permission.Get == true)
                {
                    Response.Redirect(UrlHelper.GetUrl("/incidentcontacts?maxresults=100"));
                }
            }

            IdentityContext identityContext = IoC.Container.Resolve<IdentityContext>();
            foreach (BusinessUnit account in identityContext.AuthenticatedUser.Data.BusinessUnits)
            {
                if (account.BusinessUnitType == BusinessUnitType.Account)
                {
                    string uriTmp = "/incidentcontacts/account/" + account.ID;
                    // uri must be in format "/incidents/team/{TeamID}/deleted"
                    if (authorizationService.CurrentPermissions.TryGetValue(uriTmp, out permission) == true)
                    {
                        if (permission.Get == true)
                        {
                            Response.Redirect(UrlHelper.GetUrl(uriTmp + "?maxresults=100"));
                        }
                    }
                    if (authorizationService.CurrentPermissions.TryGetValue("/incidentcontacts/account/{accountid}", out permission) == true)
                    {
                        if (permission.Get == true)
                        {
                            Response.Redirect(UrlHelper.GetUrl(uriTmp + "?maxresults=100"));
                        }
                    }
                }
            }

            // no global or account incident URIs with permission to read, resolve to reading own incidents
            Response.Redirect(UrlHelper.GetUrl("/incidentcontacts/contact/iperson/" + identityContext.AuthenticatedUser.ID.ToString() + "?maxresults=100"));
        }
    </script>          
</body>
</html>
