<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= DocumentLabels.DocumentHistory %></title>
    <polar:CssIncludes runat="server"/>
</head>

<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <span><%= CommonLabels.Search%>:</span>
    <input id="_textsearch" type="text" />
    <input id="_gobutton" type="button" value="Go" />

    <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>

    <polar:Footer runat="server" />
	<polar:Includes runat="server" />

	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of select all javascipt code -> onclick = "POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)"
		YAHOO.util.Event.addListener(window, 'load', function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.NamespaceHistories);
		    var dataSource = POLAR.View.DataTable.createDataSource(resource);
			dataSource.responseSchema = {
			    resultsList: 'Items',
			    fields: [{ key: '<%= NamespaceHistoryResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber }, '<%= NamespaceHistoryResource.Meta.Title.Name %>', '<%= NamespaceHistoryResource.Meta.URL.Name %>']
			};

			dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ key: '<%= NamespaceHistoryResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: '<%= NamespaceHistoryResource.Meta.Title.Name %>', label: '<%= CommonLabels.Title %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl }
			], dataSource, {
				sortedBy: { key: '<%= NamespaceHistoryResource.Meta.Title.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
        		draggableColumns: true,
        		paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

			POLAR.View.DataTable.configDataTable(dataTable);
			//POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
			//set with on first and second colon for beter visula efect
			$("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');

			var controlAndQueryItems = { "entities": [
                    { "id": "_textsearch", "queryVariable": "textsearch", "control": "textbox" }
                ]
			};

			YAHOO.util.Event.addListener(YAHOO.util.Dom.get('_gobutton'), 'click', function() { POLAR.View.CreateUrlAndCallUrl(controlAndQueryItems); });
			POLAR.View.OnLoadFillControlFromUrlQuery(controlAndQueryItems);
		};
	</script>

	<script runat="server">
        string _jsonResRep;

	    protected void Page_Load(object sender, EventArgs e)
	    {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>