<%@ Page Language="C#" %>
<%@ Import Namespace="Polar.ServiceDesk.HelpDesk.Configuration"%>
<%@ Import Namespace="Polar.ServiceDesk.WebUserInterface.Desktops"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= RegisterContactLabels.registerContactTitle %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">

	<div id="doc3">
	<div id="bd"><!-- body -->
	<div id="yui-main"><!-- main desktop content -->
            <div class="yui-b midletop"> </div>
            <div id='idmidle2' class="yui-b midle">
                <table border="0" cellpadding="0" cellspacing="0" width="100%" class="resourceHeader" >
                    <tbody>
                        <tr >
                            <!--
                            <td class="draghandler">
                                 <ul id="sortablesource">
                                    <li class="draghandler1"></li>
                                </ul>
                            </td> -->
                            <td class="headermessage" >
                                <span id='idResourceName' class="resourceName"></span>
                            </td>
                            <!-- <td class="headermessage">
                                <div id='messagebox2'></div>
                            </td> -->
                            <td class="headermessage">
                                <span id="messagebox"></span>
                            </td>
                            <td class="headermessage">
                                <div id='messageBoxDialog' title=''></div>
                                <span id="openMessageDialog"></span>
                            </td>
                        </tr>
                </tbody>
                </table>

	<div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
		<div style="margin:20px; width: 800px; margin-left: auto; margin-right: auto; padding:50px; border:solid 10px #ccc; background: white;">
			<div>
				<div>
					<input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
					<input id="returnToLogin" type="button" value="<%= RegisterContactLabels.ReturnToLogin %>" />
				</div>

				<br />

				<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
					<colgroup>
						<col class="psColon1">
						<col>
						<col class="psColMid">
						<col class="psColon3">
						<col>
					</colgroup>
					<tbody>
						<tr>
							<td class="psFormCell psLabelRequire">
								<span><%= RegisterContactLabels.UserName %></span>
								<span id="<%= resource.UserName.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.UserName.Name %>" class="psTextbox" type="text" value="<%= resource.UserName %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.Title %></span>
								<span id="<%= resource.Title.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.Title.Name %>" class="psTextbox" type="text" value="<%= resource.Title %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.UserFirstName %></span>
								<span id="<%= resource.FirstName.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.FirstName.Name %>" class="psTextbox" type="text" value="<%= resource.FirstName %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.WebPage %></span>
								<span id="<%= resource.WebPage.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.WebPage.Name %>" class="psTextbox" type="text" value="<%= resource.WebPage %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.UserLastName %></span>
								<span id="<%= resource.LastName.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.LastName.Name %>" class="psTextbox" type="text" value="<%= resource.LastName %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell psLabelRequire">
								<span><%= RegisterContactLabels.Email %></span>
								<span id="<%= resource.Email.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.Email.Name %>" class="psTextbox" type="text" value="<%= resource.Email %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell psLabelRequire">
								<span><%= RegisterContactLabels.Password %></span>
								<span id="<%= resource.Password.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.Password.Name %>" class="psTextbox" type="password" value="<%= resource.Password %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell psLabelRequire">
								<span><%= RegisterContactLabels.RepeatEmail %></span>
								<span id="<%= resource.RepeatEmail.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.RepeatEmail.Name %>" class="psTextbox" type="text" value="<%= resource.RepeatEmail %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell psLabelRequire">
								<span><%= RegisterContactLabels.RepeatPassword %></span>
								<span id="<%= resource.RepeatPassword.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.RepeatPassword.Name %>" class="psTextbox" type="password" value="<%= resource.RepeatPassword %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell psLabelRequire">
							</td>
							<td class="psFormCell">
							</td>
						</tr>
						<tr>
							<td class="psFormCell psBar" colSpan="2"><%=UserLabels.Telephones%></td>
							<td class="psFormMid"></td>
							<td class="psFormCell psBar" colSpan="2"><%=UserLabels.Address%></td>
						</tr>						
						<tr class="psAfterBar" ><td></td></tr>
						<td class="psFormCell">
								<span><%= RegisterContactLabels.TelephoneNumber %></span>
								<span id="<%= resource.TelephoneNumber.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.TelephoneNumber.Name %>" class="psTextbox" type="text" value="<%= resource.TelephoneNumber %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.Street %></span>
								<span id="<%= resource.Street.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.Street.Name %>" class="psTextbox" type="text" value="<%= resource.Street %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.TelephoneHome %></span>
								<span id="<%= resource.TelephoneHome.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.TelephoneHome.Name %>" class="psTextbox" type="text" value="<%= resource.TelephoneHome %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.City %></span>
								<span id="<%= resource.City.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.City.Name %>" class="psTextbox" type="text" value="<%= resource.City %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.TelephoneMobile %></span>
								<span id="<%= resource.TelephoneMobile.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.TelephoneMobile.Name %>" class="psTextbox" type="text" value="<%= resource.TelephoneMobile %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.StateProvince %></span>
								<span id="<%= resource.StateProvince.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.StateProvince.Name %>" class="psTextbox" type="text" value="<%= resource.StateProvince %>" />
							</td>
						</tr>
						<tr>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.TelephonePage %></span>
								<span id="<%= resource.TelephonePage.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.TelephonePage.Name %>" class="psTextbox" type="text" value="<%= resource.TelephonePage %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.ZipPostalCode %></span>
								<span id="<%= resource.ZipPostalCode.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.ZipPostalCode.Name %>" class="psTextbox" type="text" value="<%= resource.ZipPostalCode %>" />
							</td>
						</tr>
						 <tr>
							<td class="psFormCell">
								<span><%= RegisterContactLabels.TelephoneFax %></span>
								<span id="<%= resource.TelephoneFax.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<input id="<%= resource.TelephoneFax.Name %>" class="psTextbox" type="text" value="<%= resource.TelephoneFax %>" />
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= CommonLabels.CountryRegion %></span>
								<span id="<%= resource.ZipPostalCode.Name + "error" %>"></span>
							</td>
							<td class="psFormCell">
								<select id="CountryRegion.ID" class="styled">
									<option value=""></option>
									<% foreach (CountryRegion item in _countryRegionRepository.GetAll()) {%>
									<option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CountryRegion.Value && item.ID == resource.CountryRegion.Value.ID.Value) %>><%= item.Name %></option>
									<% } %>
								</select>
							</td>
						</tr>
						<tr>
							<td class="psFormCell psBar" colSpan="5"><span><%= UserLabels.ProfileStatus %></td>
						</tr>
						<tr class="psAfterBar" ><td></td></tr>
						<tr>
							<td class="psFormCell">
								<span><%= BusinessUnitLabels.Language %></span>
							</td>
							<td class="psFormCell">
								<select id="Language.ID" class="styled">
									<option value=""></option>
									<% foreach (Language item in _languageRepository.GetAllLanguages()) {%>
									<option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Language.Value && item.ID == resource.Language.Value.ID.Value) %>><%= item.Name %></option>
									<% } %>
								</select>
							</td>
							<td class="psFormMid"></td>
							<td class="psFormCell">
								<span><%= UserLabels.ReceiveEmails%></span>
							</td>
							<td class="psFormCell">
								<input id="<%=resource.ReceiveEmails.Name %>" name="<%= resource.ReceiveEmails.Name %>" type="checkbox" <%= resource.ReceiveEmails.Value ? "checked" : string.Empty %> />
							</td>
						</tr>
					</tbody>
				</table>
			</div>
		</div>
    </div>

    <script type="text/javascript">
        var resource = <%=_jsonResRep%> ;
    </script>
    <polar:Footer runat="server" />
    <polar:Includes runat="server" />

    <script type="text/javascript">
		YAHOO.util.Event.onDOMReady( function() {
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

        POLAR.View.Page = function() {
			var oCreateButton = new YAHOO.widget.Button("returnToLogin");
			oCreateButton.on("click", function() {
				window.location = "<%= UrlHelper.GetUrl("login") %>";
			});
		};
    </script>
    <script runat="server">
        OptionsService _optionsService = IoC.Container.Resolve<OptionsService>();
        CountryRegionRepository _countryRegionRepository = IoC.Container.Resolve<CountryRegionRepository>();
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();

        RegisterContactResource resource;
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
			PageHelper.RedirectToInstallationIfNoDatabaseFound();

			ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
			//resource = (RegisterContactResource)responsePageRequest.Resource;
            resource = resourceHandlerResult.EntityResoruceRepresentation as RegisterContactResource;
        }
    </script>
</body>
</html>
