﻿<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= ReportLabels.Report%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
        <div class="psFormToolbar">
            <table class="formActions" border="0" cellpadding="0" cellspacing="0">
                <tbody>
                <tr>
                    <td style="text-align:left"><span class="reportTitle" id="Title"></span> </td>
                    <td style="text-align:right"><a id="reportEdit"></a></td>
	            <tr>
	            <tbody>
            </table>
        </div>
       <div id="reportContent"></div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript" src="<%= ResolveUrl("~/javascripts/jqueryplugins_1_1/jquery.flot.js") %>"></script>
    <script type="text/javascript" src="<%= ResolveUrl("~/javascripts/jqueryplugins_1_1/jquery.flot.stack.js") %>"></script>
    <script type="text/javascript" src="<%= ResolveUrl("~/javascripts/jqueryplugins_1_1/excanvas.min.js") %>"></script>

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.Initialization();
            POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Report);
		    try {
		        var strURL = resource.URL.replace(/report/i, "reportedit"); //TODO:SP:Implement chaching UserResourcePermissions.reportedit URI and if do not have GET right do  not show link
		        $("#reportEdit").attr("href", strURL);
		        $("#reportEdit").text(resource.Labels.EditReport);
		        if (resource.Data != "undefine") {
		            if (resource.Data != "") {
		                try {
		                    var objJsonResRepData = YAHOO.lang.JSON.parse(resource.Data); //sama as:->  var objJsonData = eval('(' + resource.Data + ')');
		                }
		                catch (exception) {
		                    $('#messagebox').text("Exception in javascrtip souce code: YAHOO.lang.JSON.parse(resource.Data)" + " ... " + exception.toString());
		                    $("#messagebox").show();
		                }

		                $('#Title').text(objJsonResRepData.Title);
		                if (typeof (objJsonResRepData.ClientSideJavaScriptCode) !== "undefined" && objJsonResRepData.ClientSideJavaScriptCode != null) {
		                    try {
		                        eval(objJsonResRepData.ClientSideJavaScriptCode); //execute JS client side
		                    }
		                    catch (exception) {
		                        $('#messagebox').text("Exception in javascrtip souce code: eval(objJsonData.ClientSideJavaScriptCode);" + " ... " + exception.toString());
		                        $("#messagebox").show();
		                    }
		                }
		            }
		        }
		    }
		    catch (exception) {
		        $('#messagebox').text("main exception: " + exception.toString());
		        $("#messagebox").show();
		    }
		};
	</script>
</body>
</html>

<script runat="server">
    ReportResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();
        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as ReportResource;
    }
</script>