<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= ReportLabels.ReportEdit%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
        <table class="formActions" border="0" cellpadding="0" cellspacing="0">
            <tbody>
            <tr>
                <td style="text-align:left">
                    <div id="toolbar"></div>
                </td>
	        <tr>
	        <tbody>
        </table>
    </div>        
	<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Title %></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="Title" class="psTextbox" type="text" />
			    </td>
            </tr>
        </tbody>
    </table>
    <div id="tabs" style="display: none">
	    <ul>
		    <li><a href="#tabs-1" id="tab1"></a></li>
		    <li><a href="#tabs-2" id="tab2"></a></li>
		    <!-- <li><a href="#tabs-3" id="tab3"></a></li> -->
	    </ul>
	   <div id="tabs-1">
            <div class="codeEditor">
                <textarea id="ServerSideJavaScriptCode" rows="25" cols="20" style="width:100%"></textarea>
            </div>
	    </div>
	    <div id="tabs-2">
            <div class="codeEditor">
                <textarea id="ClientSideJavaScriptCode" rows="25" cols="20" style="width:100%"></textarea>
            </div>
	    </div>
	    <!--
	    <div id="tabs-3">
            <textarea readonly="readonly" id="JsonResult" rows="25" cols="25" style="width:100%; height:650px;"></textarea>
	    </div>
	    -->
    </div>

    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">

   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.Initialization();
   	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		var codeEditor1 = 0;
		var codeEditor2 = 0;

		POLAR.View.Page = function() {
		POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ReportEdit);
		    try {
		        var readOnlyEditor = false;
		        //if (resource.ID == 0) {
		        if (resource.Data === null) {// repalce with code which compare URI Tempalte on "/reportedit"
		            $("#toolbar").append("<input id='buttonCreateReport' <% if(!PageHelper.AuthorisePostRequest()) {%>disabled='disabled'<%}%> type='button'/>");
		            $("#buttonCreateReport").val(resource.LabelsCommon.CreateButton);
		            var createReportButton = new YAHOO.widget.Button("buttonCreateReport");
		            var onCreateReportData = function() {
		                $("#messagebox").hide("fast");
		                var objJsonData = {};
		                objJsonData.ServerSideJavaScriptCode = codeEditor1.mirror.getCode();
		                objJsonData.ClientSideJavaScriptCode = codeEditor2.mirror.getCode();
		                var title = $('#Title').val();
		                objJsonData.Title = title;
		                objJsonData.Deleted = false;
		                objJsonData.URI = "report/" + title;
		                objJsonData.URIBase = title;
		                objJsonData.JsonResult = "";
		                resource.Data = YAHOO.lang.JSON.stringify(objJsonData);

		                if (title.length == 0) {
		                    $('#messagebox').text(resource.Labels.TitleEmpty);
		                    $("#messagebox").show();
		                    return;
		                }
		                resource.URIBase = title;
		                var newResRepr = POLAR.View.clearExtraJSResRepForPUTandDELETE(resource);
		                var transaction = YAHOO.util.Connect.asyncRequest('POST', UserResourcePermissions.VirtualUrl + '/api/reportedit', POLAR.View.requestCallbackOnPostRedirect, YAHOO.lang.JSON.stringify(newResRepr));
		            }
		            createReportButton.on("click", onCreateReportData);

		        }
		        else {
		            $("#toolbar").append("<input id='buttonSaveReport' <% if(!PageHelper.AuthorisePutRequest()) {%>disabled='disabled'<%}%> type='button'/>");
		            var objJsonData2 = YAHOO.lang.JSON.parse(resource.Data);
		            if (objJsonData2.Deleted == true) {
		                $("#buttonSaveReport").val(resource.LabelsCommon.UndeleteButton);
		                readOnlyEditor = true;
		                var undeleteButton = new YAHOO.widget.Button("buttonSaveReport");
		                var onUndeleteButton = function() {
		                    $("#messagebox").hide("fast");
		                    var objJsonData4 = YAHOO.lang.JSON.parse(resource.Data);
		                    objJsonData4.Deleted = false;
		                    resource.Data = YAHOO.lang.JSON.stringify(objJsonData4);
		                    var apiURL = (UserResourcePermissions.VirtualUrl + "/api/" + "reportedit/" + objJsonData4.Guid);
		                    POLAR.View.requestCallbackAndRedirectExt.argument = { URL: UserResourcePermissions.VirtualUrl + "/reportedit/" + objJsonData4.Guid };
		                    var newResRepr = POLAR.View.clearExtraJSResRepForPUTandDELETE(resource);
		                    var transaction = YAHOO.util.Connect.asyncRequest('PUT', apiURL, POLAR.View.requestCallbackAndRedirectExt, YAHOO.lang.JSON.stringify(newResRepr));
		                }
		                undeleteButton.on("click", onUndeleteButton);
		            }
		            else {
		                $("#buttonSaveReport").val(resource.LabelsCommon.SaveButton);
		                $("#toolbar").append("<input id='buttonDelete' <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled='disabled'<%}%> type='button' />");
		                $("#buttonDelete").val(resource.LabelsCommon.DeleteButton);
		                var deleteReportButton = new YAHOO.widget.Button("buttonDelete");

		                var onDeleteReportButton = function() {
		                    $("#messagebox").hide("fast");
		                    var objJsonData3 = YAHOO.lang.JSON.parse(resource.Data);
		                    objJsonData3.Deleted = true;
		                    resource.Data = YAHOO.lang.JSON.stringify(objJsonData3);
		                    var apiURL = UserResourcePermissions.VirtualUrl + "/api/" + "reportedit/" + objJsonData3.Guid;
		                    POLAR.View.requestCallbackAndRedirectExt.argument = { URL: UserResourcePermissions.VirtualUrl + "/reportedit/" + objJsonData3.Guid + "/deleted" };
		                    var newResRepr = POLAR.View.clearExtraJSResRepForPUTandDELETE(resource);
		                    var transaction = YAHOO.util.Connect.asyncRequest('DELETE', apiURL, POLAR.View.requestCallbackAndRedirectExt, YAHOO.lang.JSON.stringify(newResRepr));

		                }
		                deleteReportButton.on("click", onDeleteReportButton);
		                resource["URI"] = (UserResourcePermissions.VirtualUrl + "/api/" + "reportedit/" + objJsonData2.Guid);
		                var strURL = (UserResourcePermissions.VirtualUrl + "/report/" + objJsonData2.Guid); //TODO:SP:Implement chaching UserResourcePermissions.reportedit URI and if do not have GET right do not show link
		                $("#toolbar").append("<a id='reportView'></a> ");
		                $("#toolbar").append("<a id='reportEditHistories'></a>");
		                $("#reportView").attr("href", strURL);
		                $("#reportView").text(resource.Labels.ViewReport);
		                strURL = UserResourcePermissions.VirtualUrl + "/reportedithistories?report.id=" + objJsonData2.Guid;
		                $("#reportEditHistories").attr("href", strURL);
		                $("#reportEditHistories").text(resource.Labels.ReportEditHistories);

		                var saveReportButton = new YAHOO.widget.Button("buttonSaveReport");
		                var onSaveReportButton = function() {
		                    $("#messagebox").hide("fast");
		                    var objJsonData = YAHOO.lang.JSON.parse(resource.Data);
		                    objJsonData.ServerSideJavaScriptCode = codeEditor1.mirror.getCode();
		                    objJsonData.ClientSideJavaScriptCode = codeEditor2.mirror.getCode();
		                    objJsonData.Title = $('#Title').val();
		                    //objJsonData.JsonResult = $('#JsonResult').val();
		                    resource.Data = YAHOO.lang.JSON.stringify(objJsonData);
		                    var apiURL = (UserResourcePermissions.VirtualUrl + "/api/" + "reportedit/" + objJsonData2.Guid);
		                    var newResRepr = POLAR.View.clearExtraJSResRepForPUTandDELETE(resource);
		                    var transaction = YAHOO.util.Connect.asyncRequest('PUT', apiURL, POLAR.View.requestCallback, YAHOO.lang.JSON.stringify(newResRepr));
		                }
		                saveReportButton.on("click", onSaveReportButton);
		            }

		            /*
		            var index = resource.URL.lastIndexOf("deleted", (resource.URL.length - "deleted".length))// do not do if links URI is /reportedit/{ReportName}/deleted or New report
		            if (index != -1) {
		            $("#buttonSaveReport").val(resource.LabelsCommon.UndeleteButton);
		            }
		            else {
		            $("#buttonSaveReport").val(resource.LabelsCommon.SaveButton);
		            $("#toolbar").append("<input id='buttonDelete' type='button' />");
		            $("#buttonDelete").val(resource.LabelsCommon.DeleteButton);
		            var deleteReportButton = new YAHOO.widget.Button("buttonDelete");
		            deleteReportButton.on("click", POLAR.View.onDeleteData);

		                var strURL = resource.URL.replace(/reportedit/i, "report"); //TODO:SP:Implement chaching UserResourcePermissions.reportedit URI and if do not have GET right do  not show link
		            $("#toolbar").append("<a id='reportView'></a> ");
		            $("#toolbar").append("<a id='reportEditHistories'></a>");
		            $("#reportView").attr("href", strURL);
		            $("#reportView").text(resource.Labels.ViewReport);
		            strURL = resource.URL.replace(/reportedit/i, "reportedithistories");
		            //$("#reportEditHistories").attr("href", resource.HistoryURL); //http://localhost:5650/phd/reportedithistories/rep1
		            $("#reportEditHistories").attr("href", strURL); //http://localhost:5650/phd/reportedithistories/rep1
		            $("#reportEditHistories").text(resource.Labels.ReportEditHistories);
		            }
		            */
		        }

		        if (resource.Data != null) {
		            var objJsonData = YAHOO.lang.JSON.parse(resource.Data);
		            $('#ServerSideJavaScriptCode').text(objJsonData.ServerSideJavaScriptCode);
		            $('#ClientSideJavaScriptCode').text(objJsonData.ClientSideJavaScriptCode);
		            //$('#JsonResult').text(objJsonData.JsonResult);
		            $('#Title').val(objJsonData.Title);
		        }

		        $("#tab1").text(resource.Labels.SSJS);
		        $("#tab2").text(resource.Labels.CSLS);
		        //$("#tab3").text(resource.Labels.JsonResult);

		    }
		    catch (exception) {
		        $('#messagebox').text(exception.toString());
		        $("#messagebox").show();
		    }

		    var textarea1 = document.getElementById('ServerSideJavaScriptCode');
		    codeEditor1 = new MirrorFrame(CodeMirror.replace(textarea1), "textarea1", {
		        height: "650px",
		        width: "100%",
		        tabMode: "spaces",
		        content: textarea1.value,
		        parserfile: ["tokenizejavascript.js", "parsejavascript.js"],
		        stylesheet: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/css/jscolors.css",
		        path: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/js/",
		        readOnly: readOnlyEditor,
		        autoMatchParens: true
		    });

		    var textarea2 = document.getElementById('ClientSideJavaScriptCode');
		    codeEditor2 = new MirrorFrame(CodeMirror.replace(textarea2), "textarea2", {
		        height: "650px",
		        width: "100%",
		        content: textarea2.value,
		        parserfile: ["tokenizejavascript.js", "parsejavascript.js"],
		        stylesheet: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/css/jscolors.css",
		        path: UserResourcePermissions.VirtualUrl + "/javascripts/codemirror_0_61/js/",
		        readOnly: readOnlyEditor,
		        autoMatchParens: true
		    });

		    $("#tabs").tabs();
		    $("#tabs").show("fast");
		}
	</script>
</body>
</html>

<script runat="server">
    ReportEditResource resource;
    string _jsonResRep;
	ReportRepository _reportRepository = IoC.Container.Resolve<ReportRepository>();

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as ReportEditResource;
    }
</script>

