<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <% if(0 == resource.ID.Value) {
                    %>                    
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                    else if (resource.Deleted.Value)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                </div>

            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= ServiceLevelLabels.OperationalTime %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell psLabelRequire">
    		    </td>
			    <td class="psFormCell" colspan="4">
                    <table>
	                    <tr>
		                    <td colspan="3"><span><%= ServiceLevelLabels.OperationalHours %></span></td>
	                    </tr>
	                    <tr>
		                    <td><span><%= ServiceLevelLabels.OperationalHoursDayOfTheWeek %></span></td>
		                    <td><span><%= ServiceLevelLabels.OperationalHoursStartAt %></span></td>
		                    <td><span><%= ServiceLevelLabels.OperationalHoursEndAt %></span></td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.MondayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.MondayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.MondayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Monday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.MondayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.MondayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.MondayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.MondayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.MondayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.MondayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.MondayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.MondayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.TuesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.TuesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.TuesdayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Tuesday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.TuesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.TuesdayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.TuesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.TuesdayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.TuesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.TuesdayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.TuesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.TuesdayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.WednesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.WednesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.WednesdayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Wednesday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.WednesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.WednesdayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.WednesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.WednesdayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.WednesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.WednesdayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.WednesdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.WednesdayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.ThursdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.ThursdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.ThursdayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Thursday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.ThursdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.ThursdayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.ThursdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.ThursdayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.ThursdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.ThursdayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.ThursdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.ThursdayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.FridayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.FridayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.FridayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Friday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.FridayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.FridayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.FridayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.FridayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.FridayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.FridayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.FridayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.FridayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.SaturdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.SaturdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.SaturdayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Saturday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.SaturdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.SaturdayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.SaturdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.SaturdayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.SaturdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.SaturdayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.SaturdayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.SaturdayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
	                    <tr>
		                    <td>
                                <input id="<%= ServiceLevelResource.Meta.SundayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" name="<%= ServiceLevelResource.Meta.SundayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.Active.Name %>" type="checkbox" <%= resource.SundayWorkingHours.Value.Active.Value ? "checked" : string.Empty %> />
		                        <span><%= CommonLabels.Sunday %></span>
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.SundayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeHours.Name %>" type="text" value="<%= resource.SundayWorkingHours.Value.StartTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.SundayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.StartTimeMinutes.Name %>" type="text" value="<%= resource.SundayWorkingHours.Value.StartTimeMinutes %>" />
		                    </td>
		                    <td>
		                        <input id="<%= ServiceLevelResource.Meta.SundayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeHours.Name %>" type="text" value="<%= resource.SundayWorkingHours.Value.EndTimeHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.SundayWorkingHours.Name + "." + ServiceLevelWorkingHoursResource.Meta.EndTimeMinutes.Name %>" type="text" value="<%= resource.SundayWorkingHours.Value.EndTimeMinutes %>" />
		                    </td>
	                    </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= ServiceLevelLabels.BlockedDates %></span>
                </td>
			    <td class="psFormCell" colspan="4">
                    <input id="blockedDateText" type="text" />
                    <input id="addBlockedDate" type="button" value="<%= CommonLabels.Add %>" />

                    <div id="<%= ServiceLevelResource.Meta.BlockedDates.Name %>" class="yui-skin-sam"></div>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= ServiceLevelLabels.PriorityEscalation %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                </td>
			    <td class="psFormCell" colspan="4">
                    <table>
		                <tr>
			                <td colspan="2"><span><%= ServiceLevelLabels.PlanningPriority %></span></td>
	                    </tr>
	                    <tr>
			                <td>
			                    <span><%= ServiceLevelLabels.TimeLimit %></span>
				                <input id="<%= ServiceLevelResource.Meta.PlanningPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitHours.Name %>" type="text" value="<%= resource.PlanningPriorityEscalation.Value.TimeLimitHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.PlanningPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitMinutes.Name %>" type="text" value="<%= resource.PlanningPriorityEscalation.Value.TimeLimitMinutes %>" />
			                </td>
		                </tr>
		                <tr>
			                <td colspan="2"><span><%= ServiceLevelLabels.LowPriority %></span></td>
	                    </tr>
	                    <tr>
			                <td>
			                    <span><%= ServiceLevelLabels.TimeLimit %></span>
				                <input id="<%= ServiceLevelResource.Meta.LowPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitHours.Name %>" type="text" value="<%= resource.LowPriorityEscalation.Value.TimeLimitHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.LowPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitMinutes.Name %>" type="text" value="<%= resource.LowPriorityEscalation.Value.TimeLimitMinutes %>" />
			                </td>
		                </tr>
		                <tr>
			                <td colspan="2"><span><%= ServiceLevelLabels.MediumPriority %></span></td>
	                    </tr>
	                    <tr>
			                <td>
			                    <span><%= ServiceLevelLabels.TimeLimit %></span>
				                <input id="<%= ServiceLevelResource.Meta.MediumPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitHours.Name %>" type="text" value="<%= resource.MediumPriorityEscalation.Value.TimeLimitHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.MediumPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitMinutes.Name %>" type="text" value="<%= resource.MediumPriorityEscalation.Value.TimeLimitMinutes %>" />
			                </td>
		                </tr>
		                <tr>
			                <td colspan="2"><span><%= ServiceLevelLabels.HighPriority %></span></td>
	                    </tr>
	                    <tr>
			                <td>
			                    <span><%= ServiceLevelLabels.TimeLimit %></span>
				                <input id="<%= ServiceLevelResource.Meta.HighPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitHours.Name %>" type="text" value="<%= resource.HighPriorityEscalation.Value.TimeLimitHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.HighPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitMinutes.Name %>" type="text" value="<%= resource.HighPriorityEscalation.Value.TimeLimitMinutes %>" />
			                </td>
		                </tr>
		                <tr>
			                <td colspan="2"><span><%= ServiceLevelLabels.CriticalPriority %></span></td>
	                    </tr>
	                    <tr>
			                <td>
			                    <span><%= ServiceLevelLabels.TimeLimit %></span>
				                <input id="<%= ServiceLevelResource.Meta.CriticalPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitHours.Name %>" type="text" value="<%= resource.CriticalPriorityEscalation.Value.TimeLimitHours %>" />
			                    <span>:</span>
			                    <input id="<%= ServiceLevelResource.Meta.CriticalPriorityEscalation.Name + "." + ServiceLevelPriorityEscalationResource.Meta.TimeLimitMinutes.Name %>" type="text" value="<%= resource.CriticalPriorityEscalation.Value.TimeLimitMinutes %>" />
			                </td>
		                </tr>
	                </table>
	            </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ServiceLevel);
			POLAR.View.Page.blockedDatesDataTable = POLAR.View.Page.loadBlockedDatesDataTable();
		    YAHOO.util.Event.addListener(YAHOO.util.Dom.get('addBlockedDate'), 'click', POLAR.View.Page.addBlockedDate);
		    
		    $("#blockedDateText").datepicker({ dateFormat: 'yy/mm/dd' });
		}

	    POLAR.View.Page.addBlockedDate = function() {
		    var element = YAHOO.util.Dom.get('blockedDateText');
		    if(element.value != "") {
				POLAR.View.Page.blockedDatesDataTable.addRow({'<%= ServiceLevelBlockedDateResource.Meta.Date.Name %>': element.value});
				element.value = '';
			}
	    }

		POLAR.View.Page.loadBlockedDatesDataTable = function() {
			var dataSource = new YAHOO.util.DataSource(resource);
			dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

			dataSource.responseSchema = {
			    resultsList: '<%= ServiceLevelResource.Meta.BlockedDates.Name %>',
			    fields: ['<%= ServiceLevelBlockedDateResource.Meta.Date.Name %>']};

		    var formatRemoveRow = function(elCell, oRecord, oColumn, oData) {
		        var link = document.createElement("div");
		        link.className = 'remove';
		        elCell.appendChild(link);

		        YAHOO.util.Event.addListener(link, 'click', function(e) {
		            dataTable.deleteRow(oRecord);
		        });
		    };

			var columnDefinitions = [
				{ key: '', width:20, formatter: formatRemoveRow },
			    {key:'<%= ServiceLevelBlockedDateResource.Meta.Date.Name %>', label:'<%= CommonLabels.Date %>', sortable:true, resizeable:true, formatter:YAHOO.widget.DataTable.formatDate}];

			var element = YAHOO.util.Dom.get('<%= ServiceLevelResource.Meta.BlockedDates.Name %>');
			dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource);
			POLAR.View.setContainedObject(element, dataTable);

			POLAR.View.setDataTableRowReader(element, function(recordData) {
			    var data = new Object();
			    data['<%= ServiceLevelBlockedDateResource.Meta.Date.Name %>'] = recordData['<%= ServiceLevelBlockedDateResource.Meta.Date.Name %>'];
			    return data;
			});

			return dataTable;
		}
	</script>
</body>
</html>

<script runat="server">
    ServiceLevelResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as ServiceLevelResource;
    }
</script>

