<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%=UserLabels.UserEditTitle%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
		<tbody>
		    <tr>
		        <td style="text-align:left">
		            <div>
						<%
							if (0 == resource.ID.Value)
							{
								%>
								<input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
								<input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" /><%
							}
							else
							{
								if (_userRepository.GetByID((long)resource.ID.Value).Deleted)
								{
									%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
								}
								else
								{
									%>
										<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
										<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
									<%
								}
							}
						%>
						<button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                    </div>

		        </td>
		        <td style="text-align:right">
		            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= resource.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
		        </td>
			</tr>
		</tbody>
    </table>
    </div>
	<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire"><span><%=UserLabels.UserName%></span></td><td class="psFormCell"><input id="<%=resource.UserName.Name%>" class="psTextbox"  type="text" value="<%=resource.UserName%>" /></td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=UserLabels.Title%></span> </td>	 <td class="psFormCell"><input id="<%=resource.Title.Name%>" class="psTextbox"  type="text" value="<%=resource.Title%>" /> </td>
            </tr>

            <tr>
                <td class="psFormCell">   <span><%=UserLabels.UserFirstName%></span> <span id="<%=resource.FirstName.Name + "error"%>"></span> </td>    <td class="psFormCell"><input id="<%=resource.FirstName.Name%>" size="50" class="psTextbox"  type="text" value="<%=resource.FirstName%>" /> </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=UserLabels.WebPage%> </td>   <td class="psFormCell"></span>  <input id="<%=resource.WebPage.Name%>" class="psTextbox"  type="text" value="<%=resource.WebPage%>" /> </td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=UserLabels.UserLastName%></span> <span id="<%=resource.LastName.Name + "error"%>"></span> </td>    <td class="psFormCell"><input id="<%=resource.LastName.Name%>" class="psTextbox"  type="text" value="<%=resource.LastName%>" /> </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=UserLabels.Email%></td>	<td class="psFormCell"></span>  <input id="<%=resource.Email.Name%>" class="psTextbox"  type="text" value="<%=resource.Email%>" /></td>
            </tr>
            <tr>
                <td class="psFormCell psLabelRequire"><span><%=UserLabels.Password%></span> </td> <td class="psFormCell"><input id="<%=resource.Password.Name%>" class="psTextbox"  type="text" value="<%=resource.Password%>" /> </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell" colspan="2"></td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="2"><%=UserLabels.Telephones%></td>
				<td class="psFormMid"></td>
			    <td class="psFormCell psBar" colSpan="2"><%=UserLabels.Address%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><span><%=UserLabels.TelephoneNumber%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneNumber.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneNumber%>" />   </td>
				<td class="psFormMid"></td>
			    <td class="psFormCell"><span><%=UserLabels.Street%></td>   <td class="psFormCell"></span>  <input id="<%=resource.Street.Name%>" class="psTextbox"  type="text" value="<%=resource.Street%>" /></td>
            </tr>
            <tr>
                <td class="psFormCell"><span><%=UserLabels.TelephoneHome%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneHome.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneHome  %>" />     </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=UserLabels.City%></td><td class="psFormCell"></span>  <input id="<%=resource.City.Name%>" class="psTextbox"  type="text" value="<%=resource.City%>" />                         </td>
            <tr>
            </tr>
                <td class="psFormCell"><span><%=UserLabels.TelephoneMobile%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneMobile.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneMobile%>" />   </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=UserLabels.StateProvince%></td><td class="psFormCell"></span>  <input id="<%=resource.StateProvince.Name%>" class="psTextbox"  type="text" value="<%=resource.StateProvince  %>" />     </td>
            <tr>
            </tr>
                <td class="psFormCell"><span><%=UserLabels.TelephonePage%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephonePage.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephonePage  %>" />     </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%=UserLabels.ZipPostalCode%></td><td class="psFormCell"></span>  <input id="<%=resource.ZipPostalCode.Name%>" class="psTextbox"  type="text" value="<%=resource.ZipPostalCode  %>" />     </td>
            <tr>

            <tr>
			    <td class="psFormCell"><span><%=UserLabels.TelephoneFax%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneFax.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneFax   %>" />      </td>
				<td class="psFormMid"></td>
			    <td class="psFormCell"><span><%= CommonLabels.CountryRegion%></span></td>
			    <td class="psFormCell">
			        <select id="CountryRegion.ID" class="styled">
		                <option value=""></option>
		                <%
						  	foreach (CountryRegion item in _countryRegionRepository.GetAll())
							{
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CountryRegion.Value && item.ID == resource.CountryRegion.Value.ID.Value) %>><%= item.Name%></option><%
							}
                    	%>
	                </select>
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=CommonLabels.Team%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="Teams" class="yui-skin-sam"></div></td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.Token %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"><span><%= UserLabels.UserAPIToken %></span></td>
                <td class="psFormCell" colspan="4">
					<input id="Token" type="text" class="psTextbox"  value="<%= resource.Token %>" /><br />
					<input id="generatetoken" type="button" value="<%= UserLabels.GenerateNewToken %>" />
					<input id="removetoken" type="button" value="<%= UserLabels.RemoveToken %>" />
				</td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.ProfileStatus%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%= UserLabels.ReceiveEmails%></span> </td> <td class="psFormCell"><input id="<%=resource.ReceiveEmails.Name %>" name="<%= resource.ReceiveEmails.Name %>" type="checkbox" <%= resource.ReceiveEmails.Value ? "checked" : string.Empty %> /> </td>
            </tr>
            <tr>
			    <td class="psFormCell"><span><%= BusinessUnitLabels.Language%></span></td>
			    <td class="psFormCell">
			        <select id="Language.ID" class="styled">
		                <option value="" ></option>
		                <% foreach (Language item in _languageRepository.GetAllLanguages())
                     {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Language.Value && item.ID == resource.Language.Value.ID.Value) %>><%= item.Name%></option>
		                <% } %>
	                </select>
			    </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.Description%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><textarea class="psTextarea expand25-350 resizable" id="<%=resource.Description.Name%>"><%=resource.Description%></textarea></p></td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colSpan="5">
					<span><%= UserLabels.UserAssignedIncidents %></span>
				</td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
			    <td id="AssignedIncidentsURL" class="psFormCell" colspan="4">
			       
				</td>
            </tr>
       </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>
        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.User);
		    POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");		    
            POLAR.View.Page.teamsDataTable = POLAR.View.Page.loadTeamsDataTable();

            var button = new YAHOO.widget.Button("generatetoken");
            button.on("click", function() {
				$("#Token").attr("value", POLAR.View.Page.createUUID());
            });

            var removeTokenButton = new YAHOO.widget.Button("removetoken");
            removeTokenButton.on("click", function() {
				$("#Token").attr("value", '');
            });

            var url = UserResourcePermissions.VirtualUrl + '/incidents?user=' + resource.ID;
            $("#AssignedIncidentsURL").append("<a href=" + url + ">" + url + "</a>");
            
            
		};

		POLAR.View.Page.createUUID = function() {
			// http://www.ietf.org/rfc/rfc4122.txt
			var s = [];
			var hexDigits = "0123456789ABCDEF";
			for (var i = 0; i < 32; i++) {
				s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
			}
			s[12] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
			s[16] = hexDigits.substr((s[16] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01

			var uuid = s.join("");
			return uuid;
		}

		POLAR.View.Page.loadTeamsDataTable = function() {
			var dataSource = new YAHOO.util.DataSource(resource);
			dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

			dataSource.responseSchema =
			{
			    resultsList: '<%= resource.Teams.Name %>',
			    fields:
			    [
				    { key: '<%= TeamResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber },
				    '<%= TeamResource.Meta.Name.Name %>',
				    '<%= TeamResource.Meta.URL.Name %>'
			    ]
            };

			var columnDefinitions =
			[
				{ key: '<%= TeamResource.Meta.ID.Name %>', sortable: true, className: "colwidth2", label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				{ key: '<%= TeamResource.Meta.Name.Name %>', sortable: true, className: "colwidth2", label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl }
		    ];

            var configs = {
    		      draggableColumns:true
        	};

			var element = YAHOO.util.Dom.get('Teams');
			dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource, configs );
			POLAR.View.setContainedObject(element, dataTable);

			POLAR.View.setDataTableRowReader(element, function(recordData){
			    var data = new Object();
			    data['<%= TeamResource.Meta.ID.Name %>'] = recordData['<%= TeamResource.Meta.ID.Name %>'];
			    return data;
			});

			$("#Teams table colgroup col:lt(1)").css('width', '10px');
			
			return dataTable;
		};

        YAHOO.util.Event.addListener(window, 'load', showTables);
        function showTables() {
            if(resource.IncidentsItems != null){
                var dataSource = new YAHOO.util.DataSource(resource.IncidentsItems);
                showTable1(dataSource, '_dataTableContainer1');
            }
            if(resource.AssignedIncidentsItems != null){
                var dataSource = new YAHOO.util.DataSource(resource.AssignedIncidentsItems);
                showTable1(dataSource, '_dataTableContainer2');
            }
        }

        function showTable1(dataSource, dataTableContainer) {
		    dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

            var myFormatDate = function(elCell, oRecord, oColumn, oDate) {
	            elCell.innerHTML = 1 + oDate.getMonth() + "/" + oDate.getDate()  + "/" + oDate.getFullYear() + " " + oDate.getHours() + ":" + oDate.getMinutes();
	           };

		    this.formatUrlUser = function(elCell, oRecord, oColumn, sData) {
			    elCell.innerHTML = '<a href=' + oRecord.getData('Contact.URL') + '>' + sData + '</a>';
		    };

		    dataSource.responseSchema = {
		        fields: [
			        {key:'<%= IncidentResource.Meta.ID.Name %>', parser:YAHOO.util.DataSource.parseNumber},
			        '<%= IncidentResource.Meta.Title.Name %>',
			        '<%= IncidentResource.Meta.URL.Name %>',
			        'Contact.UserName','Contact', 'Contact.URL', 'User.UserName', 'Status.Name', 'Priority.Name',
			        {key:'ModifiedOn', parser:YAHOO.util.DataSource.parseDate}]};
            var configs = {
                sortedBy:{key:'ModifiedOn', dir:YAHOO.widget.DataTable.CLASS_DESC},
		        draggableColumns:true
        	};
		    var columnDefinitions = [
			    {key:'<%= IncidentResource.Meta.ID.Name %>', width:20, label:'<%= CommonLabels.ID %>', sortable:true, formatter:'number', sortOptions:{defaultOrder:'desc'}, resizeable:true},
			    { key: '<%= IncidentResource.Meta.Title.Name %>', label: '<%= CommonLabels.Title %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
 			    { key: 'Contact.UserName', label: '<%= IncidentLabels.Contact %>', sortable: true, resizeable: true, formatter: this.formatUrlUser },
		        { key: 'User.UserName', label: '<%= IncidentLabels.User %>', sortable: true, resizeable: true },
		        {key:'Status.Name', label:'<%= IncidentLabels.IncidentStatus %>', sortable:true, resizeable:true},
		        {key:'Priority.Name', label:'<%= IncidentLabels.IncidentPriority %>', sortable:true, resizeable:true},
		        {key:'ModifiedOn', label:'<%= CommonLabels.ModifiedOn %>', sortable:true, sortOptions:{defaultDir:YAHOO.widget.DataTable.CLASS_DESC}, formatter:myFormatDate}];

		   dataTable = new YAHOO.widget.DataTable(dataTableContainer, columnDefinitions, dataSource, configs);
	    }
    </script>

    <script runat="server">
        public readonly CountryRegionRepository _countryRegionRepository = IoC.Container.Resolve<CountryRegionRepository>();
        public readonly LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();
        public readonly UserRepository _userRepository = IoC.Container.Resolve<UserRepository>();
        public readonly CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        UserResource resource;
        string _jsonResRep;
        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as UserResource;
        }
    </script>

</body>
</html>
