<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Newtonsoft.Json.Converters"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="text-align:left">
                    <div>
                        <%
						    if (0 == resource.ID.Value)
						    {
							    %>
							    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
							    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" /><%
						    }
						    else
						    {
							    if (_userTemplateRepository.GetByID((long)resource.ID.Value).Deleted)
							    {
								    %><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
							    }
							    else
							    {
								    %>
									    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
									    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
								    <%
							    }
						    }
					    %>
					    <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                    </div>

                </td>
                <td style="text-align:right" >
                    <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
                </td>
	        <tr>
	    </tbody>
    </table>
    </div>    
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
			    <td colspan="3">
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%=UserLabels.UserName%></span>
                    <span id="<%=resource.UserName.Name + "error"%>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.UserName.Name%>" class="psTextbox" type="text" value="<%=resource.UserName%>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%=UserLabels.Title%></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%=resource.Title.Name%>" class="psTextbox" type="text" value="<%=resource.Title%>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">   <span><%=UserLabels.UserFirstName%></span> <span id="<%=resource.FirstName.Name + "error"%>"></span> </td>
                <td class="psFormCell"><input id="<%=resource.FirstName.Name%>" size="50" class="psTextbox"  type="text" value="<%=resource.FirstName%>" /> </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%=UserLabels.WebPage%>
			    </td>
			    <td class="psFormCell">
			        <input id="<%=resource.WebPage.Name%>" class="psTextbox" type="text" value="<%=resource.WebPage%>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%=UserLabels.UserLastName%></span>
                    <span id="<%=resource.LastName.Name + "error"%>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.LastName.Name%>" class="psTextbox" type="text" value="<%=resource.LastName%>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%=UserLabels.Email%>
			    </td>
			    <td class="psFormCell"></span>
			        <input id="<%=resource.Email.Name%>" class="psTextbox" type="text" value="<%=resource.Email%>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%=UserLabels.Password%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.Password.Name%>" class="psTextbox" type="password" value="<%=resource.Password%>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			    </td>
			    <td class="psFormCell">
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="2"><%=UserLabels.Telephones%></td>
				<td class="psFormMid"></td>
			    <td class="psFormCell psBar" colSpan="2"><%=UserLabels.Address%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                    <span><%=UserLabels.TelephoneNumber%></span>
                </td>
                <td class="psFormCell"></span>
                    <input id="<%=resource.TelephoneNumber.Name%>" class="psTextbox" type="text" value="<%=resource.TelephoneNumber%>" />
                </td>
				<td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%=UserLabels.Street%></td>
			    <td class="psFormCell"></span>
			        <input id="<%=resource.Street.Name%>" class="psTextbox" type="text" value="<%=resource.Street%>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%=UserLabels.TelephoneHome%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.TelephoneHome.Name%>" class="psTextbox" type="text" value="<%=resource.TelephoneHome %>" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%=UserLabels.City%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.City.Name%>" class="psTextbox"  type="text" value="<%=resource.City%>" />
                </td>
            <tr>
            </tr>
                <td class="psFormCell">
                    <span><%=UserLabels.TelephoneMobile%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.TelephoneMobile.Name%>" class="psTextbox" type="text" value="<%=resource.TelephoneMobile%>" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%=UserLabels.StateProvince%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.StateProvince.Name%>" class="psTextbox" type="text" value="<%=resource.StateProvince %>" />
                </td>
            <tr>
            </tr>
                <td class="psFormCell">
                    <span><%=UserLabels.TelephonePage%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.TelephonePage.Name%>" class="psTextbox" type="text" value="<%=resource.TelephonePage  %>" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%=UserLabels.ZipPostalCode%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%=resource.ZipPostalCode.Name%>" class="psTextbox"  type="text" value="<%=resource.ZipPostalCode  %>" />
                </td>
            <tr>
            <tr>
			    <td class="psFormCell"><span><%=UserLabels.TelephoneFax%></td><td class="psFormCell"></span>  <input id="<%=resource.TelephoneFax.Name%>" class="psTextbox"  type="text" value="<%=resource.TelephoneFax   %>" />      </td>
				<td class="psFormMid"></td>
			    <td class="psFormCell"><span><%= CommonLabels.CountryRegion%></span></td>
			    <td class="psFormCell">
			        <select id="CountryRegion.ID" class="styled">
		                <option value=""></option>
		                <%
		                    foreach (CountryRegion item in _countryRegionRepository.GetAll())
                            {
                                %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CountryRegion.Value && item.ID == resource.CountryRegion.Value.ID.Value) %>><%= item.Name%></option><%
                            }
                        %>
	                </select>
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=CommonLabels.Team%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell"><%= AdminRoleLabels.AddTeam %></td>
                <td class="psFormCell" colspan="4">
                    <div id="teamLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="Teams" class="yui-skin-sam"></div></td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.ProfileStatus%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
                <td class="psFormMid"></td>
                <td class="psFormCell"><span><%= UserLabels.ReceiveEmails%></span> </td> <td class="psFormCell"><input id="<%=resource.ReceiveEmails.Name %>" name="<%= resource.ReceiveEmails.Name %>" type="checkbox" <%= resource.ReceiveEmails.Value ? "checked" : string.Empty %> /> </td>
            </tr>
            <tr>
			    <td class="psFormCell"><span><%= BusinessUnitLabels.Language%></span></td>
			    <td class="psFormCell">
			        <select id="Language.ID" class="styled">
		                <option value="" ></option>
		                <% foreach (Language item in _languageRepository.GetAllLanguages())
                     {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Language.Value && item.ID == resource.Language.Value.ID.Value) %>><%= item.Name%></option>
		                <% } %>
	                </select>
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.Description%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><textarea class="psTextarea expand25-350 resizable" id="<%=resource.Description.Name%>" ><%=resource.Description%></textarea></p></td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.IncidentsContact%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
			    <td class="psFormCell" colspan="4"><div id="_dataTableContainer1" class="yui-skin-sam"></div></td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colSpan="5"><span><%=UserLabels.UserAssignedIncidents%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
			    <td class="psFormCell" colspan="4"><div id="_dataTableContainer2" class="yui-skin-sam"></div></td>
            </tr>

       </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>
        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
    		POLAR.View.setTitleAndResourceName(resource.LabelsCommon.UserTemplate);
    		POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");

		    autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
		        id: 'teamLookup',
		        url: '<%= UrlHelper.GetUrl("/api/teams") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
		        propertyName: "Team",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "City", "PostalCode", "Email", 'URL', 'AssignableTeam'],
		            columnDefinitions: [
                                    { key: 'Add', formatter: 'customContact' },
	                                { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                    { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                    { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                    { key: 'AssignableTeam', label: 'AssignableTeam', sortable: true, resizeable: true }
                                ]
		        },
		        dataTableData: {
		            resourceName: "Teams",
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL', 'AssignableTeam', { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate}],
		            columnDefinitions: [
				                    { key: '' },
				                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                    { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                                    { key: 'Email', label: 'Email', sortable: true, resizeable: true },
                                    { key: 'AssignableTeam', label: 'AssignableTeam', sortable: true, resizeable: true },
                                    { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
				                ]
		        }
		    });
		};       
    </script>
    
    <script runat="server">
        CountryRegionRepository _countryRegionRepository = IoC.Container.Resolve<CountryRegionRepository>();
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();
		UserTemplateRepository _userTemplateRepository = IoC.Container.Resolve<UserTemplateRepository>();
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();

        UserTemplateResource resource;
        string _jsonResRep;

        bool editMod = true;
        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as UserTemplateResource;

            /*
            errorMessageAsJson = PageHelper.FormatErrorInJson(PageHelper.VerifyAuthorizationForResource(), null, null);

            try
            {
                // get resource or show error
                //resource = UserTemplateResourceHandler.GetResource();
                UserTemplateResourceHandler resourceHandler = new UserTemplateResourceHandler();
                resource = (UserTemplateResource)resourceHandler.GetResource();
                if (null == resource)
                {
                    resource = new UserTemplateResource();
                    RequestedResource requestedResource = IoC.Container.Resolve<RequestedResource>();
                    string err = "";
                    if (requestedResource.IsResourceType(typeof(UserTemplateByIdResourceURI)))
                        err = ErrorPagesLabels.UserTemplateNotFoundOrDeleted.ToString();
                    else if (requestedResource.IsResourceType(typeof(UserTemplateByIdDeletedResourceURI)))
                        err = ErrorPagesLabels.UserTemplateNotFoundOrUnDeleted.ToString();
                    errorMessageAsJson = PageHelper.FormatErrorInJson(err, null, errorMessageAsJson);
                }
            }
            catch (Exception exc)
            {
                resource = new UserTemplateResource();
                errorMessageAsJson = PageHelper.FormatErrorInJson(ErrorPagesLabels.UnableToShowPage.ToString() + exc.Message, exc.StackTrace, errorMessageAsJson);
            }

            _jsonResRep = JsonConvert.SerializeObject(resource);
            */
        }
    </script>
</body>
</html>
