<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.Infrastructure.ResourceHandlers"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell">
                    <span><%= WorkOrderHistoryLabels.WorkOrderTitle %></span>
                </td>
                <td class="psFormCell" colspan="4">
                    <input id="<%= resource.Title.Name %>" class="psTextbox" type="text" value="<%= resource.Title %>" readonly="readonly" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= WorkOrderHistoryLabels.AssignToServiceUser %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.User.Name %>" class="psTextbox" type="text" value="<%= resource.User.Value.Name.Value %>" readonly="readonly" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= WorkOrderHistoryLabels.AssignToBusinessUnit %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.AssigneeTeam.Name %>" class="psTextbox" type="text" value="<%= resource.AssigneeTeam.Value.Name %>" readonly="readonly"  />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= WorkOrderHistoryLabels.Contact %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Contact.Name %>" class="psTextbox" type="text" value="<%= resource.Contact.Value.Name.Value %>" readonly="readonly" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= WorkOrderHistoryLabels.Account %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Account.Name %>" class="psTextbox" type="text" value="<%= resource.Account.Value.Name %>" readonly="readonly"  />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= CommonLabels.Status %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Status.Name %>" class="psTextbox" type="text" value="<%= resource.Status.Value.Name.Value %>" readonly="readonly" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= CommonLabels.Deadline %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Deadline.Name %>" class="psTextbox" type="text" value="<%= resource.Deadline.Value %>" readonly="readonly"  />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= CommonLabels.Priority %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Priority.Name %>" class="psTextbox" type="text" value="<%= resource.Priority.Value.Name.Value %>" readonly="readonly" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= WorkOrderHistoryLabels.AttachedIncident %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.AttachedIncident.Name %>" class="psTextbox" type="text" value="<%= resource.AttachedIncident.Value.ID.Value %>" readonly="readonly"  />
                </td>
            </tr>

            <tr>
                <td class="psFormCell">
			        <span><%= WorkOrderHistoryLabels.CreatedOn%></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.CreatedOn.Name %>" class="psTextbox" type="text" value="" readonly="readonly" />
			    </td>
	            <td class="psFormMid"></td>
                <td class="psFormCell">
			        <span><%= WorkOrderHistoryLabels.CreatedBy%></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.CreatedBy.Name %>" class="psTextbox" type="text" value="<%= resource.CreatedBy.Value.Name %>" readonly="readonly" />
			    </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Attachments %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <%
                        foreach (var item in resource.Attachments.Value)
     	                {
     	                    %><a href="<%= item.URI %>"><%= item.Name %></a>, <%
     	                }
                    %>                    
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Description %></td>
            </tr>            
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>" readonly="readonly"><%= resource.Description %></textarea>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= CommonLabels.Note %>:</td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr id="note">
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>" readonly="readonly"><%= resource.Note.Value%></textarea>
                </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
	<script type="text/javascript">
		var resource = <%= _jsonResRep %>
	</script>
    <polar:Includes runat="server" />
    <script type="text/javascript">
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		POLAR.View.setTitleAndResourceName(resource.LabelsCommon.WorkOrderHistory);
		    $("#<%= resource.CreatedOn.Name %>").get(0).value = POLAR.View.DateTime.dateToString(POLAR.View.DateTime.stringToDate(resource.CreatedOn));
		}
    </script>

    <script runat="server">
	    WorkOrderHistoryResource resource;
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            resource = resourceHandlerResult.EntityResoruceRepresentation as WorkOrderHistoryResource;
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        }

    </script>
</body>
</html>
