<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title><%= WorkOrderLabels.WorkOrders %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div id="filter">
        <input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />		
		<span><%= CommonLabels.MaximumResults %></span>
		<select id="maxResults" class="styled smallwidth">
            <option value="0"></option>
            <option value="10" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "10") %>>10</option>
			<option value="50" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "50") %>>50</option>
			<option value="100" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "100") %>>100</option>
			<option value="200" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "200") %>>200</option>
			<option value="500" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "500") %>>500</option>
			<option value="1000" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "1000") %>>1000</option>
	    </select>

	    <span><%= CommonLabels.View %></span>
		<select class="ps-filter-views styled middlewidth">
			<%
        		bool match = false;
        		string relativeUrl = PageHelper.GetRelativeURL();
				if (resource != null && resource.Views.Value != null)
                {
				    foreach (FilterResourceFragment item in resource.Views.Value)
        		    {
        			    if (!match)
        			    {
						    match = string.Compare(item.Value.Value, relativeUrl, true) == 0;
        			    }

					    %><option value="<%= HtmlTagConverter.HtmlEncode(item.Value.Value) %>"<%= HtmlHelper.OptionSelect(item.Value.Value == relativeUrl) %>><%= item.Name.Value %></option><%
        		    }

        		    if (!match)
        		    {
					    %><option value="0" selected="selected"><%= CommonLabels.Custom %></option><%
        		    }
                }
			%>
		</select>
		<a class="ps-filter-showadvancedview" href="">
			<%= CommonLabels.AdvancedView %>
		</a>
		<div class="ps-filter-advancedview" style="display: none">
				<table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
				<colgroup>
					<col class="psColon1">
					<col>
					<col class="psColMid">
					<col class="psColon3">
					<col>
    			</colgroup>
				<tbody>
				<tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%= CommonLabels.AdvancedView %></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell"><%= CommonLabels.Status %></td>
					<td class="psFormCell">
						<select id="Status.ID"  class="styled middlewidth" >
							<option value=""></option>
							<%
        						foreach (WorkOrderStatus item in _workOrderStatusRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=CommonLabels.Priority%></span></td>
					<td class="psFormCell">
						<select id="Priority.ID"  class="styled middlewidth" >
							<option value=""></option>
							<%
        						foreach (Priority item in Enum.GetValues((typeof (Priority))))
        						{
									%><option value="<%=(long)item%>"><%=PriorityLabels.GetLabel(item)%></option><%
        						}
							%>
						</select>
					</td>
				</tr>
				<tr>
					<td class="psFormCell"><span><%=CommonLabels.Team%></span></td>
					<td class="psFormCell">
						<div id="teamLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr>
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="teamLink" href=""></a>
						            </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show"></button>
								    </td>
							    </tr>
						    </table>
						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=CommonLabels.User%></span></td>
					<td class="psFormCell">
						<div id="userLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="userLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show"></button>
								    </td>
							    </tr>
						    </table>
						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
				</tr>
				<tr>
					<td class="psFormCell"><span><%=CommonLabels.Account%></span></td>
					<td class="psFormCell">
						<div id="accountLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr >
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="accountLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show"></button>
								    </td>
							    </tr>
						    </table>

						    <div class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
					    </div>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell"><span><%=CommonLabels.Contact%></span>
					<td class="psFormCell">
						<div id="contactLookup">
						    <table border="0" cellpadding="0" cellspacing="0" >
							    <tr>
								    <td class="acbox">
									    <div class="pl-autocomplete">
									        <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										    <div class="pl-autocomplete-container" ></div>
									    </div>
									    <a id="contactLink" href=""></a>
						               </td>
								    <td class="lookupbtn">
									    <button class="lookup pl-lookup-panel-show"></button>
								    </td>
							    </tr>
						    </table>
						    <div  class="resizablepanel pl-lookup-panel">							    
							    <div class="bd">
								    <div class="yui-skin-sam pl-lookup-datatable"></div>
							    </div>
							    <div class="ft"></div>
						    </div>
                        </div>
					</td>
				</tr>

				<tr>
					<td class="psFormCell"></td>
					<td class="psFormCell"></td>
					<td class="psFormMid"></td>
                    <td class="psFormCell"><%= CommonLabels.Category%></td>
					<td class="psFormCell">
						<select id="Category.ID" class="styled middlewidth" >
							<option value=""></option>
							<%
                                foreach (Category item in _categoryRepository.GetAll())
        						{
									%><option value="<%=item.ID%>"><%=item.Name%></option><%
        						}
							%>
						</select>
					</td>
				</tr>
				
				<tr>
					<td class="psFormCell psBar" colSpan="5">
						<span><%=CommonLabels.SaveView%></span>
					</td>
				</tr>
				<tr class="psAfterBar" ><td></td></tr>
				<tr>
					<td class="psFormCell psLabelRequire"><%= CommonLabels.NewViewName %></td>
					<td class="psFormCell">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td class="psFormCell">
									<input id="viewNameTextBox" type="text" class="ps-filter-filtername textboxMiddle" />
								</td>
								<td class="psFormCell">
									&nbsp;<input id="saveViewButton" class="ps-filter-savebutton" type="button" value="<%= CommonLabels.SaveButton %>" />
								</td>
							</tr>
						</table>
					</td>
					<td class="psFormMid"></td>
					<td class="psFormCell">
						<span><%= CommonLabels.PublicView %></span>
					</td>
					<td class="psFormCell">
						<input id="publicViewCheckBox" class="ps-filter-publiccheckbox" type="checkbox" />
					</td>
				</tr>
				</tbody>
			</table>
		</div>
	</div>
    <div class="desktopTable">
        <div class="desktopTableActions">
            <%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" autocomplete="off" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%><input id="deleteButton" type="button" autocomplete="off" value="<%= CommonLabels.DeleteButton %>" /><%
				}
			%>
			<input id="buttonExport" type="button" value="<%= CommonLabels.Export %>" />
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep %>;
    </script>
    <polar:Includes runat="server" />
	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function		
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
			POLAR.View.setTitleAndResourceName(resource.LabelsCommon.WorkOrders);
            autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
                id: 'contactLookup',
                url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
                linkID: "contactLink",
                propertyName: "Contact",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                            { key: 'Add', formatter: 'customContact' },
	                        { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                            { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                            { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                        ]
                }                
            });

            autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
                id: 'teamLookup',
                url: '<%= UrlHelper.GetUrl("/api/teams") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
                linkID: "teamLink",
                propertyName: "Team",
                resourceHolder: resource,
                autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&assignableteam=true&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            });

            autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
                id: 'userLookup',
                url: '<%= UrlHelper.GetUrl("/api/users") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
                linkID: "userLink",
                propertyName: "User",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
                }
            });

            autoCompleteLookupAccount = new POLAR.Widget.AutoCompleteLookup({
                id: 'accountLookup',
                url: '<%= UrlHelper.GetUrl("/api/accounts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/account/") %>',
                linkID: "accountLink",
                propertyName: "Account",
                resourceHolder: resource,
                autoCompleteData: { schema: ['Name', 'Email', 'ID'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                                        { key: 'Add', formatter: 'customContact' },
	                                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },                                        
                                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                                    ]
                }
            });
            
            POLAR.View.Page.initializeGrid();

            var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
                args: [
                    { id: 'maxResults', urlValueName: 'maxresults', type: 'select' },
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },                    
                    { urlValueName: 'status' },
                    { urlValueName: 'priority' },
                    { urlValueName: 'category' },
                    { urlValueName: 'user' },
                    { urlValueName: 'team' },
                    { urlValueName: 'contact' },
                    { urlValueName: 'account' }
                ],
                onGetArguments: function(args) {
                    if (!YAHOO.lang.isUndefined(resource.Contact) && !YAHOO.lang.isNull(resource.Contact)) {
                        args['contact'] = resource.Contact.ID;
                    }
                    if (!YAHOO.lang.isUndefined(resource.User) && !YAHOO.lang.isNull(resource.User)) {
                        args['user'] = resource.User.ID;
                    }
                    if (!YAHOO.lang.isUndefined(resource.Account) && !YAHOO.lang.isNull(resource.Account)) {
                        args['account'] = resource.Account.ID;
                    }
                    if (!YAHOO.lang.isUndefined(resource.Team) && !YAHOO.lang.isNull(resource.Team)) {
                        args['team'] = resource.Team.ID;
                    }
                    var valStatus = $(POLAR.Util.jqIdFormat("Status.ID")).selectedOptions();
                    if (valStatus[0].value != 0) {
                        args['status'] = valStatus[0].value;
                    }
                    var valPriority = $(POLAR.Util.jqIdFormat("Priority.ID")).selectedOptions();
                    if (valPriority[0].value != 0) {
                        args['priority'] = valPriority[0].value;
                    }
                    var valCategory = $(POLAR.Util.jqIdFormat("Category.ID")).selectedOptions();
                    if (valCategory[0].value != 0) {
                        args['category'] = valCategory[0].value;
                    }
                },
                onSetArguments: function(args) {
                    var contactID = args['contact'];
                    if (!YAHOO.lang.isUndefined(contactID) && !YAHOO.lang.isNull(contactID)) {
                        autoCompleteLookupContact._changeOnLinkedControl(contactID);
                    }
                    var userID = args['user'];
                    if (!YAHOO.lang.isUndefined(userID) && !YAHOO.lang.isNull(userID)) {
                        autoCompleteLookupUser._changeOnLinkedControl(userID);
                    }
                    var accountID = args['account'];
                    if (!YAHOO.lang.isUndefined(accountID) && !YAHOO.lang.isNull(accountID)) {
                        autoCompleteLookupAccount._changeOnLinkedControl(accountID);
                    }
                    var teamID = args['team'];
                    if (!YAHOO.lang.isUndefined(teamID) && !YAHOO.lang.isNull(teamID)) {
                        autoCompleteLookupTeam._changeOnLinkedControl(teamID);
                    }

                    var statusID = args['status'];
                    $(POLAR.Util.jqIdFormat("Status.ID")).selectOptions("" + statusID);

                    var priorityID = args['priority'];
                    $(POLAR.Util.jqIdFormat("Priority.ID")).selectOptions("" + priorityID);

                    var categoryID = args['category'];
                    $(POLAR.Util.jqIdFormat("Category.ID")).selectOptions("" + categoryID);
                }
            });            
        };      


        POLAR.View.Page.initializeGrid = function() {
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
			dataSource.responseSchema = {
	        	resultsList: 'Items',
	        	fields: [
	        	    { key: 'ID', parser: YAHOO.util.DataSource.parseNumber },
	        	    'Title',	        	    
	        	    'URL',
	        	    'Contact.Name',
					'Contact.URL',
					'User.Name',
					'User.URL',
					'Deadline',
					'Team.Name',
					'Team.URL',
					'Account.Name',
					'Account.URL',
					'Status.Name',
		            'Priority.Name',
					{ key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate }
	        	    ]
			};

			var dataTableContainerWidth = $("#dataTableContainer").width();
            dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" autocomplete="off" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
	            { key: 'Title', label: '<%= CommonLabels.Title %>', maxAutoWidth: dataTableContainerWidth / 3, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
	            { key: 'Deadline', label: '<%= CommonLabels.Deadline %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate },
	            { key: 'Contact.Name', label: '<%= CommonLabels.Contact %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatServiceUser },
			    { key: 'User.Name', label: '<%= CommonLabels.User %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatAssignee },
			    { key: 'Team.Name', label: '<%= CommonLabels.Team %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatTeam },
			    { key: 'Account.Name', label: '<%= CommonLabels.Account %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatAccount },			    
			    { key: 'Status.Name', label: '<%= CommonLabels.Status %>', sortable: true, resizeable: true },
			    { key: 'Priority.Name', label: '<%= CommonLabels.Priority %>', sortable: true, resizeable: true },
			    { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', maxAutoWidth: dataTableContainerWidth / 7, sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }	            
	        ], dataSource, {
			    sortedBy: { key: 'ModifiedOn', dir: YAHOO.widget.DataTable.CLASS_DESC },
	            draggableColumns: true,
		       	paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

			POLAR.View.DataTable.configDataTable(dataTable);

	        POLAR.View.DataTable.configDeleteUndelete({
	        	dataTable: dataTable,
	        	dataTableItems: resource.Items,
	        	dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
	        	dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
	        });

	        //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
	        //set with on first and second colon for beter visula efect
	        $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');
        };
    </script>

    <script runat="server">
        string _jsonResRep;

		WorkOrdersResource resource;
		WorkOrderStatusRepository _workOrderStatusRepository = IoC.Container.Resolve<WorkOrderStatusRepository>();
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();
            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
			ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
			_jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
			resource = resourceHandlerResult.EntityResoruceRepresentation as WorkOrdersResource;
        }
    </script>

</body>
</html>