<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="SupporterRoom.aspx.cs" Inherits="WebChat.SupporterRoom" %>
<%@ Register Src="~/WebChat/Infrastructure/Includes.ascx" TagName="Includes" TagPrefix="uc1" %>
<%@ Register Src="~/WebChat/Infrastructure/ChatRoom.ascx" TagName="ChatRoom" TagPrefix="uc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<title>Polar Web Chat</title>
	<uc1:Includes runat="server" IncludeExt="true" IncludeSoundManager="true"/>
	<script type="text/javascript">
		$(document).ready(function() {	new InitSupporterRoom(); });
	</script>	
</head>

<polar:body ID="supporterRoomWidget" runat="server">
	<form id="mainForm" runat="server">
	    <div class="upmostToolbar">
	        
            <div id="goOnline" class="toolbarButtonEnabled">
                <img src="images/16_startsupport.gif" />
                <div>On</div>
            </div>
            
            <div id="goOffline" class="toolbarButtonDisabled">
                <img src="images/16_stopsupport_disabled.gif"/>
                <div>Off</div>
            </div>
            
            <div id="forwardToIncident" class="toolbarButtonStateless">
                <img id="forwardToIncidentPicture" src="  Assigned by script  "/>
                <div id="forwardToIncidentText">  Assigned by script  </div>
            </div>
            
        </div>

		<div class="chatRoomTemplatePlaceholder" style="display: none">
			<div class='chatRoomContainer'>
				<uc1:ChatRoom runat="server" />
			</div>
		</div>

		<h2 class='noChatsExplanation' style="display: none;">
		    There are no chat requests at this moment. When chat request comes in you will be notified with sound and visual signals.
		</h2>
		<h2 class='offlineExplanation'>
		    You are currently Offline. Please change your status to Online in order to recive chat requests.
		</h2>
		<p class='globalStatus'></p>
		
		<div class="activeChatsContainer">
		</div>
		
		<div class='activeSupporters' style="display: none;">
		    <h2 class='activeSupportersListHeader'>Active supporters</h2>
	        <ul class='activeSupportersList'></ul>
	    </div>

	</form>
</polar:body>
</html>
