


BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
ALTER TABLE dbo.License
	DROP CONSTRAINT DF_Table1_InstalledOn
GO
ALTER TABLE dbo.License
	DROP CONSTRAINT DF_License_Active
GO
CREATE TABLE dbo.Tmp_License
	(
	LicenseID bigint NOT NULL IDENTITY (1, 1),
	UserName nvarchar(100) NOT NULL,
	NamedLicences smallint NOT NULL,
	ConcurentLicences smallint NOT NULL,
	LicenseKey nvarchar(3000) NOT NULL,
	InstalledOn datetime NOT NULL,
	Active bit NOT NULL
	)  ON [PRIMARY]
GO
ALTER TABLE dbo.Tmp_License ADD CONSTRAINT
	DF_Table1_InstalledOn DEFAULT (getdate()) FOR InstalledOn
GO
ALTER TABLE dbo.Tmp_License ADD CONSTRAINT
	DF_License_Active DEFAULT (1) FOR Active
GO
SET IDENTITY_INSERT dbo.Tmp_License ON
GO
IF EXISTS(SELECT * FROM dbo.License)
	 EXEC('INSERT INTO dbo.Tmp_License (LicenseID, UserName, NamedLicences, ConcurentLicences, LicenseKey, InstalledOn, Active)
		SELECT LicenseID, UserName, NamedLicences, ConcurentLicences, LicenseKey, InstalledOn, Active FROM dbo.License TABLOCKX')
GO
SET IDENTITY_INSERT dbo.Tmp_License OFF
GO
DROP TABLE dbo.License
GO
EXECUTE sp_rename N'dbo.Tmp_License', N'License', 'OBJECT'
GO
ALTER TABLE dbo.License ADD CONSTRAINT
	PK_Table1 PRIMARY KEY CLUSTERED 
	(
	LicenseID
	) ON [PRIMARY]

GO
COMMIT


/************************************************************/
/*****                  DatabaseVersion		        *****/
/************************************************************/

UPDATE [dbo].[DatabaseVersion] SET [VersionNumber]='4.0.5.0'

